# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220421

module OCI
  module Adm
    # Module containing models for requests made to, and responses received from,
    # OCI Adm services
    module Models
    end
  end
end

# Require models
require 'oci/adm/models/action_type'
require 'oci/adm/models/application_dependency'
require 'oci/adm/models/application_dependency_recommendation_collection'
require 'oci/adm/models/application_dependency_recommendation_summary'
require 'oci/adm/models/application_dependency_vulnerability_collection'
require 'oci/adm/models/application_dependency_vulnerability_summary'
require 'oci/adm/models/apply_stage'
require 'oci/adm/models/change_knowledge_base_compartment_details'
require 'oci/adm/models/change_remediation_recipe_compartment_details'
require 'oci/adm/models/change_remediation_run_compartment_details'
require 'oci/adm/models/change_vulnerability_audit_compartment_details'
require 'oci/adm/models/create_knowledge_base_details'
require 'oci/adm/models/create_remediation_recipe_details'
require 'oci/adm/models/create_remediation_run_details'
require 'oci/adm/models/create_vulnerability_audit_details'
require 'oci/adm/models/detect_configuration'
require 'oci/adm/models/detect_stage'
require 'oci/adm/models/external_resource_vulnerability_audit_source'
require 'oci/adm/models/external_scm_configuration'
require 'oci/adm/models/git_hub_actions_configuration'
require 'oci/adm/models/git_lab_pipeline_configuration'
require 'oci/adm/models/jenkins_pipeline_configuration'
require 'oci/adm/models/knowledge_base'
require 'oci/adm/models/knowledge_base_collection'
require 'oci/adm/models/knowledge_base_summary'
require 'oci/adm/models/network_configuration'
require 'oci/adm/models/none_verify_configuration'
require 'oci/adm/models/oci_code_repository_configuration'
require 'oci/adm/models/oci_dev_ops_build_configuration'
require 'oci/adm/models/oci_resource_vulnerability_audit_source'
require 'oci/adm/models/operation_status'
require 'oci/adm/models/operation_type'
require 'oci/adm/models/pipeline_properties'
require 'oci/adm/models/pull_request_properties'
require 'oci/adm/models/recommend_stage'
require 'oci/adm/models/remediation_recipe'
require 'oci/adm/models/remediation_recipe_collection'
require 'oci/adm/models/remediation_recipe_summary'
require 'oci/adm/models/remediation_run'
require 'oci/adm/models/remediation_run_collection'
require 'oci/adm/models/remediation_run_stage'
require 'oci/adm/models/remediation_run_stage_collection'
require 'oci/adm/models/remediation_run_stage_summary'
require 'oci/adm/models/remediation_run_stage_type'
require 'oci/adm/models/remediation_run_summary'
require 'oci/adm/models/scm_configuration'
require 'oci/adm/models/sort_order'
require 'oci/adm/models/stage_summary'
require 'oci/adm/models/unknown_source_vulnerability_audit_source'
require 'oci/adm/models/update_knowledge_base_details'
require 'oci/adm/models/update_remediation_recipe_details'
require 'oci/adm/models/update_remediation_run_details'
require 'oci/adm/models/update_vulnerability_audit_details'
require 'oci/adm/models/usage_data_details'
require 'oci/adm/models/usage_data_via_object_storage_tuple_details'
require 'oci/adm/models/verify_configuration'
require 'oci/adm/models/verify_stage'
require 'oci/adm/models/vulnerability'
require 'oci/adm/models/vulnerability_audit'
require 'oci/adm/models/vulnerability_audit_collection'
require 'oci/adm/models/vulnerability_audit_configuration'
require 'oci/adm/models/vulnerability_audit_source'
require 'oci/adm/models/vulnerability_audit_summary'
require 'oci/adm/models/work_request'
require 'oci/adm/models/work_request_error'
require 'oci/adm/models/work_request_error_collection'
require 'oci/adm/models/work_request_log_entry'
require 'oci/adm/models/work_request_log_entry_collection'
require 'oci/adm/models/work_request_resource'
require 'oci/adm/models/work_request_resource_metadata_key'
require 'oci/adm/models/work_request_summary'
require 'oci/adm/models/work_request_summary_collection'

# Require generated clients
require 'oci/adm/application_dependency_management_client'
require 'oci/adm/application_dependency_management_client_composite_operations'

# Require service utilities
require 'oci/adm/util'
