# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220421
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Details to create a new Remediation Recipe.
  class Adm::Models::CreateRemediationRecipeDetails
    # **[Required]** The compartment Oracle Cloud Identifier ([OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm)) of the remediation recipe.
    # @return [String]
    attr_accessor :compartment_id

    # The name of the remediation recipe.
    # @return [String]
    attr_accessor :display_name

    # This attribute is required.
    # @return [OCI::Adm::Models::ScmConfiguration]
    attr_accessor :scm_configuration

    # This attribute is required.
    # @return [OCI::Adm::Models::VerifyConfiguration]
    attr_accessor :verify_configuration

    # This attribute is required.
    # @return [OCI::Adm::Models::DetectConfiguration]
    attr_accessor :detect_configuration

    # This attribute is required.
    # @return [OCI::Adm::Models::NetworkConfiguration]
    attr_accessor :network_configuration

    # **[Required]** The Oracle Cloud Identifier ([OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm)) of the knowledge base.
    # @return [String]
    attr_accessor :knowledge_base_id

    # **[Required]** Boolean indicating if a run should be automatically triggered once the knowledge base is updated.
    # @return [BOOLEAN]
    attr_accessor :is_run_triggered_on_kb_change

    # Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
    # Example: `{\"bar-key\": \"value\"}`
    #
    # @return [Hash<String, String>]
    attr_accessor :freeform_tags

    # Defined tags for this resource. Each key is predefined and scoped to a namespace.
    # Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
    #
    # @return [Hash<String, Hash<String, Object>>]
    attr_accessor :defined_tags

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'compartment_id': :'compartmentId',
        'display_name': :'displayName',
        'scm_configuration': :'scmConfiguration',
        'verify_configuration': :'verifyConfiguration',
        'detect_configuration': :'detectConfiguration',
        'network_configuration': :'networkConfiguration',
        'knowledge_base_id': :'knowledgeBaseId',
        'is_run_triggered_on_kb_change': :'isRunTriggeredOnKbChange',
        'freeform_tags': :'freeformTags',
        'defined_tags': :'definedTags'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'compartment_id': :'String',
        'display_name': :'String',
        'scm_configuration': :'OCI::Adm::Models::ScmConfiguration',
        'verify_configuration': :'OCI::Adm::Models::VerifyConfiguration',
        'detect_configuration': :'OCI::Adm::Models::DetectConfiguration',
        'network_configuration': :'OCI::Adm::Models::NetworkConfiguration',
        'knowledge_base_id': :'String',
        'is_run_triggered_on_kb_change': :'BOOLEAN',
        'freeform_tags': :'Hash<String, String>',
        'defined_tags': :'Hash<String, Hash<String, Object>>'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :compartment_id The value to assign to the {#compartment_id} property
    # @option attributes [String] :display_name The value to assign to the {#display_name} property
    # @option attributes [OCI::Adm::Models::ScmConfiguration] :scm_configuration The value to assign to the {#scm_configuration} property
    # @option attributes [OCI::Adm::Models::VerifyConfiguration] :verify_configuration The value to assign to the {#verify_configuration} property
    # @option attributes [OCI::Adm::Models::DetectConfiguration] :detect_configuration The value to assign to the {#detect_configuration} property
    # @option attributes [OCI::Adm::Models::NetworkConfiguration] :network_configuration The value to assign to the {#network_configuration} property
    # @option attributes [String] :knowledge_base_id The value to assign to the {#knowledge_base_id} property
    # @option attributes [BOOLEAN] :is_run_triggered_on_kb_change The value to assign to the {#is_run_triggered_on_kb_change} property
    # @option attributes [Hash<String, String>] :freeform_tags The value to assign to the {#freeform_tags} property
    # @option attributes [Hash<String, Hash<String, Object>>] :defined_tags The value to assign to the {#defined_tags} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.compartment_id = attributes[:'compartmentId'] if attributes[:'compartmentId']

      raise 'You cannot provide both :compartmentId and :compartment_id' if attributes.key?(:'compartmentId') && attributes.key?(:'compartment_id')

      self.compartment_id = attributes[:'compartment_id'] if attributes[:'compartment_id']

      self.display_name = attributes[:'displayName'] if attributes[:'displayName']

      raise 'You cannot provide both :displayName and :display_name' if attributes.key?(:'displayName') && attributes.key?(:'display_name')

      self.display_name = attributes[:'display_name'] if attributes[:'display_name']

      self.scm_configuration = attributes[:'scmConfiguration'] if attributes[:'scmConfiguration']

      raise 'You cannot provide both :scmConfiguration and :scm_configuration' if attributes.key?(:'scmConfiguration') && attributes.key?(:'scm_configuration')

      self.scm_configuration = attributes[:'scm_configuration'] if attributes[:'scm_configuration']

      self.verify_configuration = attributes[:'verifyConfiguration'] if attributes[:'verifyConfiguration']

      raise 'You cannot provide both :verifyConfiguration and :verify_configuration' if attributes.key?(:'verifyConfiguration') && attributes.key?(:'verify_configuration')

      self.verify_configuration = attributes[:'verify_configuration'] if attributes[:'verify_configuration']

      self.detect_configuration = attributes[:'detectConfiguration'] if attributes[:'detectConfiguration']

      raise 'You cannot provide both :detectConfiguration and :detect_configuration' if attributes.key?(:'detectConfiguration') && attributes.key?(:'detect_configuration')

      self.detect_configuration = attributes[:'detect_configuration'] if attributes[:'detect_configuration']

      self.network_configuration = attributes[:'networkConfiguration'] if attributes[:'networkConfiguration']

      raise 'You cannot provide both :networkConfiguration and :network_configuration' if attributes.key?(:'networkConfiguration') && attributes.key?(:'network_configuration')

      self.network_configuration = attributes[:'network_configuration'] if attributes[:'network_configuration']

      self.knowledge_base_id = attributes[:'knowledgeBaseId'] if attributes[:'knowledgeBaseId']

      raise 'You cannot provide both :knowledgeBaseId and :knowledge_base_id' if attributes.key?(:'knowledgeBaseId') && attributes.key?(:'knowledge_base_id')

      self.knowledge_base_id = attributes[:'knowledge_base_id'] if attributes[:'knowledge_base_id']

      self.is_run_triggered_on_kb_change = attributes[:'isRunTriggeredOnKbChange'] unless attributes[:'isRunTriggeredOnKbChange'].nil?

      raise 'You cannot provide both :isRunTriggeredOnKbChange and :is_run_triggered_on_kb_change' if attributes.key?(:'isRunTriggeredOnKbChange') && attributes.key?(:'is_run_triggered_on_kb_change')

      self.is_run_triggered_on_kb_change = attributes[:'is_run_triggered_on_kb_change'] unless attributes[:'is_run_triggered_on_kb_change'].nil?

      self.freeform_tags = attributes[:'freeformTags'] if attributes[:'freeformTags']

      raise 'You cannot provide both :freeformTags and :freeform_tags' if attributes.key?(:'freeformTags') && attributes.key?(:'freeform_tags')

      self.freeform_tags = attributes[:'freeform_tags'] if attributes[:'freeform_tags']

      self.defined_tags = attributes[:'definedTags'] if attributes[:'definedTags']

      raise 'You cannot provide both :definedTags and :defined_tags' if attributes.key?(:'definedTags') && attributes.key?(:'defined_tags')

      self.defined_tags = attributes[:'defined_tags'] if attributes[:'defined_tags']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        compartment_id == other.compartment_id &&
        display_name == other.display_name &&
        scm_configuration == other.scm_configuration &&
        verify_configuration == other.verify_configuration &&
        detect_configuration == other.detect_configuration &&
        network_configuration == other.network_configuration &&
        knowledge_base_id == other.knowledge_base_id &&
        is_run_triggered_on_kb_change == other.is_run_triggered_on_kb_change &&
        freeform_tags == other.freeform_tags &&
        defined_tags == other.defined_tags
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [compartment_id, display_name, scm_configuration, verify_configuration, detect_configuration, network_configuration, knowledge_base_id, is_run_triggered_on_kb_change, freeform_tags, defined_tags].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
