# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220509
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # The assets disk.
  class CloudBridge::Models::Disk
    # Disk name.
    # @return [String]
    attr_accessor :name

    # Order of boot volumes.
    # @return [Integer]
    attr_accessor :boot_order

    # Disk UUID for the virtual disk, if available.
    # @return [String]
    attr_accessor :uuid

    # Disk UUID LUN for the virtual disk, if available.
    # @return [String]
    attr_accessor :uuid_lun

    # The size of the volume in MBs.
    # @return [Integer]
    attr_accessor :size_in_mbs

    # Location of the boot/data volume.
    # @return [String]
    attr_accessor :location

    # The disk persistent mode.
    # @return [String]
    attr_accessor :persistent_mode

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'name': :'name',
        'boot_order': :'bootOrder',
        'uuid': :'uuid',
        'uuid_lun': :'uuidLun',
        'size_in_mbs': :'sizeInMBs',
        'location': :'location',
        'persistent_mode': :'persistentMode'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'name': :'String',
        'boot_order': :'Integer',
        'uuid': :'String',
        'uuid_lun': :'String',
        'size_in_mbs': :'Integer',
        'location': :'String',
        'persistent_mode': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :name The value to assign to the {#name} property
    # @option attributes [Integer] :boot_order The value to assign to the {#boot_order} property
    # @option attributes [String] :uuid The value to assign to the {#uuid} property
    # @option attributes [String] :uuid_lun The value to assign to the {#uuid_lun} property
    # @option attributes [Integer] :size_in_mbs The value to assign to the {#size_in_mbs} property
    # @option attributes [String] :location The value to assign to the {#location} property
    # @option attributes [String] :persistent_mode The value to assign to the {#persistent_mode} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.name = attributes[:'name'] if attributes[:'name']

      self.boot_order = attributes[:'bootOrder'] if attributes[:'bootOrder']

      raise 'You cannot provide both :bootOrder and :boot_order' if attributes.key?(:'bootOrder') && attributes.key?(:'boot_order')

      self.boot_order = attributes[:'boot_order'] if attributes[:'boot_order']

      self.uuid = attributes[:'uuid'] if attributes[:'uuid']

      self.uuid_lun = attributes[:'uuidLun'] if attributes[:'uuidLun']

      raise 'You cannot provide both :uuidLun and :uuid_lun' if attributes.key?(:'uuidLun') && attributes.key?(:'uuid_lun')

      self.uuid_lun = attributes[:'uuid_lun'] if attributes[:'uuid_lun']

      self.size_in_mbs = attributes[:'sizeInMBs'] if attributes[:'sizeInMBs']

      raise 'You cannot provide both :sizeInMBs and :size_in_mbs' if attributes.key?(:'sizeInMBs') && attributes.key?(:'size_in_mbs')

      self.size_in_mbs = attributes[:'size_in_mbs'] if attributes[:'size_in_mbs']

      self.location = attributes[:'location'] if attributes[:'location']

      self.persistent_mode = attributes[:'persistentMode'] if attributes[:'persistentMode']

      raise 'You cannot provide both :persistentMode and :persistent_mode' if attributes.key?(:'persistentMode') && attributes.key?(:'persistent_mode')

      self.persistent_mode = attributes[:'persistent_mode'] if attributes[:'persistent_mode']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        name == other.name &&
        boot_order == other.boot_order &&
        uuid == other.uuid &&
        uuid_lun == other.uuid_lun &&
        size_in_mbs == other.size_in_mbs &&
        location == other.location &&
        persistent_mode == other.persistent_mode
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [name, boot_order, uuid, uuid_lun, size_in_mbs, location, persistent_mode].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
