# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220919

module OCI
  module CloudMigrations
    # Module containing models for requests made to, and responses received from,
    # OCI CloudMigrations services
    module Models
    end
  end
end

# Require models
require 'oci/cloud_migrations/models/access_level'
require 'oci/cloud_migrations/models/action_type'
require 'oci/cloud_migrations/models/as_is_resource_assessment_strategy'
require 'oci/cloud_migrations/models/asset_source'
require 'oci/cloud_migrations/models/asset_source_collection'
require 'oci/cloud_migrations/models/asset_source_connection'
require 'oci/cloud_migrations/models/asset_source_connection_collection'
require 'oci/cloud_migrations/models/asset_source_connection_lifecycle_state'
require 'oci/cloud_migrations/models/asset_source_connection_type'
require 'oci/cloud_migrations/models/asset_source_credentials'
require 'oci/cloud_migrations/models/asset_source_credentials_type'
require 'oci/cloud_migrations/models/asset_source_lifecycle_state'
require 'oci/cloud_migrations/models/asset_source_summary'
require 'oci/cloud_migrations/models/asset_source_type'
require 'oci/cloud_migrations/models/available_shape_summary'
require 'oci/cloud_migrations/models/available_shapes_collection'
require 'oci/cloud_migrations/models/average_resource_assessment_strategy'
require 'oci/cloud_migrations/models/change_asset_source_compartment_details'
require 'oci/cloud_migrations/models/change_discovery_schedule_compartment_details'
require 'oci/cloud_migrations/models/change_migration_compartment_details'
require 'oci/cloud_migrations/models/change_migration_plan_compartment_details'
require 'oci/cloud_migrations/models/change_replication_schedule_compartment_details'
require 'oci/cloud_migrations/models/compatibility_message'
require 'oci/cloud_migrations/models/compute_cost_estimation'
require 'oci/cloud_migrations/models/cost_estimation'
require 'oci/cloud_migrations/models/create_asset_source_details'
require 'oci/cloud_migrations/models/create_discovery_schedule_details'
require 'oci/cloud_migrations/models/create_migration_asset_details'
require 'oci/cloud_migrations/models/create_migration_details'
require 'oci/cloud_migrations/models/create_migration_plan_details'
require 'oci/cloud_migrations/models/create_replication_schedule_details'
require 'oci/cloud_migrations/models/create_target_asset_details'
require 'oci/cloud_migrations/models/create_vm_target_asset_details'
require 'oci/cloud_migrations/models/create_vm_ware_asset_source_details'
require 'oci/cloud_migrations/models/create_vnic_details'
require 'oci/cloud_migrations/models/discovery_schedule'
require 'oci/cloud_migrations/models/discovery_schedule_collection'
require 'oci/cloud_migrations/models/discovery_schedule_lifecycle_state'
require 'oci/cloud_migrations/models/discovery_schedule_summary'
require 'oci/cloud_migrations/models/hydrated_volume'
require 'oci/cloud_migrations/models/instance_agent_plugin_config_details'
require 'oci/cloud_migrations/models/instance_options'
require 'oci/cloud_migrations/models/instance_source_details'
require 'oci/cloud_migrations/models/instance_source_via_boot_volume_details'
require 'oci/cloud_migrations/models/instance_source_via_image_details'
require 'oci/cloud_migrations/models/launch_instance_agent_config_details'
require 'oci/cloud_migrations/models/launch_instance_details'
require 'oci/cloud_migrations/models/launch_instance_shape_config_details'
require 'oci/cloud_migrations/models/metric_time_window'
require 'oci/cloud_migrations/models/metric_type'
require 'oci/cloud_migrations/models/migration'
require 'oci/cloud_migrations/models/migration_asset'
require 'oci/cloud_migrations/models/migration_asset_collection'
require 'oci/cloud_migrations/models/migration_asset_summary'
require 'oci/cloud_migrations/models/migration_collection'
require 'oci/cloud_migrations/models/migration_plan'
require 'oci/cloud_migrations/models/migration_plan_collection'
require 'oci/cloud_migrations/models/migration_plan_stats'
require 'oci/cloud_migrations/models/migration_plan_summary'
require 'oci/cloud_migrations/models/migration_summary'
require 'oci/cloud_migrations/models/operation_status'
require 'oci/cloud_migrations/models/operation_type'
require 'oci/cloud_migrations/models/os_image_estimation'
require 'oci/cloud_migrations/models/peak_resource_assessment_strategy'
require 'oci/cloud_migrations/models/percentile_resource_assessment_strategy'
require 'oci/cloud_migrations/models/preemptible_instance_config_details'
require 'oci/cloud_migrations/models/preemption_action'
require 'oci/cloud_migrations/models/replication_progress'
require 'oci/cloud_migrations/models/replication_schedule'
require 'oci/cloud_migrations/models/replication_schedule_collection'
require 'oci/cloud_migrations/models/replication_schedule_summary'
require 'oci/cloud_migrations/models/resource_assessment_strategy'
require 'oci/cloud_migrations/models/sort_order'
require 'oci/cloud_migrations/models/storage_cost_estimation'
require 'oci/cloud_migrations/models/target_asset'
require 'oci/cloud_migrations/models/target_asset_collection'
require 'oci/cloud_migrations/models/target_asset_summary'
require 'oci/cloud_migrations/models/target_environment'
require 'oci/cloud_migrations/models/terminate_preemption_action'
require 'oci/cloud_migrations/models/update_asset_source_details'
require 'oci/cloud_migrations/models/update_discovery_schedule_details'
require 'oci/cloud_migrations/models/update_migration_asset_details'
require 'oci/cloud_migrations/models/update_migration_details'
require 'oci/cloud_migrations/models/update_migration_plan_details'
require 'oci/cloud_migrations/models/update_replication_schedule_details'
require 'oci/cloud_migrations/models/update_target_asset_details'
require 'oci/cloud_migrations/models/update_vm_target_asset_details'
require 'oci/cloud_migrations/models/update_vm_ware_asset_source_details'
require 'oci/cloud_migrations/models/vm_target_asset'
require 'oci/cloud_migrations/models/vm_target_asset_summary'
require 'oci/cloud_migrations/models/vm_target_environment'
require 'oci/cloud_migrations/models/vm_ware_asset_source'
require 'oci/cloud_migrations/models/vm_ware_asset_source_summary'
require 'oci/cloud_migrations/models/volume_cost_estimation'
require 'oci/cloud_migrations/models/work_request'
require 'oci/cloud_migrations/models/work_request_error'
require 'oci/cloud_migrations/models/work_request_error_collection'
require 'oci/cloud_migrations/models/work_request_log_entry'
require 'oci/cloud_migrations/models/work_request_log_entry_collection'
require 'oci/cloud_migrations/models/work_request_resource'
require 'oci/cloud_migrations/models/work_request_summary'
require 'oci/cloud_migrations/models/work_request_summary_collection'

# Require generated clients
require 'oci/cloud_migrations/migration_client'
require 'oci/cloud_migrations/migration_client_composite_operations'

# Require service utilities
require 'oci/cloud_migrations/util'
