# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210415

module OCI
  module ContainerInstances
    # Module containing models for requests made to, and responses received from,
    # OCI ContainerInstances services
    module Models
    end
  end
end

# Require models
require 'oci/container_instances/models/action_type'
require 'oci/container_instances/models/basic_image_pull_secret'
require 'oci/container_instances/models/change_container_instance_compartment_details'
require 'oci/container_instances/models/container'
require 'oci/container_instances/models/container_capability'
require 'oci/container_instances/models/container_collection'
require 'oci/container_instances/models/container_command_health_check'
require 'oci/container_instances/models/container_config_file'
require 'oci/container_instances/models/container_config_file_volume'
require 'oci/container_instances/models/container_dns_config'
require 'oci/container_instances/models/container_empty_dir_volume'
require 'oci/container_instances/models/container_health_check'
require 'oci/container_instances/models/container_health_check_failure_action'
require 'oci/container_instances/models/container_health_check_type'
require 'oci/container_instances/models/container_http_health_check'
require 'oci/container_instances/models/container_instance'
require 'oci/container_instances/models/container_instance_collection'
require 'oci/container_instances/models/container_instance_container'
require 'oci/container_instances/models/container_instance_shape_collection'
require 'oci/container_instances/models/container_instance_shape_config'
require 'oci/container_instances/models/container_instance_shape_summary'
require 'oci/container_instances/models/container_instance_summary'
require 'oci/container_instances/models/container_resource_config'
require 'oci/container_instances/models/container_summary'
require 'oci/container_instances/models/container_tcp_health_check'
require 'oci/container_instances/models/container_vnic'
require 'oci/container_instances/models/container_volume'
require 'oci/container_instances/models/container_volume_type'
require 'oci/container_instances/models/create_basic_image_pull_secret_details'
require 'oci/container_instances/models/create_container_command_health_check_details'
require 'oci/container_instances/models/create_container_config_file_volume_details'
require 'oci/container_instances/models/create_container_details'
require 'oci/container_instances/models/create_container_dns_config_details'
require 'oci/container_instances/models/create_container_empty_dir_volume_details'
require 'oci/container_instances/models/create_container_health_check_details'
require 'oci/container_instances/models/create_container_http_health_check_details'
require 'oci/container_instances/models/create_container_instance_details'
require 'oci/container_instances/models/create_container_instance_shape_config_details'
require 'oci/container_instances/models/create_container_resource_config_details'
require 'oci/container_instances/models/create_container_tcp_health_check_details'
require 'oci/container_instances/models/create_container_vnic_details'
require 'oci/container_instances/models/create_container_volume_details'
require 'oci/container_instances/models/create_image_pull_secret_details'
require 'oci/container_instances/models/create_linux_security_context_details'
require 'oci/container_instances/models/create_security_context_details'
require 'oci/container_instances/models/create_vault_image_pull_secret_details'
require 'oci/container_instances/models/create_volume_mount_details'
require 'oci/container_instances/models/health_check_http_header'
require 'oci/container_instances/models/image_pull_secret'
require 'oci/container_instances/models/linux_security_context'
require 'oci/container_instances/models/operation_status'
require 'oci/container_instances/models/operation_type'
require 'oci/container_instances/models/security_context'
require 'oci/container_instances/models/shape_memory_options'
require 'oci/container_instances/models/shape_networking_bandwidth_options'
require 'oci/container_instances/models/shape_ocpu_options'
require 'oci/container_instances/models/sort_order'
require 'oci/container_instances/models/update_container_details'
require 'oci/container_instances/models/update_container_instance_details'
require 'oci/container_instances/models/vault_image_pull_secret'
require 'oci/container_instances/models/volume_mount'
require 'oci/container_instances/models/work_request'
require 'oci/container_instances/models/work_request_error'
require 'oci/container_instances/models/work_request_error_collection'
require 'oci/container_instances/models/work_request_log_entry'
require 'oci/container_instances/models/work_request_log_entry_collection'
require 'oci/container_instances/models/work_request_resource'
require 'oci/container_instances/models/work_request_summary'
require 'oci/container_instances/models/work_request_summary_collection'

# Require generated clients
require 'oci/container_instances/container_instance_client'
require 'oci/container_instances/container_instance_client_composite_operations'

# Require service utilities
require 'oci/container_instances/util'
