# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20160918
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Parameters for converting Refreshable Clone Pluggable Database into Regular Pluggable Database.
  #
  class Database::Models::ConvertToRegularPluggableDatabaseDetails
    # Indicates whether to take Pluggable Database Backup after the operation.
    # @return [BOOLEAN]
    attr_accessor :should_create_pdb_backup

    # The DB system administrator password of the Container Database.
    # @return [String]
    attr_accessor :container_database_admin_password

    # The existing TDE wallet password of the Container Database.
    # @return [String]
    attr_accessor :tde_wallet_password

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'should_create_pdb_backup': :'shouldCreatePdbBackup',
        'container_database_admin_password': :'containerDatabaseAdminPassword',
        'tde_wallet_password': :'tdeWalletPassword'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'should_create_pdb_backup': :'BOOLEAN',
        'container_database_admin_password': :'String',
        'tde_wallet_password': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [BOOLEAN] :should_create_pdb_backup The value to assign to the {#should_create_pdb_backup} property
    # @option attributes [String] :container_database_admin_password The value to assign to the {#container_database_admin_password} property
    # @option attributes [String] :tde_wallet_password The value to assign to the {#tde_wallet_password} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.should_create_pdb_backup = attributes[:'shouldCreatePdbBackup'] unless attributes[:'shouldCreatePdbBackup'].nil?

      raise 'You cannot provide both :shouldCreatePdbBackup and :should_create_pdb_backup' if attributes.key?(:'shouldCreatePdbBackup') && attributes.key?(:'should_create_pdb_backup')

      self.should_create_pdb_backup = attributes[:'should_create_pdb_backup'] unless attributes[:'should_create_pdb_backup'].nil?

      self.container_database_admin_password = attributes[:'containerDatabaseAdminPassword'] if attributes[:'containerDatabaseAdminPassword']

      raise 'You cannot provide both :containerDatabaseAdminPassword and :container_database_admin_password' if attributes.key?(:'containerDatabaseAdminPassword') && attributes.key?(:'container_database_admin_password')

      self.container_database_admin_password = attributes[:'container_database_admin_password'] if attributes[:'container_database_admin_password']

      self.tde_wallet_password = attributes[:'tdeWalletPassword'] if attributes[:'tdeWalletPassword']

      raise 'You cannot provide both :tdeWalletPassword and :tde_wallet_password' if attributes.key?(:'tdeWalletPassword') && attributes.key?(:'tde_wallet_password')

      self.tde_wallet_password = attributes[:'tde_wallet_password'] if attributes[:'tde_wallet_password']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        should_create_pdb_backup == other.should_create_pdb_backup &&
        container_database_admin_password == other.container_database_admin_password &&
        tde_wallet_password == other.tde_wallet_password
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [should_create_pdb_backup, container_database_admin_password, tde_wallet_password].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
