# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210929
require 'date'
require 'logger'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Job phase status details.
  #
  class DatabaseMigration::Models::PhaseStatus
    NAME_ENUM = [
      NAME_ODMS_VALIDATE_TGT = 'ODMS_VALIDATE_TGT'.freeze,
      NAME_ODMS_VALIDATE_SRC = 'ODMS_VALIDATE_SRC'.freeze,
      NAME_ODMS_VALIDATE_PREMIGRATION_ADVISOR = 'ODMS_VALIDATE_PREMIGRATION_ADVISOR'.freeze,
      NAME_ODMS_VALIDATE_GG_HUB = 'ODMS_VALIDATE_GG_HUB'.freeze,
      NAME_ODMS_VALIDATE_GG_SERVICE = 'ODMS_VALIDATE_GG_SERVICE'.freeze,
      NAME_ODMS_VALIDATE_DATAPUMP_SETTINGS = 'ODMS_VALIDATE_DATAPUMP_SETTINGS'.freeze,
      NAME_ODMS_VALIDATE_DATAPUMP_SETTINGS_SRC = 'ODMS_VALIDATE_DATAPUMP_SETTINGS_SRC'.freeze,
      NAME_ODMS_VALIDATE_DATAPUMP_SETTINGS_TGT = 'ODMS_VALIDATE_DATAPUMP_SETTINGS_TGT'.freeze,
      NAME_ODMS_VALIDATE_DATAPUMP_SRC = 'ODMS_VALIDATE_DATAPUMP_SRC'.freeze,
      NAME_ODMS_VALIDATE_DATAPUMP_ESTIMATE_SRC = 'ODMS_VALIDATE_DATAPUMP_ESTIMATE_SRC'.freeze,
      NAME_ODMS_INITIALIZE_GGS = 'ODMS_INITIALIZE_GGS'.freeze,
      NAME_ODMS_VALIDATE = 'ODMS_VALIDATE'.freeze,
      NAME_ODMS_PREPARE = 'ODMS_PREPARE'.freeze,
      NAME_ODMS_INITIAL_LOAD_EXPORT = 'ODMS_INITIAL_LOAD_EXPORT'.freeze,
      NAME_ODMS_DATA_UPLOAD = 'ODMS_DATA_UPLOAD'.freeze,
      NAME_ODMS_INITIAL_LOAD_IMPORT = 'ODMS_INITIAL_LOAD_IMPORT'.freeze,
      NAME_ODMS_POST_INITIAL_LOAD = 'ODMS_POST_INITIAL_LOAD'.freeze,
      NAME_ODMS_PREPARE_REPLICATION_TARGET = 'ODMS_PREPARE_REPLICATION_TARGET'.freeze,
      NAME_ODMS_MONITOR_REPLICATION_LAG = 'ODMS_MONITOR_REPLICATION_LAG'.freeze,
      NAME_ODMS_SWITCHOVER = 'ODMS_SWITCHOVER'.freeze,
      NAME_ODMS_CLEANUP = 'ODMS_CLEANUP'.freeze,
      NAME_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    STATUS_ENUM = [
      STATUS_PENDING = 'PENDING'.freeze,
      STATUS_STARTED = 'STARTED'.freeze,
      STATUS_COMPLETED = 'COMPLETED'.freeze,
      STATUS_FAILED = 'FAILED'.freeze,
      STATUS_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    # **[Required]** Phase name
    #
    # @return [String]
    attr_reader :name

    # **[Required]** Phase status
    #
    # @return [String]
    attr_reader :status

    # **[Required]** Duration of the phase in milliseconds
    #
    # @return [Integer]
    attr_accessor :duration_in_ms

    # True if a Pre-Migration Advisor report is available for this phase. False or null if no report is available.
    #
    # @return [BOOLEAN]
    attr_accessor :is_advisor_report_available

    # The text describing the root cause of the reported issue
    #
    # @return [String]
    attr_accessor :issue

    # The text describing the action required to fix the issue
    #
    # @return [String]
    attr_accessor :action

    # Summary of phase status results.
    #
    # @return [Array<OCI::DatabaseMigration::Models::PhaseExtractEntry>]
    attr_accessor :extract

    # @return [OCI::DatabaseMigration::Models::LogLocationBucketDetails]
    attr_accessor :log_location

    # Percent progress of job phase.
    #
    # @return [Integer]
    attr_accessor :progress

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'name': :'name',
        'status': :'status',
        'duration_in_ms': :'durationInMs',
        'is_advisor_report_available': :'isAdvisorReportAvailable',
        'issue': :'issue',
        'action': :'action',
        'extract': :'extract',
        'log_location': :'logLocation',
        'progress': :'progress'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'name': :'String',
        'status': :'String',
        'duration_in_ms': :'Integer',
        'is_advisor_report_available': :'BOOLEAN',
        'issue': :'String',
        'action': :'String',
        'extract': :'Array<OCI::DatabaseMigration::Models::PhaseExtractEntry>',
        'log_location': :'OCI::DatabaseMigration::Models::LogLocationBucketDetails',
        'progress': :'Integer'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :name The value to assign to the {#name} property
    # @option attributes [String] :status The value to assign to the {#status} property
    # @option attributes [Integer] :duration_in_ms The value to assign to the {#duration_in_ms} property
    # @option attributes [BOOLEAN] :is_advisor_report_available The value to assign to the {#is_advisor_report_available} property
    # @option attributes [String] :issue The value to assign to the {#issue} property
    # @option attributes [String] :action The value to assign to the {#action} property
    # @option attributes [Array<OCI::DatabaseMigration::Models::PhaseExtractEntry>] :extract The value to assign to the {#extract} property
    # @option attributes [OCI::DatabaseMigration::Models::LogLocationBucketDetails] :log_location The value to assign to the {#log_location} property
    # @option attributes [Integer] :progress The value to assign to the {#progress} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.name = attributes[:'name'] if attributes[:'name']

      self.status = attributes[:'status'] if attributes[:'status']

      self.duration_in_ms = attributes[:'durationInMs'] if attributes[:'durationInMs']

      raise 'You cannot provide both :durationInMs and :duration_in_ms' if attributes.key?(:'durationInMs') && attributes.key?(:'duration_in_ms')

      self.duration_in_ms = attributes[:'duration_in_ms'] if attributes[:'duration_in_ms']

      self.is_advisor_report_available = attributes[:'isAdvisorReportAvailable'] unless attributes[:'isAdvisorReportAvailable'].nil?

      raise 'You cannot provide both :isAdvisorReportAvailable and :is_advisor_report_available' if attributes.key?(:'isAdvisorReportAvailable') && attributes.key?(:'is_advisor_report_available')

      self.is_advisor_report_available = attributes[:'is_advisor_report_available'] unless attributes[:'is_advisor_report_available'].nil?

      self.issue = attributes[:'issue'] if attributes[:'issue']

      self.action = attributes[:'action'] if attributes[:'action']

      self.extract = attributes[:'extract'] if attributes[:'extract']

      self.log_location = attributes[:'logLocation'] if attributes[:'logLocation']

      raise 'You cannot provide both :logLocation and :log_location' if attributes.key?(:'logLocation') && attributes.key?(:'log_location')

      self.log_location = attributes[:'log_location'] if attributes[:'log_location']

      self.progress = attributes[:'progress'] if attributes[:'progress']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] name Object to be assigned
    def name=(name)
      # rubocop:disable Style/ConditionalAssignment
      if name && !NAME_ENUM.include?(name)
        OCI.logger.debug("Unknown value for 'name' [" + name + "]. Mapping to 'NAME_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @name = NAME_UNKNOWN_ENUM_VALUE
      else
        @name = name
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      # rubocop:disable Style/ConditionalAssignment
      if status && !STATUS_ENUM.include?(status)
        OCI.logger.debug("Unknown value for 'status' [" + status + "]. Mapping to 'STATUS_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @status = STATUS_UNKNOWN_ENUM_VALUE
      else
        @status = status
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        name == other.name &&
        status == other.status &&
        duration_in_ms == other.duration_in_ms &&
        is_advisor_report_available == other.is_advisor_report_available &&
        issue == other.issue &&
        action == other.action &&
        extract == other.extract &&
        log_location == other.log_location &&
        progress == other.progress
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [name, status, duration_in_ms, is_advisor_report_available, issue, action, extract, log_location, progress].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
