# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220125

module OCI
  module DisasterRecovery
    # Module containing models for requests made to, and responses received from,
    # OCI DisasterRecovery services
    module Models
    end
  end
end

# Require models
require 'oci/disaster_recovery/models/action_type'
require 'oci/disaster_recovery/models/associate_dr_protection_group_details'
require 'oci/disaster_recovery/models/block_volume_attachment_details'
require 'oci/disaster_recovery/models/block_volume_mount_details'
require 'oci/disaster_recovery/models/cancel_dr_plan_execution_details'
require 'oci/disaster_recovery/models/change_dr_protection_group_compartment_details'
require 'oci/disaster_recovery/models/compute_instance_movable_file_system_operation'
require 'oci/disaster_recovery/models/compute_instance_movable_vnic_mapping'
require 'oci/disaster_recovery/models/compute_instance_movable_vnic_mapping_details'
require 'oci/disaster_recovery/models/compute_instance_non_movable_block_volume_operation'
require 'oci/disaster_recovery/models/compute_instance_non_movable_file_system_operation'
require 'oci/disaster_recovery/models/compute_instance_vnic_mapping'
require 'oci/disaster_recovery/models/compute_instance_vnic_mapping_details'
require 'oci/disaster_recovery/models/create_block_volume_attachment_details'
require 'oci/disaster_recovery/models/create_block_volume_mount_details'
require 'oci/disaster_recovery/models/create_compute_instance_movable_file_system_operation_details'
require 'oci/disaster_recovery/models/create_compute_instance_non_movable_block_volume_operation_details'
require 'oci/disaster_recovery/models/create_compute_instance_non_movable_file_system_operation_details'
require 'oci/disaster_recovery/models/create_dr_plan_details'
require 'oci/disaster_recovery/models/create_dr_plan_execution_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_autonomous_database_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_compute_instance_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_compute_instance_movable_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_compute_instance_non_movable_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_database_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_file_system_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_load_balancer_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_network_load_balancer_details'
require 'oci/disaster_recovery/models/create_dr_protection_group_member_volume_group_details'
require 'oci/disaster_recovery/models/create_file_system_mount_details'
require 'oci/disaster_recovery/models/create_file_system_unmount_details'
require 'oci/disaster_recovery/models/create_object_storage_log_location_details'
require 'oci/disaster_recovery/models/disassociate_dr_protection_group_default_details'
require 'oci/disaster_recovery/models/disassociate_dr_protection_group_details'
require 'oci/disaster_recovery/models/dr_plan'
require 'oci/disaster_recovery/models/dr_plan_collection'
require 'oci/disaster_recovery/models/dr_plan_execution'
require 'oci/disaster_recovery/models/dr_plan_execution_collection'
require 'oci/disaster_recovery/models/dr_plan_execution_control_details'
require 'oci/disaster_recovery/models/dr_plan_execution_lifecycle_state'
require 'oci/disaster_recovery/models/dr_plan_execution_option_details'
require 'oci/disaster_recovery/models/dr_plan_execution_options'
require 'oci/disaster_recovery/models/dr_plan_execution_summary'
require 'oci/disaster_recovery/models/dr_plan_execution_type'
require 'oci/disaster_recovery/models/dr_plan_group'
require 'oci/disaster_recovery/models/dr_plan_group_execution'
require 'oci/disaster_recovery/models/dr_plan_group_execution_status'
require 'oci/disaster_recovery/models/dr_plan_group_type'
require 'oci/disaster_recovery/models/dr_plan_lifecycle_state'
require 'oci/disaster_recovery/models/dr_plan_step'
require 'oci/disaster_recovery/models/dr_plan_step_error_mode'
require 'oci/disaster_recovery/models/dr_plan_step_execution'
require 'oci/disaster_recovery/models/dr_plan_step_execution_status'
require 'oci/disaster_recovery/models/dr_plan_step_type'
require 'oci/disaster_recovery/models/dr_plan_summary'
require 'oci/disaster_recovery/models/dr_plan_type'
require 'oci/disaster_recovery/models/dr_plan_user_defined_step'
require 'oci/disaster_recovery/models/dr_protection_group'
require 'oci/disaster_recovery/models/dr_protection_group_collection'
require 'oci/disaster_recovery/models/dr_protection_group_lifecycle_state'
require 'oci/disaster_recovery/models/dr_protection_group_lifecycle_sub_state'
require 'oci/disaster_recovery/models/dr_protection_group_member'
require 'oci/disaster_recovery/models/dr_protection_group_member_autonomous_database'
require 'oci/disaster_recovery/models/dr_protection_group_member_compute_instance'
require 'oci/disaster_recovery/models/dr_protection_group_member_compute_instance_movable'
require 'oci/disaster_recovery/models/dr_protection_group_member_compute_instance_non_movable'
require 'oci/disaster_recovery/models/dr_protection_group_member_database'
require 'oci/disaster_recovery/models/dr_protection_group_member_file_system'
require 'oci/disaster_recovery/models/dr_protection_group_member_load_balancer'
require 'oci/disaster_recovery/models/dr_protection_group_member_network_load_balancer'
require 'oci/disaster_recovery/models/dr_protection_group_member_type'
require 'oci/disaster_recovery/models/dr_protection_group_member_volume_group'
require 'oci/disaster_recovery/models/dr_protection_group_role'
require 'oci/disaster_recovery/models/dr_protection_group_summary'
require 'oci/disaster_recovery/models/failover_execution_option_details'
require 'oci/disaster_recovery/models/failover_execution_options'
require 'oci/disaster_recovery/models/failover_precheck_execution_option_details'
require 'oci/disaster_recovery/models/failover_precheck_execution_options'
require 'oci/disaster_recovery/models/file_system_export_mapping'
require 'oci/disaster_recovery/models/file_system_export_mapping_details'
require 'oci/disaster_recovery/models/file_system_mount_details'
require 'oci/disaster_recovery/models/file_system_unmount_details'
require 'oci/disaster_recovery/models/ignore_dr_plan_execution_details'
require 'oci/disaster_recovery/models/invoke_function_precheck_step'
require 'oci/disaster_recovery/models/invoke_function_step'
require 'oci/disaster_recovery/models/load_balancer_backend_set_mapping'
require 'oci/disaster_recovery/models/load_balancer_backend_set_mapping_details'
require 'oci/disaster_recovery/models/local_script_precheck_step'
require 'oci/disaster_recovery/models/network_load_balancer_backend_set_mapping'
require 'oci/disaster_recovery/models/network_load_balancer_backend_set_mapping_details'
require 'oci/disaster_recovery/models/object_storage_log_location'
require 'oci/disaster_recovery/models/object_storage_script_location'
require 'oci/disaster_recovery/models/object_store_script_precheck_step'
require 'oci/disaster_recovery/models/operation_status'
require 'oci/disaster_recovery/models/operation_type'
require 'oci/disaster_recovery/models/pause_dr_plan_execution_details'
require 'oci/disaster_recovery/models/resume_dr_plan_execution_details'
require 'oci/disaster_recovery/models/retry_dr_plan_execution_details'
require 'oci/disaster_recovery/models/run_local_script_user_defined_step'
require 'oci/disaster_recovery/models/run_object_store_script_user_defined_step'
require 'oci/disaster_recovery/models/sort_order'
require 'oci/disaster_recovery/models/start_drill_execution_option_details'
require 'oci/disaster_recovery/models/start_drill_execution_options'
require 'oci/disaster_recovery/models/start_drill_precheck_execution_option_details'
require 'oci/disaster_recovery/models/start_drill_precheck_execution_options'
require 'oci/disaster_recovery/models/stop_drill_execution_option_details'
require 'oci/disaster_recovery/models/stop_drill_execution_options'
require 'oci/disaster_recovery/models/stop_drill_precheck_execution_option_details'
require 'oci/disaster_recovery/models/stop_drill_precheck_execution_options'
require 'oci/disaster_recovery/models/switchover_execution_option_details'
require 'oci/disaster_recovery/models/switchover_execution_options'
require 'oci/disaster_recovery/models/switchover_precheck_execution_option_details'
require 'oci/disaster_recovery/models/switchover_precheck_execution_options'
require 'oci/disaster_recovery/models/update_block_volume_attachment_details'
require 'oci/disaster_recovery/models/update_block_volume_mount_details'
require 'oci/disaster_recovery/models/update_compute_instance_movable_file_system_operation_details'
require 'oci/disaster_recovery/models/update_compute_instance_non_movable_block_volume_operation_details'
require 'oci/disaster_recovery/models/update_compute_instance_non_movable_file_system_operation_details'
require 'oci/disaster_recovery/models/update_dr_plan_details'
require 'oci/disaster_recovery/models/update_dr_plan_execution_details'
require 'oci/disaster_recovery/models/update_dr_plan_group_details'
require 'oci/disaster_recovery/models/update_dr_plan_step_details'
require 'oci/disaster_recovery/models/update_dr_plan_user_defined_step_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_autonomous_database_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_compute_instance_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_compute_instance_movable_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_compute_instance_non_movable_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_database_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_file_system_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_load_balancer_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_network_load_balancer_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_member_volume_group_details'
require 'oci/disaster_recovery/models/update_dr_protection_group_role_details'
require 'oci/disaster_recovery/models/update_file_system_mount_details'
require 'oci/disaster_recovery/models/update_file_system_unmount_details'
require 'oci/disaster_recovery/models/update_invoke_function_precheck_step_details'
require 'oci/disaster_recovery/models/update_invoke_function_user_defined_step_details'
require 'oci/disaster_recovery/models/update_local_script_precheck_step_details'
require 'oci/disaster_recovery/models/update_object_storage_log_location_details'
require 'oci/disaster_recovery/models/update_object_storage_script_location_details'
require 'oci/disaster_recovery/models/update_object_store_script_precheck_step_details'
require 'oci/disaster_recovery/models/update_run_local_script_user_defined_step_details'
require 'oci/disaster_recovery/models/update_run_object_store_script_user_defined_step_details'
require 'oci/disaster_recovery/models/work_request'
require 'oci/disaster_recovery/models/work_request_error'
require 'oci/disaster_recovery/models/work_request_error_collection'
require 'oci/disaster_recovery/models/work_request_log_entry'
require 'oci/disaster_recovery/models/work_request_log_entry_collection'
require 'oci/disaster_recovery/models/work_request_resource'
require 'oci/disaster_recovery/models/work_request_summary'
require 'oci/disaster_recovery/models/work_request_summary_collection'

# Require generated clients
require 'oci/disaster_recovery/disaster_recovery_client'
require 'oci/disaster_recovery/disaster_recovery_client_composite_operations'

# Require service utilities
require 'oci/disaster_recovery/util'
