# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 1.0.017
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # UpdateTransferApplianceDetails model.
  class Dts::Models::UpdateTransferApplianceDetails
    LIFECYCLE_STATE_ENUM = [
      LIFECYCLE_STATE_PREPARING = 'PREPARING'.freeze,
      LIFECYCLE_STATE_FINALIZED = 'FINALIZED'.freeze,
      LIFECYCLE_STATE_RETURN_LABEL_REQUESTED = 'RETURN_LABEL_REQUESTED'.freeze,
      LIFECYCLE_STATE_RETURN_LABEL_GENERATING = 'RETURN_LABEL_GENERATING'.freeze,
      LIFECYCLE_STATE_RETURN_LABEL_AVAILABLE = 'RETURN_LABEL_AVAILABLE'.freeze,
      LIFECYCLE_STATE_DELETED = 'DELETED'.freeze,
      LIFECYCLE_STATE_CUSTOMER_NEVER_RECEIVED = 'CUSTOMER_NEVER_RECEIVED'.freeze,
      LIFECYCLE_STATE_CANCELLED = 'CANCELLED'.freeze
    ].freeze

    # @return [String]
    attr_reader :lifecycle_state

    # @return [OCI::Dts::Models::ShippingAddress]
    attr_accessor :customer_shipping_address

    # Expected return date from customer for the device, time portion should be zero.
    # @return [DateTime]
    attr_accessor :expected_return_date

    # Start time for the window to pickup the device from customer.
    # @return [DateTime]
    attr_accessor :pickup_window_start_time

    # End time for the window to pickup the device from customer.
    # @return [DateTime]
    attr_accessor :pickup_window_end_time

    # Minimum storage capacity of the device, in terabytes. Valid options are 50, 95 and 150.
    # @return [Integer]
    attr_accessor :minimum_storage_capacity_in_terabytes

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'lifecycle_state': :'lifecycleState',
        'customer_shipping_address': :'customerShippingAddress',
        'expected_return_date': :'expectedReturnDate',
        'pickup_window_start_time': :'pickupWindowStartTime',
        'pickup_window_end_time': :'pickupWindowEndTime',
        'minimum_storage_capacity_in_terabytes': :'minimumStorageCapacityInTerabytes'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'lifecycle_state': :'String',
        'customer_shipping_address': :'OCI::Dts::Models::ShippingAddress',
        'expected_return_date': :'DateTime',
        'pickup_window_start_time': :'DateTime',
        'pickup_window_end_time': :'DateTime',
        'minimum_storage_capacity_in_terabytes': :'Integer'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :lifecycle_state The value to assign to the {#lifecycle_state} property
    # @option attributes [OCI::Dts::Models::ShippingAddress] :customer_shipping_address The value to assign to the {#customer_shipping_address} property
    # @option attributes [DateTime] :expected_return_date The value to assign to the {#expected_return_date} property
    # @option attributes [DateTime] :pickup_window_start_time The value to assign to the {#pickup_window_start_time} property
    # @option attributes [DateTime] :pickup_window_end_time The value to assign to the {#pickup_window_end_time} property
    # @option attributes [Integer] :minimum_storage_capacity_in_terabytes The value to assign to the {#minimum_storage_capacity_in_terabytes} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.lifecycle_state = attributes[:'lifecycleState'] if attributes[:'lifecycleState']

      raise 'You cannot provide both :lifecycleState and :lifecycle_state' if attributes.key?(:'lifecycleState') && attributes.key?(:'lifecycle_state')

      self.lifecycle_state = attributes[:'lifecycle_state'] if attributes[:'lifecycle_state']

      self.customer_shipping_address = attributes[:'customerShippingAddress'] if attributes[:'customerShippingAddress']

      raise 'You cannot provide both :customerShippingAddress and :customer_shipping_address' if attributes.key?(:'customerShippingAddress') && attributes.key?(:'customer_shipping_address')

      self.customer_shipping_address = attributes[:'customer_shipping_address'] if attributes[:'customer_shipping_address']

      self.expected_return_date = attributes[:'expectedReturnDate'] if attributes[:'expectedReturnDate']

      raise 'You cannot provide both :expectedReturnDate and :expected_return_date' if attributes.key?(:'expectedReturnDate') && attributes.key?(:'expected_return_date')

      self.expected_return_date = attributes[:'expected_return_date'] if attributes[:'expected_return_date']

      self.pickup_window_start_time = attributes[:'pickupWindowStartTime'] if attributes[:'pickupWindowStartTime']

      raise 'You cannot provide both :pickupWindowStartTime and :pickup_window_start_time' if attributes.key?(:'pickupWindowStartTime') && attributes.key?(:'pickup_window_start_time')

      self.pickup_window_start_time = attributes[:'pickup_window_start_time'] if attributes[:'pickup_window_start_time']

      self.pickup_window_end_time = attributes[:'pickupWindowEndTime'] if attributes[:'pickupWindowEndTime']

      raise 'You cannot provide both :pickupWindowEndTime and :pickup_window_end_time' if attributes.key?(:'pickupWindowEndTime') && attributes.key?(:'pickup_window_end_time')

      self.pickup_window_end_time = attributes[:'pickup_window_end_time'] if attributes[:'pickup_window_end_time']

      self.minimum_storage_capacity_in_terabytes = attributes[:'minimumStorageCapacityInTerabytes'] if attributes[:'minimumStorageCapacityInTerabytes']

      raise 'You cannot provide both :minimumStorageCapacityInTerabytes and :minimum_storage_capacity_in_terabytes' if attributes.key?(:'minimumStorageCapacityInTerabytes') && attributes.key?(:'minimum_storage_capacity_in_terabytes')

      self.minimum_storage_capacity_in_terabytes = attributes[:'minimum_storage_capacity_in_terabytes'] if attributes[:'minimum_storage_capacity_in_terabytes']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] lifecycle_state Object to be assigned
    def lifecycle_state=(lifecycle_state)
      raise "Invalid value for 'lifecycle_state': this must be one of the values in LIFECYCLE_STATE_ENUM." if lifecycle_state && !LIFECYCLE_STATE_ENUM.include?(lifecycle_state)

      @lifecycle_state = lifecycle_state
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        lifecycle_state == other.lifecycle_state &&
        customer_shipping_address == other.customer_shipping_address &&
        expected_return_date == other.expected_return_date &&
        pickup_window_start_time == other.pickup_window_start_time &&
        pickup_window_end_time == other.pickup_window_end_time &&
        minimum_storage_capacity_in_terabytes == other.minimum_storage_capacity_in_terabytes
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [lifecycle_state, customer_shipping_address, expected_return_date, pickup_window_start_time, pickup_window_end_time, minimum_storage_capacity_in_terabytes].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
