# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20180828
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Results of a emWarehouse search. Contains boh EmWarehouseSummary items and other information, such as metadata.
  class EmWarehouse::Models::EmInstancesDetails
    # **[Required]** operations Insights Warehouse Identifier
    # @return [String]
    attr_accessor :em_id

    # EmInstance Target count
    # @return [Integer]
    attr_accessor :targets_count

    # emHost name
    # @return [String]
    attr_accessor :em_host

    # emdDiscoverer url
    # @return [String]
    attr_accessor :em_discoverer_url

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'em_id': :'emId',
        'targets_count': :'targetsCount',
        'em_host': :'emHost',
        'em_discoverer_url': :'emDiscovererUrl'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'em_id': :'String',
        'targets_count': :'Integer',
        'em_host': :'String',
        'em_discoverer_url': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :em_id The value to assign to the {#em_id} property
    # @option attributes [Integer] :targets_count The value to assign to the {#targets_count} property
    # @option attributes [String] :em_host The value to assign to the {#em_host} property
    # @option attributes [String] :em_discoverer_url The value to assign to the {#em_discoverer_url} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.em_id = attributes[:'emId'] if attributes[:'emId']

      raise 'You cannot provide both :emId and :em_id' if attributes.key?(:'emId') && attributes.key?(:'em_id')

      self.em_id = attributes[:'em_id'] if attributes[:'em_id']

      self.targets_count = attributes[:'targetsCount'] if attributes[:'targetsCount']

      raise 'You cannot provide both :targetsCount and :targets_count' if attributes.key?(:'targetsCount') && attributes.key?(:'targets_count')

      self.targets_count = attributes[:'targets_count'] if attributes[:'targets_count']

      self.em_host = attributes[:'emHost'] if attributes[:'emHost']

      raise 'You cannot provide both :emHost and :em_host' if attributes.key?(:'emHost') && attributes.key?(:'em_host')

      self.em_host = attributes[:'em_host'] if attributes[:'em_host']

      self.em_discoverer_url = attributes[:'emDiscovererUrl'] if attributes[:'emDiscovererUrl']

      raise 'You cannot provide both :emDiscovererUrl and :em_discoverer_url' if attributes.key?(:'emDiscovererUrl') && attributes.key?(:'em_discoverer_url')

      self.em_discoverer_url = attributes[:'em_discoverer_url'] if attributes[:'em_discoverer_url']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        em_id == other.em_id &&
        targets_count == other.targets_count &&
        em_host == other.em_host &&
        em_discoverer_url == other.em_discoverer_url
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [em_id, targets_count, em_host, em_discoverer_url].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
