# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200407

module OCI
  module GoldenGate
    # Module containing models for requests made to, and responses received from,
    # OCI GoldenGate services
    module Models
    end
  end
end

# Require models
require 'oci/golden_gate/models/action_type'
require 'oci/golden_gate/models/amazon_kinesis_connection'
require 'oci/golden_gate/models/amazon_kinesis_connection_summary'
require 'oci/golden_gate/models/amazon_redshift_connection'
require 'oci/golden_gate/models/amazon_redshift_connection_summary'
require 'oci/golden_gate/models/amazon_s3_connection'
require 'oci/golden_gate/models/amazon_s3_connection_summary'
require 'oci/golden_gate/models/azure_data_lake_storage_connection'
require 'oci/golden_gate/models/azure_data_lake_storage_connection_summary'
require 'oci/golden_gate/models/azure_synapse_connection'
require 'oci/golden_gate/models/azure_synapse_connection_summary'
require 'oci/golden_gate/models/cancel_deployment_backup_details'
require 'oci/golden_gate/models/cancel_deployment_backup_type'
require 'oci/golden_gate/models/cancel_deployment_upgrade_details'
require 'oci/golden_gate/models/cancel_deployment_upgrade_type'
require 'oci/golden_gate/models/cancel_snooze_deployment_upgrade_details'
require 'oci/golden_gate/models/cancel_snooze_deployment_upgrade_type'
require 'oci/golden_gate/models/certificate'
require 'oci/golden_gate/models/certificate_collection'
require 'oci/golden_gate/models/certificate_lifecycle_state'
require 'oci/golden_gate/models/certificate_summary'
require 'oci/golden_gate/models/change_connection_compartment_details'
require 'oci/golden_gate/models/change_database_registration_compartment_details'
require 'oci/golden_gate/models/change_deployment_backup_compartment_details'
require 'oci/golden_gate/models/change_deployment_compartment_details'
require 'oci/golden_gate/models/collect_deployment_diagnostic_details'
require 'oci/golden_gate/models/connection'
require 'oci/golden_gate/models/connection_assignment'
require 'oci/golden_gate/models/connection_assignment_collection'
require 'oci/golden_gate/models/connection_assignment_summary'
require 'oci/golden_gate/models/connection_collection'
require 'oci/golden_gate/models/connection_summary'
require 'oci/golden_gate/models/connection_type'
require 'oci/golden_gate/models/copy_deployment_backup_details'
require 'oci/golden_gate/models/create_amazon_kinesis_connection_details'
require 'oci/golden_gate/models/create_amazon_redshift_connection_details'
require 'oci/golden_gate/models/create_amazon_s3_connection_details'
require 'oci/golden_gate/models/create_azure_data_lake_storage_connection_details'
require 'oci/golden_gate/models/create_azure_synapse_connection_details'
require 'oci/golden_gate/models/create_certificate_details'
require 'oci/golden_gate/models/create_connection_assignment_details'
require 'oci/golden_gate/models/create_connection_details'
require 'oci/golden_gate/models/create_database_registration_details'
require 'oci/golden_gate/models/create_deployment_backup_details'
require 'oci/golden_gate/models/create_deployment_details'
require 'oci/golden_gate/models/create_elasticsearch_connection_details'
require 'oci/golden_gate/models/create_generic_connection_details'
require 'oci/golden_gate/models/create_golden_gate_connection_details'
require 'oci/golden_gate/models/create_google_big_query_connection_details'
require 'oci/golden_gate/models/create_google_cloud_storage_connection_details'
require 'oci/golden_gate/models/create_hdfs_connection_details'
require 'oci/golden_gate/models/create_java_message_service_connection_details'
require 'oci/golden_gate/models/create_kafka_connection_details'
require 'oci/golden_gate/models/create_kafka_schema_registry_connection_details'
require 'oci/golden_gate/models/create_maintenance_configuration_details'
require 'oci/golden_gate/models/create_maintenance_window_details'
require 'oci/golden_gate/models/create_microsoft_sqlserver_connection_details'
require 'oci/golden_gate/models/create_mongo_db_connection_details'
require 'oci/golden_gate/models/create_mysql_connection_details'
require 'oci/golden_gate/models/create_oci_object_storage_connection_details'
require 'oci/golden_gate/models/create_ogg_deployment_details'
require 'oci/golden_gate/models/create_oracle_connection_details'
require 'oci/golden_gate/models/create_oracle_nosql_connection_details'
require 'oci/golden_gate/models/create_postgresql_connection_details'
require 'oci/golden_gate/models/create_redis_connection_details'
require 'oci/golden_gate/models/create_snowflake_connection_details'
require 'oci/golden_gate/models/credential_store'
require 'oci/golden_gate/models/database_registration'
require 'oci/golden_gate/models/database_registration_collection'
require 'oci/golden_gate/models/database_registration_summary'
require 'oci/golden_gate/models/day'
require 'oci/golden_gate/models/default_cancel_deployment_backup_details'
require 'oci/golden_gate/models/default_cancel_deployment_upgrade_details'
require 'oci/golden_gate/models/default_cancel_snooze_deployment_upgrade_details'
require 'oci/golden_gate/models/default_deployment_wallet_exists_details'
require 'oci/golden_gate/models/default_restore_deployment_details'
require 'oci/golden_gate/models/default_rollback_deployment_upgrade_details'
require 'oci/golden_gate/models/default_snooze_deployment_upgrade_details'
require 'oci/golden_gate/models/default_start_deployment_details'
require 'oci/golden_gate/models/default_stop_deployment_details'
require 'oci/golden_gate/models/default_test_connection_assignment_details'
require 'oci/golden_gate/models/default_upgrade_deployment_upgrade_details'
require 'oci/golden_gate/models/deployment'
require 'oci/golden_gate/models/deployment_backup'
require 'oci/golden_gate/models/deployment_backup_collection'
require 'oci/golden_gate/models/deployment_backup_summary'
require 'oci/golden_gate/models/deployment_backup_type'
require 'oci/golden_gate/models/deployment_collection'
require 'oci/golden_gate/models/deployment_diagnostic_data'
require 'oci/golden_gate/models/deployment_diagnostic_state'
require 'oci/golden_gate/models/deployment_message_collection'
require 'oci/golden_gate/models/deployment_summary'
require 'oci/golden_gate/models/deployment_type'
require 'oci/golden_gate/models/deployment_type_collection'
require 'oci/golden_gate/models/deployment_type_summary'
require 'oci/golden_gate/models/deployment_upgrade'
require 'oci/golden_gate/models/deployment_upgrade_collection'
require 'oci/golden_gate/models/deployment_upgrade_lifecycle_state'
require 'oci/golden_gate/models/deployment_upgrade_summary'
require 'oci/golden_gate/models/deployment_upgrade_type'
require 'oci/golden_gate/models/deployment_version_collection'
require 'oci/golden_gate/models/deployment_version_summary'
require 'oci/golden_gate/models/deployment_wallet_exists_details'
require 'oci/golden_gate/models/deployment_wallet_exists_response_details'
require 'oci/golden_gate/models/deployment_wallet_operation_type'
require 'oci/golden_gate/models/deployment_wallet_status'
require 'oci/golden_gate/models/deployment_wallets_operation_collection'
require 'oci/golden_gate/models/deployment_wallets_operation_summary'
require 'oci/golden_gate/models/elasticsearch_connection'
require 'oci/golden_gate/models/elasticsearch_connection_summary'
require 'oci/golden_gate/models/export_deployment_wallet_details'
require 'oci/golden_gate/models/generic_connection'
require 'oci/golden_gate/models/generic_connection_summary'
require 'oci/golden_gate/models/golden_gate_connection'
require 'oci/golden_gate/models/golden_gate_connection_summary'
require 'oci/golden_gate/models/google_big_query_connection'
require 'oci/golden_gate/models/google_big_query_connection_summary'
require 'oci/golden_gate/models/google_cloud_storage_connection'
require 'oci/golden_gate/models/google_cloud_storage_connection_summary'
require 'oci/golden_gate/models/hdfs_connection'
require 'oci/golden_gate/models/hdfs_connection_summary'
require 'oci/golden_gate/models/import_deployment_wallet_details'
require 'oci/golden_gate/models/ingress_ip_details'
require 'oci/golden_gate/models/java_message_service_connection'
require 'oci/golden_gate/models/java_message_service_connection_summary'
require 'oci/golden_gate/models/kafka_bootstrap_server'
require 'oci/golden_gate/models/kafka_connection'
require 'oci/golden_gate/models/kafka_connection_summary'
require 'oci/golden_gate/models/kafka_schema_registry_connection'
require 'oci/golden_gate/models/kafka_schema_registry_connection_summary'
require 'oci/golden_gate/models/license_model'
require 'oci/golden_gate/models/lifecycle_state'
require 'oci/golden_gate/models/lifecycle_sub_state'
require 'oci/golden_gate/models/maintenance_action_type'
require 'oci/golden_gate/models/maintenance_configuration'
require 'oci/golden_gate/models/maintenance_window'
require 'oci/golden_gate/models/message_summary'
require 'oci/golden_gate/models/microsoft_sqlserver_connection'
require 'oci/golden_gate/models/microsoft_sqlserver_connection_summary'
require 'oci/golden_gate/models/mongo_db_connection'
require 'oci/golden_gate/models/mongo_db_connection_summary'
require 'oci/golden_gate/models/mysql_connection'
require 'oci/golden_gate/models/mysql_connection_summary'
require 'oci/golden_gate/models/name_value_pair'
require 'oci/golden_gate/models/oci_object_storage_connection'
require 'oci/golden_gate/models/oci_object_storage_connection_summary'
require 'oci/golden_gate/models/ogg_deployment'
require 'oci/golden_gate/models/operation_status'
require 'oci/golden_gate/models/operation_type'
require 'oci/golden_gate/models/oracle_connection'
require 'oci/golden_gate/models/oracle_connection_summary'
require 'oci/golden_gate/models/oracle_nosql_connection'
require 'oci/golden_gate/models/oracle_nosql_connection_summary'
require 'oci/golden_gate/models/postgresql_connection'
require 'oci/golden_gate/models/postgresql_connection_summary'
require 'oci/golden_gate/models/redis_connection'
require 'oci/golden_gate/models/redis_connection_summary'
require 'oci/golden_gate/models/release_type'
require 'oci/golden_gate/models/reschedule_deployment_upgrade_details'
require 'oci/golden_gate/models/reschedule_deployment_upgrade_to_date_details'
require 'oci/golden_gate/models/reschedule_deployment_upgrade_type'
require 'oci/golden_gate/models/restore_deployment_details'
require 'oci/golden_gate/models/restore_deployment_type'
require 'oci/golden_gate/models/rollback_deployment_upgrade_details'
require 'oci/golden_gate/models/rollback_deployment_upgrade_type'
require 'oci/golden_gate/models/snooze_deployment_upgrade_details'
require 'oci/golden_gate/models/snooze_deployment_upgrade_type'
require 'oci/golden_gate/models/snowflake_connection'
require 'oci/golden_gate/models/snowflake_connection_summary'
require 'oci/golden_gate/models/sort_order'
require 'oci/golden_gate/models/start_deployment_details'
require 'oci/golden_gate/models/start_deployment_type'
require 'oci/golden_gate/models/stop_deployment_details'
require 'oci/golden_gate/models/stop_deployment_type'
require 'oci/golden_gate/models/technology_type'
require 'oci/golden_gate/models/test_connection_assignment_details'
require 'oci/golden_gate/models/test_connection_assignment_error'
require 'oci/golden_gate/models/test_connection_assignment_result'
require 'oci/golden_gate/models/test_connection_assignment_type'
require 'oci/golden_gate/models/trail_file_collection'
require 'oci/golden_gate/models/trail_file_summary'
require 'oci/golden_gate/models/trail_sequence_collection'
require 'oci/golden_gate/models/trail_sequence_summary'
require 'oci/golden_gate/models/update_amazon_kinesis_connection_details'
require 'oci/golden_gate/models/update_amazon_redshift_connection_details'
require 'oci/golden_gate/models/update_amazon_s3_connection_details'
require 'oci/golden_gate/models/update_azure_data_lake_storage_connection_details'
require 'oci/golden_gate/models/update_azure_synapse_connection_details'
require 'oci/golden_gate/models/update_connection_details'
require 'oci/golden_gate/models/update_database_registration_details'
require 'oci/golden_gate/models/update_deployment_backup_details'
require 'oci/golden_gate/models/update_deployment_details'
require 'oci/golden_gate/models/update_elasticsearch_connection_details'
require 'oci/golden_gate/models/update_generic_connection_details'
require 'oci/golden_gate/models/update_golden_gate_connection_details'
require 'oci/golden_gate/models/update_google_big_query_connection_details'
require 'oci/golden_gate/models/update_google_cloud_storage_connection_details'
require 'oci/golden_gate/models/update_hdfs_connection_details'
require 'oci/golden_gate/models/update_java_message_service_connection_details'
require 'oci/golden_gate/models/update_kafka_connection_details'
require 'oci/golden_gate/models/update_kafka_schema_registry_connection_details'
require 'oci/golden_gate/models/update_maintenance_configuration_details'
require 'oci/golden_gate/models/update_maintenance_window_details'
require 'oci/golden_gate/models/update_microsoft_sqlserver_connection_details'
require 'oci/golden_gate/models/update_mongo_db_connection_details'
require 'oci/golden_gate/models/update_mysql_connection_details'
require 'oci/golden_gate/models/update_oci_object_storage_connection_details'
require 'oci/golden_gate/models/update_ogg_deployment_details'
require 'oci/golden_gate/models/update_oracle_connection_details'
require 'oci/golden_gate/models/update_oracle_nosql_connection_details'
require 'oci/golden_gate/models/update_postgresql_connection_details'
require 'oci/golden_gate/models/update_redis_connection_details'
require 'oci/golden_gate/models/update_snowflake_connection_details'
require 'oci/golden_gate/models/upgrade_deployment_current_release_details'
require 'oci/golden_gate/models/upgrade_deployment_details'
require 'oci/golden_gate/models/upgrade_deployment_specific_release_details'
require 'oci/golden_gate/models/upgrade_deployment_type'
require 'oci/golden_gate/models/upgrade_deployment_upgrade_details'
require 'oci/golden_gate/models/upgrade_deployment_upgrade_type'
require 'oci/golden_gate/models/wallet_exists_deployment_type'
require 'oci/golden_gate/models/work_request'
require 'oci/golden_gate/models/work_request_error'
require 'oci/golden_gate/models/work_request_log_entry'
require 'oci/golden_gate/models/work_request_resource'

# Require generated clients
require 'oci/golden_gate/golden_gate_client'
require 'oci/golden_gate/golden_gate_client_composite_operations'

# Require service utilities
require 'oci/golden_gate/util'
