# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: v1

module OCI
  module IdentityDomains
    # Module containing models for requests made to, and responses received from,
    # OCI IdentityDomains services
    module Models
    end
  end
end

# Require models
require 'oci/identity_domains/models/account_mgmt_info'
require 'oci/identity_domains/models/account_mgmt_info_app'
require 'oci/identity_domains/models/account_mgmt_info_matching_owners'
require 'oci/identity_domains/models/account_mgmt_info_object_class'
require 'oci/identity_domains/models/account_mgmt_info_owner'
require 'oci/identity_domains/models/account_mgmt_info_resource_type'
require 'oci/identity_domains/models/account_mgmt_info_search_request'
require 'oci/identity_domains/models/account_mgmt_info_user_wallet_artifact'
require 'oci/identity_domains/models/account_mgmt_infos'
require 'oci/identity_domains/models/account_recovery_setting'
require 'oci/identity_domains/models/account_recovery_settings'
require 'oci/identity_domains/models/addresses'
require 'oci/identity_domains/models/api_key'
require 'oci/identity_domains/models/api_key_search_request'
require 'oci/identity_domains/models/api_key_user'
require 'oci/identity_domains/models/api_keys'
require 'oci/identity_domains/models/app'
require 'oci/identity_domains/models/app_accounts'
require 'oci/identity_domains/models/app_admin_roles'
require 'oci/identity_domains/models/app_alias_apps'
require 'oci/identity_domains/models/app_allow_authz_policy'
require 'oci/identity_domains/models/app_allowed_scopes'
require 'oci/identity_domains/models/app_allowed_tags'
require 'oci/identity_domains/models/app_app_resources'
require 'oci/identity_domains/models/app_app_signon_policy'
require 'oci/identity_domains/models/app_apps_network_perimeters'
require 'oci/identity_domains/models/app_as_opc_service'
require 'oci/identity_domains/models/app_attr_rendering_metadata'
require 'oci/identity_domains/models/app_based_on_template'
require 'oci/identity_domains/models/app_bundle_configuration_properties'
require 'oci/identity_domains/models/app_bundle_pool_configuration'
require 'oci/identity_domains/models/app_certificates'
require 'oci/identity_domains/models/app_cloud_control_properties'
require 'oci/identity_domains/models/app_connector_bundle'
require 'oci/identity_domains/models/app_deny_authz_policy'
require 'oci/identity_domains/models/app_domain_app'
require 'oci/identity_domains/models/app_editable_attributes'
require 'oci/identity_domains/models/app_extension_dbcs_app'
require 'oci/identity_domains/models/app_extension_enterprise_app_app'
require 'oci/identity_domains/models/app_extension_form_fill_app_app'
require 'oci/identity_domains/models/app_extension_form_fill_app_template_app_template'
require 'oci/identity_domains/models/app_extension_kerberos_realm_app'
require 'oci/identity_domains/models/app_extension_managedapp_app'
require 'oci/identity_domains/models/app_extension_multicloud_service_app_app'
require 'oci/identity_domains/models/app_extension_opc_service_app'
require 'oci/identity_domains/models/app_extension_radius_app_app'
require 'oci/identity_domains/models/app_extension_requestable_app'
require 'oci/identity_domains/models/app_extension_saml_service_provider_app'
require 'oci/identity_domains/models/app_extension_web_tier_policy_app'
require 'oci/identity_domains/models/app_flat_file_bundle_configuration_properties'
require 'oci/identity_domains/models/app_flat_file_connector_bundle'
require 'oci/identity_domains/models/app_form_fill_url_match'
require 'oci/identity_domains/models/app_granted_app_roles'
require 'oci/identity_domains/models/app_grants'
require 'oci/identity_domains/models/app_group_assertion_attributes'
require 'oci/identity_domains/models/app_group_membership_to_return'
require 'oci/identity_domains/models/app_identity_bridges'
require 'oci/identity_domains/models/app_identity_providers'
require 'oci/identity_domains/models/app_idp_policy'
require 'oci/identity_domains/models/app_object_classes'
require 'oci/identity_domains/models/app_outbound_assertion_attributes'
require 'oci/identity_domains/models/app_protectable_secondary_audiences'
require 'oci/identity_domains/models/app_radius_policy'
require 'oci/identity_domains/models/app_role'
require 'oci/identity_domains/models/app_role_app'
require 'oci/identity_domains/models/app_role_members'
require 'oci/identity_domains/models/app_role_search_request'
require 'oci/identity_domains/models/app_roles'
require 'oci/identity_domains/models/app_saml_service_provider'
require 'oci/identity_domains/models/app_scopes'
require 'oci/identity_domains/models/app_search_request'
require 'oci/identity_domains/models/app_service_params'
require 'oci/identity_domains/models/app_signon_policy'
require 'oci/identity_domains/models/app_status_changer'
require 'oci/identity_domains/models/app_terms_of_use'
require 'oci/identity_domains/models/app_three_legged_o_auth_credential'
require 'oci/identity_domains/models/app_trust_policies'
require 'oci/identity_domains/models/app_user_assertion_attributes'
require 'oci/identity_domains/models/app_user_roles'
require 'oci/identity_domains/models/approval_workflow'
require 'oci/identity_domains/models/approval_workflow_approval_workflow_steps'
require 'oci/identity_domains/models/approval_workflow_assignment'
require 'oci/identity_domains/models/approval_workflow_assignment_approval_workflow'
require 'oci/identity_domains/models/approval_workflow_assignment_assigned_to'
require 'oci/identity_domains/models/approval_workflow_assignments'
require 'oci/identity_domains/models/approval_workflow_max_duration'
require 'oci/identity_domains/models/approval_workflow_step'
require 'oci/identity_domains/models/approval_workflow_step_approvers'
require 'oci/identity_domains/models/approval_workflow_steps'
require 'oci/identity_domains/models/approval_workflows'
require 'oci/identity_domains/models/apps'
require 'oci/identity_domains/models/attribute_sets'
require 'oci/identity_domains/models/auth_token'
require 'oci/identity_domains/models/auth_token_search_request'
require 'oci/identity_domains/models/auth_token_user'
require 'oci/identity_domains/models/auth_tokens'
require 'oci/identity_domains/models/authentication_factor_setting'
require 'oci/identity_domains/models/authentication_factor_settings'
require 'oci/identity_domains/models/authentication_factor_settings_bypass_code_settings'
require 'oci/identity_domains/models/authentication_factor_settings_client_app_settings'
require 'oci/identity_domains/models/authentication_factor_settings_compliance_policy'
require 'oci/identity_domains/models/authentication_factor_settings_duo_security_settings'
require 'oci/identity_domains/models/authentication_factor_settings_email_settings'
require 'oci/identity_domains/models/authentication_factor_settings_endpoint_restrictions'
require 'oci/identity_domains/models/authentication_factor_settings_identity_store_settings'
require 'oci/identity_domains/models/authentication_factor_settings_notification_settings'
require 'oci/identity_domains/models/authentication_factor_settings_search_request'
require 'oci/identity_domains/models/authentication_factor_settings_third_party_factor'
require 'oci/identity_domains/models/authentication_factor_settings_totp_settings'
require 'oci/identity_domains/models/authentication_factors_remover'
require 'oci/identity_domains/models/authentication_factors_remover_user'
require 'oci/identity_domains/models/branding_setting'
require 'oci/identity_domains/models/branding_settings'
require 'oci/identity_domains/models/branding_settings_company_names'
require 'oci/identity_domains/models/branding_settings_default_company_names'
require 'oci/identity_domains/models/branding_settings_default_images'
require 'oci/identity_domains/models/branding_settings_default_login_texts'
require 'oci/identity_domains/models/branding_settings_images'
require 'oci/identity_domains/models/branding_settings_login_texts'
require 'oci/identity_domains/models/cloud_gate'
require 'oci/identity_domains/models/cloud_gate_ext_mappings'
require 'oci/identity_domains/models/cloud_gate_ext_servers'
require 'oci/identity_domains/models/cloud_gate_ext_upstream_server_groups'
require 'oci/identity_domains/models/cloud_gate_ext_upstream_servers'
require 'oci/identity_domains/models/cloud_gate_mapping'
require 'oci/identity_domains/models/cloud_gate_mapping_cloud_gate'
require 'oci/identity_domains/models/cloud_gate_mapping_gateway_app'
require 'oci/identity_domains/models/cloud_gate_mapping_search_request'
require 'oci/identity_domains/models/cloud_gate_mapping_server'
require 'oci/identity_domains/models/cloud_gate_mapping_upstream_server_group'
require 'oci/identity_domains/models/cloud_gate_mappings'
require 'oci/identity_domains/models/cloud_gate_oauth_client'
require 'oci/identity_domains/models/cloud_gate_search_request'
require 'oci/identity_domains/models/cloud_gate_server'
require 'oci/identity_domains/models/cloud_gate_server_cloud_gate'
require 'oci/identity_domains/models/cloud_gate_server_search_request'
require 'oci/identity_domains/models/cloud_gate_servers'
require 'oci/identity_domains/models/cloud_gates'
require 'oci/identity_domains/models/condition'
require 'oci/identity_domains/models/condition_search_request'
require 'oci/identity_domains/models/conditions'
require 'oci/identity_domains/models/customer_secret_key'
require 'oci/identity_domains/models/customer_secret_key_search_request'
require 'oci/identity_domains/models/customer_secret_key_user'
require 'oci/identity_domains/models/customer_secret_keys'
require 'oci/identity_domains/models/defined_tags'
require 'oci/identity_domains/models/dynamic_resource_group'
require 'oci/identity_domains/models/dynamic_resource_group_dynamic_group_app_roles'
require 'oci/identity_domains/models/dynamic_resource_group_grants'
require 'oci/identity_domains/models/dynamic_resource_group_search_request'
require 'oci/identity_domains/models/dynamic_resource_groups'
require 'oci/identity_domains/models/extension_adaptive_user'
require 'oci/identity_domains/models/extension_capabilities_user'
require 'oci/identity_domains/models/extension_db_credentials_user'
require 'oci/identity_domains/models/extension_db_user_user'
require 'oci/identity_domains/models/extension_dbcs_group'
require 'oci/identity_domains/models/extension_dynamic_group'
require 'oci/identity_domains/models/extension_enterprise20_user'
require 'oci/identity_domains/models/extension_fido_authentication_factor_settings'
require 'oci/identity_domains/models/extension_group_group'
require 'oci/identity_domains/models/extension_kerberos_user_user'
require 'oci/identity_domains/models/extension_me_user'
require 'oci/identity_domains/models/extension_messages_error'
require 'oci/identity_domains/models/extension_mfa_user'
require 'oci/identity_domains/models/extension_oci_tags'
require 'oci/identity_domains/models/extension_password_state_user'
require 'oci/identity_domains/models/extension_passwordless_user'
require 'oci/identity_domains/models/extension_posix_group'
require 'oci/identity_domains/models/extension_posix_user'
require 'oci/identity_domains/models/extension_requestable_group'
require 'oci/identity_domains/models/extension_security_questions_user'
require 'oci/identity_domains/models/extension_self_change_user'
require 'oci/identity_domains/models/extension_self_registration_user'
require 'oci/identity_domains/models/extension_sff_user'
require 'oci/identity_domains/models/extension_social_account_user'
require 'oci/identity_domains/models/extension_social_identity_provider'
require 'oci/identity_domains/models/extension_terms_of_use_user'
require 'oci/identity_domains/models/extension_third_party_authentication_factor_settings'
require 'oci/identity_domains/models/extension_user_credentials_user'
require 'oci/identity_domains/models/extension_user_state_user'
require 'oci/identity_domains/models/extension_user_user'
require 'oci/identity_domains/models/extension_x509_identity_provider'
require 'oci/identity_domains/models/freeform_tags'
require 'oci/identity_domains/models/grant'
require 'oci/identity_domains/models/grant_app'
require 'oci/identity_domains/models/grant_app_entitlement_collection'
require 'oci/identity_domains/models/grant_entitlement'
require 'oci/identity_domains/models/grant_grantee'
require 'oci/identity_domains/models/grant_grantor'
require 'oci/identity_domains/models/grant_search_request'
require 'oci/identity_domains/models/grants'
require 'oci/identity_domains/models/group'
require 'oci/identity_domains/models/group_ext_app_roles'
require 'oci/identity_domains/models/group_ext_domain_level_schema_names'
require 'oci/identity_domains/models/group_ext_grants'
require 'oci/identity_domains/models/group_ext_instance_level_schema_names'
require 'oci/identity_domains/models/group_ext_owners'
require 'oci/identity_domains/models/group_ext_password_policy'
require 'oci/identity_domains/models/group_ext_synced_from_app'
require 'oci/identity_domains/models/group_members'
require 'oci/identity_domains/models/group_search_request'
require 'oci/identity_domains/models/groups'
require 'oci/identity_domains/models/idcs_created_by'
require 'oci/identity_domains/models/idcs_last_modified_by'
require 'oci/identity_domains/models/idcs_prevented_operations'
require 'oci/identity_domains/models/identity_provider'
require 'oci/identity_domains/models/identity_provider_correlation_policy'
require 'oci/identity_domains/models/identity_provider_jit_user_prov_assigned_groups'
require 'oci/identity_domains/models/identity_provider_jit_user_prov_attributes'
require 'oci/identity_domains/models/identity_provider_jit_user_prov_group_mappings'
require 'oci/identity_domains/models/identity_provider_relay_idp_param_mappings'
require 'oci/identity_domains/models/identity_provider_search_request'
require 'oci/identity_domains/models/identity_providers'
require 'oci/identity_domains/models/identity_setting'
require 'oci/identity_domains/models/identity_settings'
require 'oci/identity_domains/models/identity_settings_my_profile'
require 'oci/identity_domains/models/identity_settings_posix_gid'
require 'oci/identity_domains/models/identity_settings_posix_uid'
require 'oci/identity_domains/models/identity_settings_search_request'
require 'oci/identity_domains/models/identity_settings_tokens'
require 'oci/identity_domains/models/kmsi_setting'
require 'oci/identity_domains/models/kmsi_settings'
require 'oci/identity_domains/models/kmsi_settings_search_request'
require 'oci/identity_domains/models/me'
require 'oci/identity_domains/models/me_emails'
require 'oci/identity_domains/models/me_entitlements'
require 'oci/identity_domains/models/me_groups'
require 'oci/identity_domains/models/me_ims'
require 'oci/identity_domains/models/me_name'
require 'oci/identity_domains/models/me_password_changer'
require 'oci/identity_domains/models/me_phone_numbers'
require 'oci/identity_domains/models/me_photos'
require 'oci/identity_domains/models/me_roles'
require 'oci/identity_domains/models/me_x509_certificates'
require 'oci/identity_domains/models/meta'
require 'oci/identity_domains/models/my_api_key'
require 'oci/identity_domains/models/my_api_key_user'
require 'oci/identity_domains/models/my_api_keys'
require 'oci/identity_domains/models/my_app'
require 'oci/identity_domains/models/my_app_app'
require 'oci/identity_domains/models/my_app_owner'
require 'oci/identity_domains/models/my_app_search_request'
require 'oci/identity_domains/models/my_app_user_wallet_artifact'
require 'oci/identity_domains/models/my_apps'
require 'oci/identity_domains/models/my_auth_token'
require 'oci/identity_domains/models/my_auth_token_user'
require 'oci/identity_domains/models/my_auth_tokens'
require 'oci/identity_domains/models/my_authentication_factor_initiator'
require 'oci/identity_domains/models/my_authentication_factor_initiator_additional_attributes'
require 'oci/identity_domains/models/my_authentication_factor_initiator_third_party_factor'
require 'oci/identity_domains/models/my_authentication_factor_validator'
require 'oci/identity_domains/models/my_authentication_factor_validator_additional_attributes'
require 'oci/identity_domains/models/my_authentication_factor_validator_security_questions'
require 'oci/identity_domains/models/my_authentication_factor_validator_third_party_factor'
require 'oci/identity_domains/models/my_authentication_factors_remover'
require 'oci/identity_domains/models/my_authentication_factors_remover_user'
require 'oci/identity_domains/models/my_completed_approval'
require 'oci/identity_domains/models/my_completed_approvals'
require 'oci/identity_domains/models/my_customer_secret_key'
require 'oci/identity_domains/models/my_customer_secret_key_user'
require 'oci/identity_domains/models/my_customer_secret_keys'
require 'oci/identity_domains/models/my_device'
require 'oci/identity_domains/models/my_device_additional_attributes'
require 'oci/identity_domains/models/my_device_authentication_factors'
require 'oci/identity_domains/models/my_device_non_compliances'
require 'oci/identity_domains/models/my_device_push_notification_target'
require 'oci/identity_domains/models/my_device_third_party_factor'
require 'oci/identity_domains/models/my_device_user'
require 'oci/identity_domains/models/my_devices'
require 'oci/identity_domains/models/my_group'
require 'oci/identity_domains/models/my_group_members'
require 'oci/identity_domains/models/my_group_search_request'
require 'oci/identity_domains/models/my_groups'
require 'oci/identity_domains/models/my_o_auth2_client_credential'
require 'oci/identity_domains/models/my_o_auth2_client_credential_scopes'
require 'oci/identity_domains/models/my_o_auth2_client_credential_user'
require 'oci/identity_domains/models/my_o_auth2_client_credentials'
require 'oci/identity_domains/models/my_pending_approval'
require 'oci/identity_domains/models/my_pending_approvals'
require 'oci/identity_domains/models/my_request'
require 'oci/identity_domains/models/my_request_approval_details'
require 'oci/identity_domains/models/my_request_requesting'
require 'oci/identity_domains/models/my_request_requestor'
require 'oci/identity_domains/models/my_request_search_request'
require 'oci/identity_domains/models/my_requestable_group'
require 'oci/identity_domains/models/my_requestable_group_members'
require 'oci/identity_domains/models/my_requestable_group_search_request'
require 'oci/identity_domains/models/my_requestable_groups'
require 'oci/identity_domains/models/my_requests'
require 'oci/identity_domains/models/my_smtp_credential'
require 'oci/identity_domains/models/my_smtp_credential_user'
require 'oci/identity_domains/models/my_smtp_credentials'
require 'oci/identity_domains/models/my_support_account'
require 'oci/identity_domains/models/my_support_account_user'
require 'oci/identity_domains/models/my_support_accounts'
require 'oci/identity_domains/models/my_trusted_user_agent'
require 'oci/identity_domains/models/my_trusted_user_agent_trusted_factors'
require 'oci/identity_domains/models/my_trusted_user_agent_user'
require 'oci/identity_domains/models/my_trusted_user_agents'
require 'oci/identity_domains/models/my_user_db_credential'
require 'oci/identity_domains/models/my_user_db_credentials'
require 'oci/identity_domains/models/my_user_db_credentials_user'
require 'oci/identity_domains/models/network_perimeter'
require 'oci/identity_domains/models/network_perimeter_ip_addresses'
require 'oci/identity_domains/models/network_perimeter_search_request'
require 'oci/identity_domains/models/network_perimeters'
require 'oci/identity_domains/models/notification_setting'
require 'oci/identity_domains/models/notification_settings'
require 'oci/identity_domains/models/notification_settings_event_settings'
require 'oci/identity_domains/models/notification_settings_from_email_address'
require 'oci/identity_domains/models/notification_settings_search_request'
require 'oci/identity_domains/models/o_auth2_client_credential'
require 'oci/identity_domains/models/o_auth2_client_credential_scopes'
require 'oci/identity_domains/models/o_auth2_client_credential_search_request'
require 'oci/identity_domains/models/o_auth2_client_credential_user'
require 'oci/identity_domains/models/o_auth2_client_credentials'
require 'oci/identity_domains/models/o_auth_client_certificate'
require 'oci/identity_domains/models/o_auth_client_certificate_search_request'
require 'oci/identity_domains/models/o_auth_client_certificates'
require 'oci/identity_domains/models/o_auth_partner_certificate'
require 'oci/identity_domains/models/o_auth_partner_certificate_search_request'
require 'oci/identity_domains/models/o_auth_partner_certificates'
require 'oci/identity_domains/models/operations'
require 'oci/identity_domains/models/password_policies'
require 'oci/identity_domains/models/password_policy'
require 'oci/identity_domains/models/password_policy_configured_password_policy_rules'
require 'oci/identity_domains/models/password_policy_groups'
require 'oci/identity_domains/models/password_policy_search_request'
require 'oci/identity_domains/models/patch_op'
require 'oci/identity_domains/models/policies'
require 'oci/identity_domains/models/policy'
require 'oci/identity_domains/models/policy_policy_type'
require 'oci/identity_domains/models/policy_rules'
require 'oci/identity_domains/models/policy_search_request'
require 'oci/identity_domains/models/resource_type_schema_attribute'
require 'oci/identity_domains/models/resource_type_schema_attribute_search_request'
require 'oci/identity_domains/models/resource_type_schema_attributes'
require 'oci/identity_domains/models/rule'
require 'oci/identity_domains/models/rule_condition_group'
require 'oci/identity_domains/models/rule_policy_type'
require 'oci/identity_domains/models/rule_return'
require 'oci/identity_domains/models/rule_search_request'
require 'oci/identity_domains/models/rules'
require 'oci/identity_domains/models/schema'
require 'oci/identity_domains/models/schema_attributes'
require 'oci/identity_domains/models/schema_idcs_complex_attribute_name_mappings'
require 'oci/identity_domains/models/schema_idcs_csv_attribute_name_mappings'
require 'oci/identity_domains/models/schema_localized_canonical_values'
require 'oci/identity_domains/models/schema_localized_display_name'
require 'oci/identity_domains/models/schema_referenced_resource_type_unique_attribute_name_mappings'
require 'oci/identity_domains/models/schema_resolve_value_using_resource_type'
require 'oci/identity_domains/models/schema_search_request'
require 'oci/identity_domains/models/schema_sub_attributes'
require 'oci/identity_domains/models/schemas'
require 'oci/identity_domains/models/security_question'
require 'oci/identity_domains/models/security_question_question_text'
require 'oci/identity_domains/models/security_question_search_request'
require 'oci/identity_domains/models/security_question_setting'
require 'oci/identity_domains/models/security_question_settings'
require 'oci/identity_domains/models/security_question_settings_search_request'
require 'oci/identity_domains/models/security_questions'
require 'oci/identity_domains/models/self_registration_profile'
require 'oci/identity_domains/models/self_registration_profile_after_submit_text'
require 'oci/identity_domains/models/self_registration_profile_consent_text'
require 'oci/identity_domains/models/self_registration_profile_default_groups'
require 'oci/identity_domains/models/self_registration_profile_display_name'
require 'oci/identity_domains/models/self_registration_profile_email_template'
require 'oci/identity_domains/models/self_registration_profile_footer_text'
require 'oci/identity_domains/models/self_registration_profile_header_text'
require 'oci/identity_domains/models/self_registration_profile_search_request'
require 'oci/identity_domains/models/self_registration_profile_user_attributes'
require 'oci/identity_domains/models/self_registration_profiles'
require 'oci/identity_domains/models/setting'
require 'oci/identity_domains/models/settings'
require 'oci/identity_domains/models/settings_certificate_validation'
require 'oci/identity_domains/models/settings_cloud_gate_cors_settings'
require 'oci/identity_domains/models/settings_company_names'
require 'oci/identity_domains/models/settings_default_company_names'
require 'oci/identity_domains/models/settings_default_images'
require 'oci/identity_domains/models/settings_default_login_texts'
require 'oci/identity_domains/models/settings_images'
require 'oci/identity_domains/models/settings_login_texts'
require 'oci/identity_domains/models/settings_purge_configs'
require 'oci/identity_domains/models/settings_search_request'
require 'oci/identity_domains/models/settings_tenant_custom_claims'
require 'oci/identity_domains/models/smtp_credential'
require 'oci/identity_domains/models/smtp_credential_search_request'
require 'oci/identity_domains/models/smtp_credential_user'
require 'oci/identity_domains/models/smtp_credentials'
require 'oci/identity_domains/models/sort_order'
require 'oci/identity_domains/models/tags'
require 'oci/identity_domains/models/user'
require 'oci/identity_domains/models/user_attributes_setting'
require 'oci/identity_domains/models/user_attributes_settings'
require 'oci/identity_domains/models/user_attributes_settings_attribute_settings'
require 'oci/identity_domains/models/user_attributes_settings_search_request'
require 'oci/identity_domains/models/user_capabilities_changer'
require 'oci/identity_domains/models/user_db_credential'
require 'oci/identity_domains/models/user_db_credentials'
require 'oci/identity_domains/models/user_db_credentials_search_request'
require 'oci/identity_domains/models/user_db_credentials_user'
require 'oci/identity_domains/models/user_emails'
require 'oci/identity_domains/models/user_entitlements'
require 'oci/identity_domains/models/user_ext_accounts'
require 'oci/identity_domains/models/user_ext_api_keys'
require 'oci/identity_domains/models/user_ext_app_roles'
require 'oci/identity_domains/models/user_ext_applicable_authentication_target_app'
require 'oci/identity_domains/models/user_ext_applicable_password_policy'
require 'oci/identity_domains/models/user_ext_auth_tokens'
require 'oci/identity_domains/models/user_ext_bypass_codes'
require 'oci/identity_domains/models/user_ext_customer_secret_keys'
require 'oci/identity_domains/models/user_ext_db_credentials'
require 'oci/identity_domains/models/user_ext_delegated_authentication_target_app'
require 'oci/identity_domains/models/user_ext_devices'
require 'oci/identity_domains/models/user_ext_factor_identifier'
require 'oci/identity_domains/models/user_ext_grants'
require 'oci/identity_domains/models/user_ext_idcs_app_roles_limited_to_groups'
require 'oci/identity_domains/models/user_ext_locked'
require 'oci/identity_domains/models/user_ext_manager'
require 'oci/identity_domains/models/user_ext_o_auth2_client_credentials'
require 'oci/identity_domains/models/user_ext_password_verifiers'
require 'oci/identity_domains/models/user_ext_preferred_device'
require 'oci/identity_domains/models/user_ext_realm_users'
require 'oci/identity_domains/models/user_ext_recovery_locked'
require 'oci/identity_domains/models/user_ext_risk_scores'
require 'oci/identity_domains/models/user_ext_sec_questions'
require 'oci/identity_domains/models/user_ext_self_registration_profile'
require 'oci/identity_domains/models/user_ext_smtp_credentials'
require 'oci/identity_domains/models/user_ext_social_accounts'
require 'oci/identity_domains/models/user_ext_support_accounts'
require 'oci/identity_domains/models/user_ext_synced_from_app'
require 'oci/identity_domains/models/user_ext_terms_of_use_consents'
require 'oci/identity_domains/models/user_ext_trusted_user_agents'
require 'oci/identity_domains/models/user_ext_user_token'
require 'oci/identity_domains/models/user_groups'
require 'oci/identity_domains/models/user_ims'
require 'oci/identity_domains/models/user_name'
require 'oci/identity_domains/models/user_password_changer'
require 'oci/identity_domains/models/user_password_resetter'
require 'oci/identity_domains/models/user_password_resetter_user_token'
require 'oci/identity_domains/models/user_phone_numbers'
require 'oci/identity_domains/models/user_photos'
require 'oci/identity_domains/models/user_roles'
require 'oci/identity_domains/models/user_search_request'
require 'oci/identity_domains/models/user_status_changer'
require 'oci/identity_domains/models/user_x509_certificates'
require 'oci/identity_domains/models/users'

# Require generated clients
require 'oci/identity_domains/identity_domains_client'

# Require service utilities
require 'oci/identity_domains/util'
