# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: v1
require 'date'
require 'logger'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Schema for App resource.
  class IdentityDomains::Models::App
    IDCS_PREVENTED_OPERATIONS_ENUM = [
      IDCS_PREVENTED_OPERATIONS_REPLACE = 'replace'.freeze,
      IDCS_PREVENTED_OPERATIONS_UPDATE = 'update'.freeze,
      IDCS_PREVENTED_OPERATIONS_DELETE = 'delete'.freeze,
      IDCS_PREVENTED_OPERATIONS_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    LOGIN_MECHANISM_ENUM = [
      LOGIN_MECHANISM_OIDC = 'OIDC'.freeze,
      LOGIN_MECHANISM_SAML = 'SAML'.freeze,
      LOGIN_MECHANISM_FORMFILL = 'FORMFILL'.freeze,
      LOGIN_MECHANISM_RADIUS = 'RADIUS'.freeze,
      LOGIN_MECHANISM_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    CLIENT_TYPE_ENUM = [
      CLIENT_TYPE_CONFIDENTIAL = 'confidential'.freeze,
      CLIENT_TYPE_PUBLIC = 'public'.freeze,
      CLIENT_TYPE_TRUSTED = 'trusted'.freeze,
      CLIENT_TYPE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    ALLOWED_OPERATIONS_ENUM = [
      ALLOWED_OPERATIONS_INTROSPECT = 'introspect'.freeze,
      ALLOWED_OPERATIONS_ON_BEHALF_OF_USER = 'onBehalfOfUser'.freeze,
      ALLOWED_OPERATIONS_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    CLIENT_IP_CHECKING_ENUM = [
      CLIENT_IP_CHECKING_ANYWHERE = 'anywhere'.freeze,
      CLIENT_IP_CHECKING_WHITELISTED = 'whitelisted'.freeze,
      CLIENT_IP_CHECKING_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    TRUST_SCOPE_ENUM = [
      TRUST_SCOPE_EXPLICIT = 'Explicit'.freeze,
      TRUST_SCOPE_ACCOUNT = 'Account'.freeze,
      TRUST_SCOPE_TAGS = 'Tags'.freeze,
      TRUST_SCOPE_DEFAULT = 'Default'.freeze,
      TRUST_SCOPE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    # Unique identifier for the SCIM Resource as defined by the Service Provider. Each representation of the Resource MUST include a non-empty id value. This identifier MUST be unique across the Service Provider's entire set of Resources. It MUST be a stable, non-reassignable identifier that does not change when the same Resource is returned in subsequent requests. The value of the id attribute is always issued by the Service Provider and MUST never be specified by the Service Consumer. bulkId: is a reserved keyword and MUST NOT be used in the unique identifier.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: always
    #  - type: string
    #  - uniqueness: global
    # @return [String]
    attr_accessor :id

    # Unique OCI identifier for the SCIM Resource.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: immutable
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: global
    # @return [String]
    attr_accessor :ocid

    # **[Required]** REQUIRED. The schemas attribute is an array of Strings which allows introspection of the supported schema version for a SCIM representation as well any schema extensions supported by that representation. Each String value must be a unique URI. This specification defines URIs for User, Group, and a standard \\\"enterprise\\\" extension. All representations of SCIM schema MUST include a non-zero value array with value(s) of the URIs supported by that representation. Duplicate values MUST NOT be included. Value order is not specified and MUST not impact behavior.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: true
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_accessor :schemas

    # @return [OCI::IdentityDomains::Models::Meta]
    attr_accessor :meta

    # @return [OCI::IdentityDomains::Models::IdcsCreatedBy]
    attr_accessor :idcs_created_by

    # @return [OCI::IdentityDomains::Models::IdcsLastModifiedBy]
    attr_accessor :idcs_last_modified_by

    # Each value of this attribute specifies an operation that only an internal client may perform on this particular resource.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_reader :idcs_prevented_operations

    # A list of tags on this resource.
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [key, value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: request
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::Tags>]
    attr_accessor :tags

    # A boolean flag indicating this resource in the process of being deleted. Usually set to true when synchronous deletion of the resource would take too long.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :delete_in_progress

    # The release number when the resource was upgraded.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :idcs_last_upgraded_in_release

    # OCI Domain Id (ocid) in which the resource lives.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :domain_ocid

    # OCI Compartment Id (ocid) in which the resource lives.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :compartment_ocid

    # OCI Tenant Id (ocid) in which the resource lives.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :tenancy_ocid

    # Indicates whether the application is billed as an OPCService. If true, customer is not billed for runtime operations of the app.
    #
    # **Added In:** 18.4.2
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: always
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :meter_as_opc_service

    # Name of the application. Also serves as username if the application authenticates to Oracle Public Cloud infrastructure. This name may not be user-friendly and cannot be changed once an App is created.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: immutable
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: server
    # @return [String]
    attr_accessor :name

    # This value is the credential of this App, which this App supplies as a password when this App authenticates to the Oracle Public Cloud infrastructure. This value is also the client secret of this App when it acts as an OAuthClient.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - idcsSensitive: none
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :client_secret

    # Hashed Client Secret. This hash-value is used to verify the 'clientSecret' credential of this App
    #
    # **Added In:** 2106240046
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - idcsSensitive: hash_sc
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :hashed_client_secret

    # **[Required]** Display name of the application. Display name is intended to be user-friendly, and an administrator can change the value at any time.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: true
    #  - returned: always
    #  - type: string
    #  - uniqueness: server
    # @return [String]
    attr_accessor :display_name

    # Description of the application.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :description

    # Encryption Alogrithm to use for encrypting ID token.
    #
    # **Added In:** 2010242156
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :id_token_enc_algo

    # Service Names allow to use OCI signature for client authentication instead of client credentials
    #
    # **Added In:** 2207040824
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_accessor :delegated_service_names

    # If true, this App is able to participate in runtime services, such as automatic-login, OAuth, and SAML. If false, all runtime services are disabled for this App, and only administrative operations can be performed.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :active

    # Application icon.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: request
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :app_icon

    # Application thumbnail.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: request
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :app_thumbnail

    # If true, this App was migrated from an earlier version of Oracle Public Cloud infrastructure (and may therefore require special handling from runtime services such as OAuth or SAML). If false, this App requires no special handling from runtime services.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :migrated

    # If true, this App is an internal infrastructure App.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :infrastructure

    # If true, this App allows runtime services to log end users into this App automatically.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_login_target

    # If true, this app will be displayed in the MyApps page of each end-user who has access to the App.
    #
    # **Added In:** 18.1.2
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :show_in_my_apps

    # The protocol that runtime services will use to log end users in to this App automatically. If 'OIDC', then runtime services use the OpenID Connect protocol. If 'SAML', then runtime services use Security Assertion Markup Language protocol.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_reader :login_mechanism

    # The URL of the landing page for this App, which is the first page that an end user should see if runtime services log that end user in to this App automatically.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :landing_page_url

    # Application Logo URL
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :product_logo_url

    # Privacy Policy URL
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :privacy_policy_url

    # Terms of Service URL
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :terms_of_service_url

    # Contact Email Address
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :contact_email_address

    # Product Name
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :product_name

    # Home Page URL
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :home_page_url

    # If true, this application acts as FormFill Application
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_form_fill

    # If true, this application acts as an OAuth Client
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_o_auth_client

    # If true, this application acts as an Radius App
    #
    # **Added In:** 20.1.3
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_radius_app

    # Specifies the type of access that this App has when it acts as an OAuthClient.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_reader :client_type

    # OPTIONAL. Each value is a URI within this App. This attribute is required when this App acts as an OAuthClient and is involved in three-legged flows (authorization-code flows).
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_accessor :redirect_uris

    # If true, indicates that the system should allow all URL-schemes within each value of the 'redirectUris' attribute.  Also indicates that the system should not attempt to confirm that each value of the 'redirectUris' attribute is a valid URI.  In particular, the system should not confirm that the domain component of the URI is a top-level domain and the system should not confirm that the hostname portion is a valid system that is reachable over the network.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :all_url_schemes_allowed

    # OAuth will use this URI to logout if this App wants to participate in SSO, and if this App's session gets cleared as part of global logout. Note: This attribute is used only if this App acts as an OAuthClient.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :logout_uri

    # Each value of this attribute is the URI of a landing page within this App. It is used only when this App, acting as an OAuthClient, initiates the logout flow and wants to be redirected back to one of its landing pages.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_accessor :post_logout_redirect_uris

    # List of grant-types that this App is allowed to use when it acts as an OAuthClient.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_accessor :allowed_grants

    # OPTIONAL. Required only when this App acts as an OAuthClient. Supported values are 'introspect' and 'onBehalfOfUser'. The value 'introspect' allows the client to look inside the access-token. The value 'onBehalfOfUser' overrides how the client's privileges are combined with the privileges of the Subject User. Ordinarily, authorization calculates the set of effective privileges as the intersection of the client's privileges and the user's privileges. The value 'onBehalfOf' indicates that authorization should ignore the privileges of the client and use only the user's privileges to calculate the effective privileges.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_reader :allowed_operations

    # Network Perimeters checking mode
    #
    # **Added In:** 2010242156
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_reader :client_ip_checking

    # If true, this application is an Oracle Public Cloud service-instance.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_opc_service

    # If true, indicates that this application accepts an Oracle Cloud Identity Service User as a login-identity (does not require an account) and relies for authorization on the User's memberships in AppRoles.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: immutable
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_unmanaged_app

    # If true, any managed App that is based on this template is checked for access control that is, access to this app is subject to successful authorization at SSO service, viz. app grants to start with.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :allow_access_control

    # If true, indicates that this application acts as an OAuth Resource.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_o_auth_resource

    # Expiry-time in seconds for an Access Token. Any token that allows access to this App will expire after the specified duration.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: integer
    #  - uniqueness: none
    # @return [Integer]
    attr_accessor :access_token_expiry

    # Expiry-time in seconds for a Refresh Token.  Any token that allows access to this App, once refreshed, will expire after the specified duration.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: integer
    #  - uniqueness: none
    # @return [Integer]
    attr_accessor :refresh_token_expiry

    # If true, indicates that the Refresh Token is allowed when this App acts as an OAuth Resource.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :allow_offline

    # Callback Service URL
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :callback_service_url

    # The base URI for all of the scopes defined in this App. The value of 'audience' is combined with the 'value' of each scope to form an 'fqs' or fully qualified scope.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :audience

    # If true, indicates that the App should be visible in each end-user's mobile application.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_mobile_target

    # This attribute specifies the URL of the page that the App uses when an end-user signs in to that App.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :login_page_url

    # This attribute specifies the callback URL for the social linking operation.
    #
    # **Added In:** 18.2.4
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :linking_callback_url

    # This attribute specifies the URL of the page that the App uses when an end-user signs out.
    #
    # **Added In:** 17.4.2
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :logout_page_url

    # This attribute specifies the URL of the page to which an application will redirect an end-user in case of error.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :error_page_url

    # If true, then this App acts as a SAML Service Provider.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_saml_service_provider

    # If true, the webtier policy is active
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_web_tier_policy

    # If true, indicates that this App supports Kerberos Authentication
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_kerberos_realm

    # URL of application icon.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: reference
    #  - uniqueness: none
    # @return [String]
    attr_accessor :icon

    # If true, this App is an AliasApp and it cannot be granted to an end-user directly.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: immutable
    #  - required: false
    #  - returned: always
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_alias_app

    # If true, indicates that access to this App requires an account. That is, in order to log in to the App, a User must use an application-specific identity that is maintained in the remote identity-repository of that App.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_managed_app

    # This Uniform Resource Name (URN) value identifies the type of Oracle Public Cloud service of which this app is an instance.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :service_type_urn

    # This value specifies the version of the Oracle Public Cloud service of which this App is an instance
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_accessor :service_type_version

    # This flag indicates if the App is capable of validating obligations with the token for allowing access to the App.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_obligation_capable

    # If true, this App requires an upgrade and mandates attention from application administrator. The flag is used by UI to indicate this app is ready to upgrade.
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :ready_to_upgrade

    # Indicates the scope of trust for this App when acting as an OAuthClient. A value of 'Explicit' indicates that the App is allowed to access only the scopes of OAuthResources that are explicitly specified as 'allowedScopes'. A value of 'Account' indicates that the App is allowed implicitly to access any scope of any OAuthResource within the same Oracle Cloud Account. A value of 'Tags' indicates that the App is allowed to access any scope of any OAuthResource with a matching tag within the same Oracle Cloud Account. A value of 'Default' indicates that the Tenant default trust scope configured in the Tenant Settings is used.
    #
    # **Added In:** 17.4.2
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [String]
    attr_reader :trust_scope

    # If true, this application acts as database service Application
    #
    # **Added In:** 18.2.2
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readOnly
    #  - required: false
    #  - type: boolean
    # @return [BOOLEAN]
    attr_accessor :is_database_service

    # A list of secondary audiences--additional URIs to be added automatically to any OAuth token that allows access to this App. Note: This attribute is used mainly for backward compatibility in certain Oracle Public Cloud Apps.
    #
    # **Deprecated Since: 18.2.6**
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: string
    #  - uniqueness: none
    # @return [Array<String>]
    attr_accessor :secondary_audiences

    # If true, this app acts as Enterprise app with Authentication and URL Authz policy.
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_enterprise_app

    # If true, indicates that consent should be skipped for all scopes
    #
    # **Added In:** 19.2.1
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :bypass_consent

    # Indicates whether the application is allowed to be access using kmsi token.
    #
    # **Added In:** 2111190457
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: false
    #  - multiValued: false
    #  - mutability: readWrite
    #  - required: false
    #  - returned: always
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :disable_kmsi_token_authentication

    # If true, indicates the app is used for multicloud service integration.
    #
    # **Added In:** 2301202328
    #
    # **SCIM++ Properties:**
    #  - idcsSearchable: true
    #  - multiValued: false
    #  - mutability: immutable
    #  - required: false
    #  - returned: default
    #  - type: boolean
    #  - uniqueness: none
    # @return [BOOLEAN]
    attr_accessor :is_multicloud_service_app

    # @return [OCI::IdentityDomains::Models::AppRadiusPolicy]
    attr_accessor :radius_policy

    # Network Perimeter
    #
    # **Added In:** 2010242156
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [value]
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    # @return [Array<OCI::IdentityDomains::Models::AppAppsNetworkPerimeters>]
    attr_accessor :apps_network_perimeters

    # A collection of arbitrary properties that scope the privileges of a cloud-control App.
    #
    # **Added In:** 18.4.2
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [name]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppCloudControlProperties>]
    attr_accessor :cloud_control_properties

    # App attributes editable by subject
    #
    # **Added In:** 18.2.6
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsCompositeKey: [name]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppEditableAttributes>]
    attr_accessor :editable_attributes

    # @return [OCI::IdentityDomains::Models::AppTermsOfUse]
    attr_accessor :terms_of_use

    # A list of secondary audiences--additional URIs to be added automatically to any OAuth token that allows access to this App. Note: This attribute is used mainly for backward compatibility in certain Oracle Public Cloud Apps.
    #
    # **Added In:** 18.2.2
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppProtectableSecondaryAudiences>]
    attr_accessor :protectable_secondary_audiences

    # @return [OCI::IdentityDomains::Models::AppIdpPolicy]
    attr_accessor :idp_policy

    # A list of tags, acting as an OAuthClient, this App is allowed to access.
    #
    # **Added In:** 17.4.6
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [key, value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppAllowedTags>]
    attr_accessor :allowed_tags

    # @return [OCI::IdentityDomains::Models::AppAppSignonPolicy]
    attr_accessor :app_signon_policy

    # Trust Policies.
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    # @return [Array<OCI::IdentityDomains::Models::AppTrustPolicies>]
    attr_accessor :trust_policies

    # @return [OCI::IdentityDomains::Models::AppSignonPolicy]
    attr_accessor :signon_policy

    # A list of IdentityProvider assigned to app. A user trying to access this app will be automatically redirected to configured IdP during the authentication phase, before being able to access App.
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: request
    #  - type: complex
    # @return [Array<OCI::IdentityDomains::Models::AppIdentityProviders>]
    attr_accessor :identity_providers

    # Accounts of App
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppAccounts>]
    attr_accessor :accounts

    # Grants assigned to the app
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppGrants>]
    attr_accessor :grants

    # Custom attribute that is required to compute other attribute values during app creation.
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [name]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: always
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppServiceParams>]
    attr_accessor :service_params

    # Label for the attribute to be shown in the UI.
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [name]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: immutable
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppAttrRenderingMetadata>]
    attr_accessor :attr_rendering_metadata

    # This attribute is required.
    # @return [OCI::IdentityDomains::Models::AppBasedOnTemplate]
    attr_accessor :based_on_template

    # A list of AppRoles that are granted to this App (and that are defined by other Apps). Within the Oracle Public Cloud infrastructure, this allows AppID-based association. Such an association allows this App to act as a consumer and thus to access resources of another App that acts as a producer.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppGrantedAppRoles>]
    attr_accessor :granted_app_roles

    # @return [OCI::IdentityDomains::Models::AppSamlServiceProvider]
    attr_accessor :saml_service_provider

    # A list of scopes (exposed by this App or by other Apps) that this App is allowed to access when it acts as an OAuthClient.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsCompositeKey: [fqs]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppAllowedScopes>]
    attr_accessor :allowed_scopes

    # Each value of this attribute represent a certificate that this App uses when it acts as an OAuthClient.
    #
    # **SCIM++ Properties:**
    #  - caseExact: false
    #  - idcsCompositeKey: [certAlias]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppCertificates>]
    attr_accessor :certificates

    # Each value of this internal attribute refers to an Oracle Public Cloud infrastructure App on which this App depends.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppAliasApps>]
    attr_accessor :alias_apps

    # @return [OCI::IdentityDomains::Models::AppAsOPCService]
    attr_accessor :as_opc_service

    # A list of AppRoles defined by this UnmanagedApp. Membership in each of these AppRoles confers administrative privilege within this App.
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: complex
    # @return [Array<OCI::IdentityDomains::Models::AppAdminRoles>]
    attr_accessor :admin_roles

    # A list of AppRoles defined by this UnmanagedApp. Membership in each of these AppRoles confers end-user privilege within this App.
    #
    # **SCIM++ Properties:**
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: false
    #  - multiValued: true
    #  - mutability: readOnly
    #  - required: false
    #  - returned: request
    #  - type: complex
    # @return [Array<OCI::IdentityDomains::Models::AppUserRoles>]
    attr_accessor :user_roles

    # Scopes defined by this App. Used when this App acts as an OAuth Resource.
    #
    # **SCIM++ Properties:**
    #  - caseExact: true
    #  - idcsCompositeKey: [value]
    #  - idcsSearchable: true
    #  - multiValued: true
    #  - mutability: readWrite
    #  - required: false
    #  - returned: default
    #  - type: complex
    #  - uniqueness: none
    # @return [Array<OCI::IdentityDomains::Models::AppScopes>]
    attr_accessor :scopes

    # @return [OCI::IdentityDomains::Models::AppExtensionRadiusAppApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app

    # @return [OCI::IdentityDomains::Models::AppExtensionSamlServiceProviderApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app

    # @return [OCI::IdentityDomains::Models::AppExtensionWebTierPolicyApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app

    # @return [OCI::IdentityDomains::Models::AppExtensionManagedappApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app

    # @return [OCI::IdentityDomains::Models::AppExtensionFormFillAppTemplateAppTemplate]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template

    # @return [OCI::IdentityDomains::Models::AppExtensionOpcServiceApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app

    # @return [OCI::IdentityDomains::Models::AppExtensionKerberosRealmApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app

    # @return [OCI::IdentityDomains::Models::AppExtensionRequestableApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app

    # @return [OCI::IdentityDomains::Models::AppExtensionFormFillAppApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app

    # @return [OCI::IdentityDomains::Models::AppExtensionDbcsApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app

    # @return [OCI::IdentityDomains::Models::AppExtensionEnterpriseAppApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app

    # @return [OCI::IdentityDomains::Models::ExtensionOCITags]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags

    # @return [OCI::IdentityDomains::Models::AppExtensionMulticloudServiceAppApp]
    attr_accessor :urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'id',
        'ocid': :'ocid',
        'schemas': :'schemas',
        'meta': :'meta',
        'idcs_created_by': :'idcsCreatedBy',
        'idcs_last_modified_by': :'idcsLastModifiedBy',
        'idcs_prevented_operations': :'idcsPreventedOperations',
        'tags': :'tags',
        'delete_in_progress': :'deleteInProgress',
        'idcs_last_upgraded_in_release': :'idcsLastUpgradedInRelease',
        'domain_ocid': :'domainOcid',
        'compartment_ocid': :'compartmentOcid',
        'tenancy_ocid': :'tenancyOcid',
        'meter_as_opc_service': :'meterAsOPCService',
        'name': :'name',
        'client_secret': :'clientSecret',
        'hashed_client_secret': :'hashedClientSecret',
        'display_name': :'displayName',
        'description': :'description',
        'id_token_enc_algo': :'idTokenEncAlgo',
        'delegated_service_names': :'delegatedServiceNames',
        'active': :'active',
        'app_icon': :'appIcon',
        'app_thumbnail': :'appThumbnail',
        'migrated': :'migrated',
        'infrastructure': :'infrastructure',
        'is_login_target': :'isLoginTarget',
        'show_in_my_apps': :'showInMyApps',
        'login_mechanism': :'loginMechanism',
        'landing_page_url': :'landingPageUrl',
        'product_logo_url': :'productLogoUrl',
        'privacy_policy_url': :'privacyPolicyUrl',
        'terms_of_service_url': :'termsOfServiceUrl',
        'contact_email_address': :'contactEmailAddress',
        'product_name': :'productName',
        'home_page_url': :'homePageUrl',
        'is_form_fill': :'isFormFill',
        'is_o_auth_client': :'isOAuthClient',
        'is_radius_app': :'isRadiusApp',
        'client_type': :'clientType',
        'redirect_uris': :'redirectUris',
        'all_url_schemes_allowed': :'allUrlSchemesAllowed',
        'logout_uri': :'logoutUri',
        'post_logout_redirect_uris': :'postLogoutRedirectUris',
        'allowed_grants': :'allowedGrants',
        'allowed_operations': :'allowedOperations',
        'client_ip_checking': :'clientIPChecking',
        'is_opc_service': :'isOPCService',
        'is_unmanaged_app': :'isUnmanagedApp',
        'allow_access_control': :'allowAccessControl',
        'is_o_auth_resource': :'isOAuthResource',
        'access_token_expiry': :'accessTokenExpiry',
        'refresh_token_expiry': :'refreshTokenExpiry',
        'allow_offline': :'allowOffline',
        'callback_service_url': :'callbackServiceUrl',
        'audience': :'audience',
        'is_mobile_target': :'isMobileTarget',
        'login_page_url': :'loginPageUrl',
        'linking_callback_url': :'linkingCallbackUrl',
        'logout_page_url': :'logoutPageUrl',
        'error_page_url': :'errorPageUrl',
        'is_saml_service_provider': :'isSamlServiceProvider',
        'is_web_tier_policy': :'isWebTierPolicy',
        'is_kerberos_realm': :'isKerberosRealm',
        'icon': :'icon',
        'is_alias_app': :'isAliasApp',
        'is_managed_app': :'isManagedApp',
        'service_type_urn': :'serviceTypeURN',
        'service_type_version': :'serviceTypeVersion',
        'is_obligation_capable': :'isObligationCapable',
        'ready_to_upgrade': :'readyToUpgrade',
        'trust_scope': :'trustScope',
        'is_database_service': :'isDatabaseService',
        'secondary_audiences': :'secondaryAudiences',
        'is_enterprise_app': :'isEnterpriseApp',
        'bypass_consent': :'bypassConsent',
        'disable_kmsi_token_authentication': :'disableKmsiTokenAuthentication',
        'is_multicloud_service_app': :'isMulticloudServiceApp',
        'radius_policy': :'radiusPolicy',
        'apps_network_perimeters': :'appsNetworkPerimeters',
        'cloud_control_properties': :'cloudControlProperties',
        'editable_attributes': :'editableAttributes',
        'terms_of_use': :'termsOfUse',
        'protectable_secondary_audiences': :'protectableSecondaryAudiences',
        'idp_policy': :'idpPolicy',
        'allowed_tags': :'allowedTags',
        'app_signon_policy': :'appSignonPolicy',
        'trust_policies': :'trustPolicies',
        'signon_policy': :'signonPolicy',
        'identity_providers': :'identityProviders',
        'accounts': :'accounts',
        'grants': :'grants',
        'service_params': :'serviceParams',
        'attr_rendering_metadata': :'attrRenderingMetadata',
        'based_on_template': :'basedOnTemplate',
        'granted_app_roles': :'grantedAppRoles',
        'saml_service_provider': :'samlServiceProvider',
        'allowed_scopes': :'allowedScopes',
        'certificates': :'certificates',
        'alias_apps': :'aliasApps',
        'as_opc_service': :'asOPCService',
        'admin_roles': :'adminRoles',
        'user_roles': :'userRoles',
        'scopes': :'scopes',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:radiusApp:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:samlServiceProvider:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:webTierPolicy:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:managedapp:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillAppTemplate:AppTemplate',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:opcService:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:kerberosRealm:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:requestable:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillApp:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:dbcs:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:enterpriseApp:App',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:OCITags',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app': :'urn:ietf:params:scim:schemas:oracle:idcs:extension:multicloudServiceApp:App'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'String',
        'ocid': :'String',
        'schemas': :'Array<String>',
        'meta': :'OCI::IdentityDomains::Models::Meta',
        'idcs_created_by': :'OCI::IdentityDomains::Models::IdcsCreatedBy',
        'idcs_last_modified_by': :'OCI::IdentityDomains::Models::IdcsLastModifiedBy',
        'idcs_prevented_operations': :'Array<String>',
        'tags': :'Array<OCI::IdentityDomains::Models::Tags>',
        'delete_in_progress': :'BOOLEAN',
        'idcs_last_upgraded_in_release': :'String',
        'domain_ocid': :'String',
        'compartment_ocid': :'String',
        'tenancy_ocid': :'String',
        'meter_as_opc_service': :'BOOLEAN',
        'name': :'String',
        'client_secret': :'String',
        'hashed_client_secret': :'String',
        'display_name': :'String',
        'description': :'String',
        'id_token_enc_algo': :'String',
        'delegated_service_names': :'Array<String>',
        'active': :'BOOLEAN',
        'app_icon': :'String',
        'app_thumbnail': :'String',
        'migrated': :'BOOLEAN',
        'infrastructure': :'BOOLEAN',
        'is_login_target': :'BOOLEAN',
        'show_in_my_apps': :'BOOLEAN',
        'login_mechanism': :'String',
        'landing_page_url': :'String',
        'product_logo_url': :'String',
        'privacy_policy_url': :'String',
        'terms_of_service_url': :'String',
        'contact_email_address': :'String',
        'product_name': :'String',
        'home_page_url': :'String',
        'is_form_fill': :'BOOLEAN',
        'is_o_auth_client': :'BOOLEAN',
        'is_radius_app': :'BOOLEAN',
        'client_type': :'String',
        'redirect_uris': :'Array<String>',
        'all_url_schemes_allowed': :'BOOLEAN',
        'logout_uri': :'String',
        'post_logout_redirect_uris': :'Array<String>',
        'allowed_grants': :'Array<String>',
        'allowed_operations': :'Array<String>',
        'client_ip_checking': :'String',
        'is_opc_service': :'BOOLEAN',
        'is_unmanaged_app': :'BOOLEAN',
        'allow_access_control': :'BOOLEAN',
        'is_o_auth_resource': :'BOOLEAN',
        'access_token_expiry': :'Integer',
        'refresh_token_expiry': :'Integer',
        'allow_offline': :'BOOLEAN',
        'callback_service_url': :'String',
        'audience': :'String',
        'is_mobile_target': :'BOOLEAN',
        'login_page_url': :'String',
        'linking_callback_url': :'String',
        'logout_page_url': :'String',
        'error_page_url': :'String',
        'is_saml_service_provider': :'BOOLEAN',
        'is_web_tier_policy': :'BOOLEAN',
        'is_kerberos_realm': :'BOOLEAN',
        'icon': :'String',
        'is_alias_app': :'BOOLEAN',
        'is_managed_app': :'BOOLEAN',
        'service_type_urn': :'String',
        'service_type_version': :'String',
        'is_obligation_capable': :'BOOLEAN',
        'ready_to_upgrade': :'BOOLEAN',
        'trust_scope': :'String',
        'is_database_service': :'BOOLEAN',
        'secondary_audiences': :'Array<String>',
        'is_enterprise_app': :'BOOLEAN',
        'bypass_consent': :'BOOLEAN',
        'disable_kmsi_token_authentication': :'BOOLEAN',
        'is_multicloud_service_app': :'BOOLEAN',
        'radius_policy': :'OCI::IdentityDomains::Models::AppRadiusPolicy',
        'apps_network_perimeters': :'Array<OCI::IdentityDomains::Models::AppAppsNetworkPerimeters>',
        'cloud_control_properties': :'Array<OCI::IdentityDomains::Models::AppCloudControlProperties>',
        'editable_attributes': :'Array<OCI::IdentityDomains::Models::AppEditableAttributes>',
        'terms_of_use': :'OCI::IdentityDomains::Models::AppTermsOfUse',
        'protectable_secondary_audiences': :'Array<OCI::IdentityDomains::Models::AppProtectableSecondaryAudiences>',
        'idp_policy': :'OCI::IdentityDomains::Models::AppIdpPolicy',
        'allowed_tags': :'Array<OCI::IdentityDomains::Models::AppAllowedTags>',
        'app_signon_policy': :'OCI::IdentityDomains::Models::AppAppSignonPolicy',
        'trust_policies': :'Array<OCI::IdentityDomains::Models::AppTrustPolicies>',
        'signon_policy': :'OCI::IdentityDomains::Models::AppSignonPolicy',
        'identity_providers': :'Array<OCI::IdentityDomains::Models::AppIdentityProviders>',
        'accounts': :'Array<OCI::IdentityDomains::Models::AppAccounts>',
        'grants': :'Array<OCI::IdentityDomains::Models::AppGrants>',
        'service_params': :'Array<OCI::IdentityDomains::Models::AppServiceParams>',
        'attr_rendering_metadata': :'Array<OCI::IdentityDomains::Models::AppAttrRenderingMetadata>',
        'based_on_template': :'OCI::IdentityDomains::Models::AppBasedOnTemplate',
        'granted_app_roles': :'Array<OCI::IdentityDomains::Models::AppGrantedAppRoles>',
        'saml_service_provider': :'OCI::IdentityDomains::Models::AppSamlServiceProvider',
        'allowed_scopes': :'Array<OCI::IdentityDomains::Models::AppAllowedScopes>',
        'certificates': :'Array<OCI::IdentityDomains::Models::AppCertificates>',
        'alias_apps': :'Array<OCI::IdentityDomains::Models::AppAliasApps>',
        'as_opc_service': :'OCI::IdentityDomains::Models::AppAsOPCService',
        'admin_roles': :'Array<OCI::IdentityDomains::Models::AppAdminRoles>',
        'user_roles': :'Array<OCI::IdentityDomains::Models::AppUserRoles>',
        'scopes': :'Array<OCI::IdentityDomains::Models::AppScopes>',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app': :'OCI::IdentityDomains::Models::AppExtensionRadiusAppApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app': :'OCI::IdentityDomains::Models::AppExtensionSamlServiceProviderApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app': :'OCI::IdentityDomains::Models::AppExtensionWebTierPolicyApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app': :'OCI::IdentityDomains::Models::AppExtensionManagedappApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template': :'OCI::IdentityDomains::Models::AppExtensionFormFillAppTemplateAppTemplate',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app': :'OCI::IdentityDomains::Models::AppExtensionOpcServiceApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app': :'OCI::IdentityDomains::Models::AppExtensionKerberosRealmApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app': :'OCI::IdentityDomains::Models::AppExtensionRequestableApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app': :'OCI::IdentityDomains::Models::AppExtensionFormFillAppApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app': :'OCI::IdentityDomains::Models::AppExtensionDbcsApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app': :'OCI::IdentityDomains::Models::AppExtensionEnterpriseAppApp',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags': :'OCI::IdentityDomains::Models::ExtensionOCITags',
        'urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app': :'OCI::IdentityDomains::Models::AppExtensionMulticloudServiceAppApp'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :id The value to assign to the {#id} property
    # @option attributes [String] :ocid The value to assign to the {#ocid} property
    # @option attributes [Array<String>] :schemas The value to assign to the {#schemas} property
    # @option attributes [OCI::IdentityDomains::Models::Meta] :meta The value to assign to the {#meta} property
    # @option attributes [OCI::IdentityDomains::Models::IdcsCreatedBy] :idcs_created_by The value to assign to the {#idcs_created_by} property
    # @option attributes [OCI::IdentityDomains::Models::IdcsLastModifiedBy] :idcs_last_modified_by The value to assign to the {#idcs_last_modified_by} property
    # @option attributes [Array<String>] :idcs_prevented_operations The value to assign to the {#idcs_prevented_operations} property
    # @option attributes [Array<OCI::IdentityDomains::Models::Tags>] :tags The value to assign to the {#tags} property
    # @option attributes [BOOLEAN] :delete_in_progress The value to assign to the {#delete_in_progress} property
    # @option attributes [String] :idcs_last_upgraded_in_release The value to assign to the {#idcs_last_upgraded_in_release} property
    # @option attributes [String] :domain_ocid The value to assign to the {#domain_ocid} property
    # @option attributes [String] :compartment_ocid The value to assign to the {#compartment_ocid} property
    # @option attributes [String] :tenancy_ocid The value to assign to the {#tenancy_ocid} property
    # @option attributes [BOOLEAN] :meter_as_opc_service The value to assign to the {#meter_as_opc_service} property
    # @option attributes [String] :name The value to assign to the {#name} property
    # @option attributes [String] :client_secret The value to assign to the {#client_secret} property
    # @option attributes [String] :hashed_client_secret The value to assign to the {#hashed_client_secret} property
    # @option attributes [String] :display_name The value to assign to the {#display_name} property
    # @option attributes [String] :description The value to assign to the {#description} property
    # @option attributes [String] :id_token_enc_algo The value to assign to the {#id_token_enc_algo} property
    # @option attributes [Array<String>] :delegated_service_names The value to assign to the {#delegated_service_names} property
    # @option attributes [BOOLEAN] :active The value to assign to the {#active} property
    # @option attributes [String] :app_icon The value to assign to the {#app_icon} property
    # @option attributes [String] :app_thumbnail The value to assign to the {#app_thumbnail} property
    # @option attributes [BOOLEAN] :migrated The value to assign to the {#migrated} property
    # @option attributes [BOOLEAN] :infrastructure The value to assign to the {#infrastructure} property
    # @option attributes [BOOLEAN] :is_login_target The value to assign to the {#is_login_target} property
    # @option attributes [BOOLEAN] :show_in_my_apps The value to assign to the {#show_in_my_apps} property
    # @option attributes [String] :login_mechanism The value to assign to the {#login_mechanism} property
    # @option attributes [String] :landing_page_url The value to assign to the {#landing_page_url} property
    # @option attributes [String] :product_logo_url The value to assign to the {#product_logo_url} property
    # @option attributes [String] :privacy_policy_url The value to assign to the {#privacy_policy_url} property
    # @option attributes [String] :terms_of_service_url The value to assign to the {#terms_of_service_url} property
    # @option attributes [String] :contact_email_address The value to assign to the {#contact_email_address} property
    # @option attributes [String] :product_name The value to assign to the {#product_name} property
    # @option attributes [String] :home_page_url The value to assign to the {#home_page_url} property
    # @option attributes [BOOLEAN] :is_form_fill The value to assign to the {#is_form_fill} property
    # @option attributes [BOOLEAN] :is_o_auth_client The value to assign to the {#is_o_auth_client} property
    # @option attributes [BOOLEAN] :is_radius_app The value to assign to the {#is_radius_app} property
    # @option attributes [String] :client_type The value to assign to the {#client_type} property
    # @option attributes [Array<String>] :redirect_uris The value to assign to the {#redirect_uris} property
    # @option attributes [BOOLEAN] :all_url_schemes_allowed The value to assign to the {#all_url_schemes_allowed} property
    # @option attributes [String] :logout_uri The value to assign to the {#logout_uri} property
    # @option attributes [Array<String>] :post_logout_redirect_uris The value to assign to the {#post_logout_redirect_uris} property
    # @option attributes [Array<String>] :allowed_grants The value to assign to the {#allowed_grants} property
    # @option attributes [Array<String>] :allowed_operations The value to assign to the {#allowed_operations} property
    # @option attributes [String] :client_ip_checking The value to assign to the {#client_ip_checking} property
    # @option attributes [BOOLEAN] :is_opc_service The value to assign to the {#is_opc_service} property
    # @option attributes [BOOLEAN] :is_unmanaged_app The value to assign to the {#is_unmanaged_app} property
    # @option attributes [BOOLEAN] :allow_access_control The value to assign to the {#allow_access_control} property
    # @option attributes [BOOLEAN] :is_o_auth_resource The value to assign to the {#is_o_auth_resource} property
    # @option attributes [Integer] :access_token_expiry The value to assign to the {#access_token_expiry} property
    # @option attributes [Integer] :refresh_token_expiry The value to assign to the {#refresh_token_expiry} property
    # @option attributes [BOOLEAN] :allow_offline The value to assign to the {#allow_offline} property
    # @option attributes [String] :callback_service_url The value to assign to the {#callback_service_url} property
    # @option attributes [String] :audience The value to assign to the {#audience} property
    # @option attributes [BOOLEAN] :is_mobile_target The value to assign to the {#is_mobile_target} property
    # @option attributes [String] :login_page_url The value to assign to the {#login_page_url} property
    # @option attributes [String] :linking_callback_url The value to assign to the {#linking_callback_url} property
    # @option attributes [String] :logout_page_url The value to assign to the {#logout_page_url} property
    # @option attributes [String] :error_page_url The value to assign to the {#error_page_url} property
    # @option attributes [BOOLEAN] :is_saml_service_provider The value to assign to the {#is_saml_service_provider} property
    # @option attributes [BOOLEAN] :is_web_tier_policy The value to assign to the {#is_web_tier_policy} property
    # @option attributes [BOOLEAN] :is_kerberos_realm The value to assign to the {#is_kerberos_realm} property
    # @option attributes [String] :icon The value to assign to the {#icon} property
    # @option attributes [BOOLEAN] :is_alias_app The value to assign to the {#is_alias_app} property
    # @option attributes [BOOLEAN] :is_managed_app The value to assign to the {#is_managed_app} property
    # @option attributes [String] :service_type_urn The value to assign to the {#service_type_urn} property
    # @option attributes [String] :service_type_version The value to assign to the {#service_type_version} property
    # @option attributes [BOOLEAN] :is_obligation_capable The value to assign to the {#is_obligation_capable} property
    # @option attributes [BOOLEAN] :ready_to_upgrade The value to assign to the {#ready_to_upgrade} property
    # @option attributes [String] :trust_scope The value to assign to the {#trust_scope} property
    # @option attributes [BOOLEAN] :is_database_service The value to assign to the {#is_database_service} property
    # @option attributes [Array<String>] :secondary_audiences The value to assign to the {#secondary_audiences} property
    # @option attributes [BOOLEAN] :is_enterprise_app The value to assign to the {#is_enterprise_app} property
    # @option attributes [BOOLEAN] :bypass_consent The value to assign to the {#bypass_consent} property
    # @option attributes [BOOLEAN] :disable_kmsi_token_authentication The value to assign to the {#disable_kmsi_token_authentication} property
    # @option attributes [BOOLEAN] :is_multicloud_service_app The value to assign to the {#is_multicloud_service_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppRadiusPolicy] :radius_policy The value to assign to the {#radius_policy} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppAppsNetworkPerimeters>] :apps_network_perimeters The value to assign to the {#apps_network_perimeters} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppCloudControlProperties>] :cloud_control_properties The value to assign to the {#cloud_control_properties} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppEditableAttributes>] :editable_attributes The value to assign to the {#editable_attributes} property
    # @option attributes [OCI::IdentityDomains::Models::AppTermsOfUse] :terms_of_use The value to assign to the {#terms_of_use} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppProtectableSecondaryAudiences>] :protectable_secondary_audiences The value to assign to the {#protectable_secondary_audiences} property
    # @option attributes [OCI::IdentityDomains::Models::AppIdpPolicy] :idp_policy The value to assign to the {#idp_policy} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppAllowedTags>] :allowed_tags The value to assign to the {#allowed_tags} property
    # @option attributes [OCI::IdentityDomains::Models::AppAppSignonPolicy] :app_signon_policy The value to assign to the {#app_signon_policy} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppTrustPolicies>] :trust_policies The value to assign to the {#trust_policies} property
    # @option attributes [OCI::IdentityDomains::Models::AppSignonPolicy] :signon_policy The value to assign to the {#signon_policy} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppIdentityProviders>] :identity_providers The value to assign to the {#identity_providers} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppAccounts>] :accounts The value to assign to the {#accounts} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppGrants>] :grants The value to assign to the {#grants} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppServiceParams>] :service_params The value to assign to the {#service_params} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppAttrRenderingMetadata>] :attr_rendering_metadata The value to assign to the {#attr_rendering_metadata} property
    # @option attributes [OCI::IdentityDomains::Models::AppBasedOnTemplate] :based_on_template The value to assign to the {#based_on_template} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppGrantedAppRoles>] :granted_app_roles The value to assign to the {#granted_app_roles} property
    # @option attributes [OCI::IdentityDomains::Models::AppSamlServiceProvider] :saml_service_provider The value to assign to the {#saml_service_provider} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppAllowedScopes>] :allowed_scopes The value to assign to the {#allowed_scopes} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppCertificates>] :certificates The value to assign to the {#certificates} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppAliasApps>] :alias_apps The value to assign to the {#alias_apps} property
    # @option attributes [OCI::IdentityDomains::Models::AppAsOPCService] :as_opc_service The value to assign to the {#as_opc_service} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppAdminRoles>] :admin_roles The value to assign to the {#admin_roles} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppUserRoles>] :user_roles The value to assign to the {#user_roles} property
    # @option attributes [Array<OCI::IdentityDomains::Models::AppScopes>] :scopes The value to assign to the {#scopes} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionRadiusAppApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionSamlServiceProviderApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionWebTierPolicyApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionManagedappApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionFormFillAppTemplateAppTemplate] :urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionOpcServiceApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionKerberosRealmApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionRequestableApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionFormFillAppApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionDbcsApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionEnterpriseAppApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app} property
    # @option attributes [OCI::IdentityDomains::Models::ExtensionOCITags] :urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags} property
    # @option attributes [OCI::IdentityDomains::Models::AppExtensionMulticloudServiceAppApp] :urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app The value to assign to the {#urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.id = attributes[:'id'] if attributes[:'id']

      self.ocid = attributes[:'ocid'] if attributes[:'ocid']

      self.schemas = attributes[:'schemas'] if attributes[:'schemas']

      self.meta = attributes[:'meta'] if attributes[:'meta']

      self.idcs_created_by = attributes[:'idcsCreatedBy'] if attributes[:'idcsCreatedBy']

      raise 'You cannot provide both :idcsCreatedBy and :idcs_created_by' if attributes.key?(:'idcsCreatedBy') && attributes.key?(:'idcs_created_by')

      self.idcs_created_by = attributes[:'idcs_created_by'] if attributes[:'idcs_created_by']

      self.idcs_last_modified_by = attributes[:'idcsLastModifiedBy'] if attributes[:'idcsLastModifiedBy']

      raise 'You cannot provide both :idcsLastModifiedBy and :idcs_last_modified_by' if attributes.key?(:'idcsLastModifiedBy') && attributes.key?(:'idcs_last_modified_by')

      self.idcs_last_modified_by = attributes[:'idcs_last_modified_by'] if attributes[:'idcs_last_modified_by']

      self.idcs_prevented_operations = attributes[:'idcsPreventedOperations'] if attributes[:'idcsPreventedOperations']

      raise 'You cannot provide both :idcsPreventedOperations and :idcs_prevented_operations' if attributes.key?(:'idcsPreventedOperations') && attributes.key?(:'idcs_prevented_operations')

      self.idcs_prevented_operations = attributes[:'idcs_prevented_operations'] if attributes[:'idcs_prevented_operations']

      self.tags = attributes[:'tags'] if attributes[:'tags']

      self.delete_in_progress = attributes[:'deleteInProgress'] unless attributes[:'deleteInProgress'].nil?

      raise 'You cannot provide both :deleteInProgress and :delete_in_progress' if attributes.key?(:'deleteInProgress') && attributes.key?(:'delete_in_progress')

      self.delete_in_progress = attributes[:'delete_in_progress'] unless attributes[:'delete_in_progress'].nil?

      self.idcs_last_upgraded_in_release = attributes[:'idcsLastUpgradedInRelease'] if attributes[:'idcsLastUpgradedInRelease']

      raise 'You cannot provide both :idcsLastUpgradedInRelease and :idcs_last_upgraded_in_release' if attributes.key?(:'idcsLastUpgradedInRelease') && attributes.key?(:'idcs_last_upgraded_in_release')

      self.idcs_last_upgraded_in_release = attributes[:'idcs_last_upgraded_in_release'] if attributes[:'idcs_last_upgraded_in_release']

      self.domain_ocid = attributes[:'domainOcid'] if attributes[:'domainOcid']

      raise 'You cannot provide both :domainOcid and :domain_ocid' if attributes.key?(:'domainOcid') && attributes.key?(:'domain_ocid')

      self.domain_ocid = attributes[:'domain_ocid'] if attributes[:'domain_ocid']

      self.compartment_ocid = attributes[:'compartmentOcid'] if attributes[:'compartmentOcid']

      raise 'You cannot provide both :compartmentOcid and :compartment_ocid' if attributes.key?(:'compartmentOcid') && attributes.key?(:'compartment_ocid')

      self.compartment_ocid = attributes[:'compartment_ocid'] if attributes[:'compartment_ocid']

      self.tenancy_ocid = attributes[:'tenancyOcid'] if attributes[:'tenancyOcid']

      raise 'You cannot provide both :tenancyOcid and :tenancy_ocid' if attributes.key?(:'tenancyOcid') && attributes.key?(:'tenancy_ocid')

      self.tenancy_ocid = attributes[:'tenancy_ocid'] if attributes[:'tenancy_ocid']

      self.meter_as_opc_service = attributes[:'meterAsOPCService'] unless attributes[:'meterAsOPCService'].nil?

      raise 'You cannot provide both :meterAsOPCService and :meter_as_opc_service' if attributes.key?(:'meterAsOPCService') && attributes.key?(:'meter_as_opc_service')

      self.meter_as_opc_service = attributes[:'meter_as_opc_service'] unless attributes[:'meter_as_opc_service'].nil?

      self.name = attributes[:'name'] if attributes[:'name']

      self.client_secret = attributes[:'clientSecret'] if attributes[:'clientSecret']

      raise 'You cannot provide both :clientSecret and :client_secret' if attributes.key?(:'clientSecret') && attributes.key?(:'client_secret')

      self.client_secret = attributes[:'client_secret'] if attributes[:'client_secret']

      self.hashed_client_secret = attributes[:'hashedClientSecret'] if attributes[:'hashedClientSecret']

      raise 'You cannot provide both :hashedClientSecret and :hashed_client_secret' if attributes.key?(:'hashedClientSecret') && attributes.key?(:'hashed_client_secret')

      self.hashed_client_secret = attributes[:'hashed_client_secret'] if attributes[:'hashed_client_secret']

      self.display_name = attributes[:'displayName'] if attributes[:'displayName']

      raise 'You cannot provide both :displayName and :display_name' if attributes.key?(:'displayName') && attributes.key?(:'display_name')

      self.display_name = attributes[:'display_name'] if attributes[:'display_name']

      self.description = attributes[:'description'] if attributes[:'description']

      self.id_token_enc_algo = attributes[:'idTokenEncAlgo'] if attributes[:'idTokenEncAlgo']

      raise 'You cannot provide both :idTokenEncAlgo and :id_token_enc_algo' if attributes.key?(:'idTokenEncAlgo') && attributes.key?(:'id_token_enc_algo')

      self.id_token_enc_algo = attributes[:'id_token_enc_algo'] if attributes[:'id_token_enc_algo']

      self.delegated_service_names = attributes[:'delegatedServiceNames'] if attributes[:'delegatedServiceNames']

      raise 'You cannot provide both :delegatedServiceNames and :delegated_service_names' if attributes.key?(:'delegatedServiceNames') && attributes.key?(:'delegated_service_names')

      self.delegated_service_names = attributes[:'delegated_service_names'] if attributes[:'delegated_service_names']

      self.active = attributes[:'active'] unless attributes[:'active'].nil?

      self.app_icon = attributes[:'appIcon'] if attributes[:'appIcon']

      raise 'You cannot provide both :appIcon and :app_icon' if attributes.key?(:'appIcon') && attributes.key?(:'app_icon')

      self.app_icon = attributes[:'app_icon'] if attributes[:'app_icon']

      self.app_thumbnail = attributes[:'appThumbnail'] if attributes[:'appThumbnail']

      raise 'You cannot provide both :appThumbnail and :app_thumbnail' if attributes.key?(:'appThumbnail') && attributes.key?(:'app_thumbnail')

      self.app_thumbnail = attributes[:'app_thumbnail'] if attributes[:'app_thumbnail']

      self.migrated = attributes[:'migrated'] unless attributes[:'migrated'].nil?

      self.infrastructure = attributes[:'infrastructure'] unless attributes[:'infrastructure'].nil?

      self.is_login_target = attributes[:'isLoginTarget'] unless attributes[:'isLoginTarget'].nil?

      raise 'You cannot provide both :isLoginTarget and :is_login_target' if attributes.key?(:'isLoginTarget') && attributes.key?(:'is_login_target')

      self.is_login_target = attributes[:'is_login_target'] unless attributes[:'is_login_target'].nil?

      self.show_in_my_apps = attributes[:'showInMyApps'] unless attributes[:'showInMyApps'].nil?

      raise 'You cannot provide both :showInMyApps and :show_in_my_apps' if attributes.key?(:'showInMyApps') && attributes.key?(:'show_in_my_apps')

      self.show_in_my_apps = attributes[:'show_in_my_apps'] unless attributes[:'show_in_my_apps'].nil?

      self.login_mechanism = attributes[:'loginMechanism'] if attributes[:'loginMechanism']

      raise 'You cannot provide both :loginMechanism and :login_mechanism' if attributes.key?(:'loginMechanism') && attributes.key?(:'login_mechanism')

      self.login_mechanism = attributes[:'login_mechanism'] if attributes[:'login_mechanism']

      self.landing_page_url = attributes[:'landingPageUrl'] if attributes[:'landingPageUrl']

      raise 'You cannot provide both :landingPageUrl and :landing_page_url' if attributes.key?(:'landingPageUrl') && attributes.key?(:'landing_page_url')

      self.landing_page_url = attributes[:'landing_page_url'] if attributes[:'landing_page_url']

      self.product_logo_url = attributes[:'productLogoUrl'] if attributes[:'productLogoUrl']

      raise 'You cannot provide both :productLogoUrl and :product_logo_url' if attributes.key?(:'productLogoUrl') && attributes.key?(:'product_logo_url')

      self.product_logo_url = attributes[:'product_logo_url'] if attributes[:'product_logo_url']

      self.privacy_policy_url = attributes[:'privacyPolicyUrl'] if attributes[:'privacyPolicyUrl']

      raise 'You cannot provide both :privacyPolicyUrl and :privacy_policy_url' if attributes.key?(:'privacyPolicyUrl') && attributes.key?(:'privacy_policy_url')

      self.privacy_policy_url = attributes[:'privacy_policy_url'] if attributes[:'privacy_policy_url']

      self.terms_of_service_url = attributes[:'termsOfServiceUrl'] if attributes[:'termsOfServiceUrl']

      raise 'You cannot provide both :termsOfServiceUrl and :terms_of_service_url' if attributes.key?(:'termsOfServiceUrl') && attributes.key?(:'terms_of_service_url')

      self.terms_of_service_url = attributes[:'terms_of_service_url'] if attributes[:'terms_of_service_url']

      self.contact_email_address = attributes[:'contactEmailAddress'] if attributes[:'contactEmailAddress']

      raise 'You cannot provide both :contactEmailAddress and :contact_email_address' if attributes.key?(:'contactEmailAddress') && attributes.key?(:'contact_email_address')

      self.contact_email_address = attributes[:'contact_email_address'] if attributes[:'contact_email_address']

      self.product_name = attributes[:'productName'] if attributes[:'productName']

      raise 'You cannot provide both :productName and :product_name' if attributes.key?(:'productName') && attributes.key?(:'product_name')

      self.product_name = attributes[:'product_name'] if attributes[:'product_name']

      self.home_page_url = attributes[:'homePageUrl'] if attributes[:'homePageUrl']

      raise 'You cannot provide both :homePageUrl and :home_page_url' if attributes.key?(:'homePageUrl') && attributes.key?(:'home_page_url')

      self.home_page_url = attributes[:'home_page_url'] if attributes[:'home_page_url']

      self.is_form_fill = attributes[:'isFormFill'] unless attributes[:'isFormFill'].nil?

      raise 'You cannot provide both :isFormFill and :is_form_fill' if attributes.key?(:'isFormFill') && attributes.key?(:'is_form_fill')

      self.is_form_fill = attributes[:'is_form_fill'] unless attributes[:'is_form_fill'].nil?

      self.is_o_auth_client = attributes[:'isOAuthClient'] unless attributes[:'isOAuthClient'].nil?

      raise 'You cannot provide both :isOAuthClient and :is_o_auth_client' if attributes.key?(:'isOAuthClient') && attributes.key?(:'is_o_auth_client')

      self.is_o_auth_client = attributes[:'is_o_auth_client'] unless attributes[:'is_o_auth_client'].nil?

      self.is_radius_app = attributes[:'isRadiusApp'] unless attributes[:'isRadiusApp'].nil?

      raise 'You cannot provide both :isRadiusApp and :is_radius_app' if attributes.key?(:'isRadiusApp') && attributes.key?(:'is_radius_app')

      self.is_radius_app = attributes[:'is_radius_app'] unless attributes[:'is_radius_app'].nil?

      self.client_type = attributes[:'clientType'] if attributes[:'clientType']

      raise 'You cannot provide both :clientType and :client_type' if attributes.key?(:'clientType') && attributes.key?(:'client_type')

      self.client_type = attributes[:'client_type'] if attributes[:'client_type']

      self.redirect_uris = attributes[:'redirectUris'] if attributes[:'redirectUris']

      raise 'You cannot provide both :redirectUris and :redirect_uris' if attributes.key?(:'redirectUris') && attributes.key?(:'redirect_uris')

      self.redirect_uris = attributes[:'redirect_uris'] if attributes[:'redirect_uris']

      self.all_url_schemes_allowed = attributes[:'allUrlSchemesAllowed'] unless attributes[:'allUrlSchemesAllowed'].nil?

      raise 'You cannot provide both :allUrlSchemesAllowed and :all_url_schemes_allowed' if attributes.key?(:'allUrlSchemesAllowed') && attributes.key?(:'all_url_schemes_allowed')

      self.all_url_schemes_allowed = attributes[:'all_url_schemes_allowed'] unless attributes[:'all_url_schemes_allowed'].nil?

      self.logout_uri = attributes[:'logoutUri'] if attributes[:'logoutUri']

      raise 'You cannot provide both :logoutUri and :logout_uri' if attributes.key?(:'logoutUri') && attributes.key?(:'logout_uri')

      self.logout_uri = attributes[:'logout_uri'] if attributes[:'logout_uri']

      self.post_logout_redirect_uris = attributes[:'postLogoutRedirectUris'] if attributes[:'postLogoutRedirectUris']

      raise 'You cannot provide both :postLogoutRedirectUris and :post_logout_redirect_uris' if attributes.key?(:'postLogoutRedirectUris') && attributes.key?(:'post_logout_redirect_uris')

      self.post_logout_redirect_uris = attributes[:'post_logout_redirect_uris'] if attributes[:'post_logout_redirect_uris']

      self.allowed_grants = attributes[:'allowedGrants'] if attributes[:'allowedGrants']

      raise 'You cannot provide both :allowedGrants and :allowed_grants' if attributes.key?(:'allowedGrants') && attributes.key?(:'allowed_grants')

      self.allowed_grants = attributes[:'allowed_grants'] if attributes[:'allowed_grants']

      self.allowed_operations = attributes[:'allowedOperations'] if attributes[:'allowedOperations']

      raise 'You cannot provide both :allowedOperations and :allowed_operations' if attributes.key?(:'allowedOperations') && attributes.key?(:'allowed_operations')

      self.allowed_operations = attributes[:'allowed_operations'] if attributes[:'allowed_operations']

      self.client_ip_checking = attributes[:'clientIPChecking'] if attributes[:'clientIPChecking']

      raise 'You cannot provide both :clientIPChecking and :client_ip_checking' if attributes.key?(:'clientIPChecking') && attributes.key?(:'client_ip_checking')

      self.client_ip_checking = attributes[:'client_ip_checking'] if attributes[:'client_ip_checking']

      self.is_opc_service = attributes[:'isOPCService'] unless attributes[:'isOPCService'].nil?

      raise 'You cannot provide both :isOPCService and :is_opc_service' if attributes.key?(:'isOPCService') && attributes.key?(:'is_opc_service')

      self.is_opc_service = attributes[:'is_opc_service'] unless attributes[:'is_opc_service'].nil?

      self.is_unmanaged_app = attributes[:'isUnmanagedApp'] unless attributes[:'isUnmanagedApp'].nil?

      raise 'You cannot provide both :isUnmanagedApp and :is_unmanaged_app' if attributes.key?(:'isUnmanagedApp') && attributes.key?(:'is_unmanaged_app')

      self.is_unmanaged_app = attributes[:'is_unmanaged_app'] unless attributes[:'is_unmanaged_app'].nil?

      self.allow_access_control = attributes[:'allowAccessControl'] unless attributes[:'allowAccessControl'].nil?

      raise 'You cannot provide both :allowAccessControl and :allow_access_control' if attributes.key?(:'allowAccessControl') && attributes.key?(:'allow_access_control')

      self.allow_access_control = attributes[:'allow_access_control'] unless attributes[:'allow_access_control'].nil?

      self.is_o_auth_resource = attributes[:'isOAuthResource'] unless attributes[:'isOAuthResource'].nil?

      raise 'You cannot provide both :isOAuthResource and :is_o_auth_resource' if attributes.key?(:'isOAuthResource') && attributes.key?(:'is_o_auth_resource')

      self.is_o_auth_resource = attributes[:'is_o_auth_resource'] unless attributes[:'is_o_auth_resource'].nil?

      self.access_token_expiry = attributes[:'accessTokenExpiry'] if attributes[:'accessTokenExpiry']

      raise 'You cannot provide both :accessTokenExpiry and :access_token_expiry' if attributes.key?(:'accessTokenExpiry') && attributes.key?(:'access_token_expiry')

      self.access_token_expiry = attributes[:'access_token_expiry'] if attributes[:'access_token_expiry']

      self.refresh_token_expiry = attributes[:'refreshTokenExpiry'] if attributes[:'refreshTokenExpiry']

      raise 'You cannot provide both :refreshTokenExpiry and :refresh_token_expiry' if attributes.key?(:'refreshTokenExpiry') && attributes.key?(:'refresh_token_expiry')

      self.refresh_token_expiry = attributes[:'refresh_token_expiry'] if attributes[:'refresh_token_expiry']

      self.allow_offline = attributes[:'allowOffline'] unless attributes[:'allowOffline'].nil?

      raise 'You cannot provide both :allowOffline and :allow_offline' if attributes.key?(:'allowOffline') && attributes.key?(:'allow_offline')

      self.allow_offline = attributes[:'allow_offline'] unless attributes[:'allow_offline'].nil?

      self.callback_service_url = attributes[:'callbackServiceUrl'] if attributes[:'callbackServiceUrl']

      raise 'You cannot provide both :callbackServiceUrl and :callback_service_url' if attributes.key?(:'callbackServiceUrl') && attributes.key?(:'callback_service_url')

      self.callback_service_url = attributes[:'callback_service_url'] if attributes[:'callback_service_url']

      self.audience = attributes[:'audience'] if attributes[:'audience']

      self.is_mobile_target = attributes[:'isMobileTarget'] unless attributes[:'isMobileTarget'].nil?

      raise 'You cannot provide both :isMobileTarget and :is_mobile_target' if attributes.key?(:'isMobileTarget') && attributes.key?(:'is_mobile_target')

      self.is_mobile_target = attributes[:'is_mobile_target'] unless attributes[:'is_mobile_target'].nil?

      self.login_page_url = attributes[:'loginPageUrl'] if attributes[:'loginPageUrl']

      raise 'You cannot provide both :loginPageUrl and :login_page_url' if attributes.key?(:'loginPageUrl') && attributes.key?(:'login_page_url')

      self.login_page_url = attributes[:'login_page_url'] if attributes[:'login_page_url']

      self.linking_callback_url = attributes[:'linkingCallbackUrl'] if attributes[:'linkingCallbackUrl']

      raise 'You cannot provide both :linkingCallbackUrl and :linking_callback_url' if attributes.key?(:'linkingCallbackUrl') && attributes.key?(:'linking_callback_url')

      self.linking_callback_url = attributes[:'linking_callback_url'] if attributes[:'linking_callback_url']

      self.logout_page_url = attributes[:'logoutPageUrl'] if attributes[:'logoutPageUrl']

      raise 'You cannot provide both :logoutPageUrl and :logout_page_url' if attributes.key?(:'logoutPageUrl') && attributes.key?(:'logout_page_url')

      self.logout_page_url = attributes[:'logout_page_url'] if attributes[:'logout_page_url']

      self.error_page_url = attributes[:'errorPageUrl'] if attributes[:'errorPageUrl']

      raise 'You cannot provide both :errorPageUrl and :error_page_url' if attributes.key?(:'errorPageUrl') && attributes.key?(:'error_page_url')

      self.error_page_url = attributes[:'error_page_url'] if attributes[:'error_page_url']

      self.is_saml_service_provider = attributes[:'isSamlServiceProvider'] unless attributes[:'isSamlServiceProvider'].nil?

      raise 'You cannot provide both :isSamlServiceProvider and :is_saml_service_provider' if attributes.key?(:'isSamlServiceProvider') && attributes.key?(:'is_saml_service_provider')

      self.is_saml_service_provider = attributes[:'is_saml_service_provider'] unless attributes[:'is_saml_service_provider'].nil?

      self.is_web_tier_policy = attributes[:'isWebTierPolicy'] unless attributes[:'isWebTierPolicy'].nil?

      raise 'You cannot provide both :isWebTierPolicy and :is_web_tier_policy' if attributes.key?(:'isWebTierPolicy') && attributes.key?(:'is_web_tier_policy')

      self.is_web_tier_policy = attributes[:'is_web_tier_policy'] unless attributes[:'is_web_tier_policy'].nil?

      self.is_kerberos_realm = attributes[:'isKerberosRealm'] unless attributes[:'isKerberosRealm'].nil?

      raise 'You cannot provide both :isKerberosRealm and :is_kerberos_realm' if attributes.key?(:'isKerberosRealm') && attributes.key?(:'is_kerberos_realm')

      self.is_kerberos_realm = attributes[:'is_kerberos_realm'] unless attributes[:'is_kerberos_realm'].nil?

      self.icon = attributes[:'icon'] if attributes[:'icon']

      self.is_alias_app = attributes[:'isAliasApp'] unless attributes[:'isAliasApp'].nil?

      raise 'You cannot provide both :isAliasApp and :is_alias_app' if attributes.key?(:'isAliasApp') && attributes.key?(:'is_alias_app')

      self.is_alias_app = attributes[:'is_alias_app'] unless attributes[:'is_alias_app'].nil?

      self.is_managed_app = attributes[:'isManagedApp'] unless attributes[:'isManagedApp'].nil?

      raise 'You cannot provide both :isManagedApp and :is_managed_app' if attributes.key?(:'isManagedApp') && attributes.key?(:'is_managed_app')

      self.is_managed_app = attributes[:'is_managed_app'] unless attributes[:'is_managed_app'].nil?

      self.service_type_urn = attributes[:'serviceTypeURN'] if attributes[:'serviceTypeURN']

      raise 'You cannot provide both :serviceTypeURN and :service_type_urn' if attributes.key?(:'serviceTypeURN') && attributes.key?(:'service_type_urn')

      self.service_type_urn = attributes[:'service_type_urn'] if attributes[:'service_type_urn']

      self.service_type_version = attributes[:'serviceTypeVersion'] if attributes[:'serviceTypeVersion']

      raise 'You cannot provide both :serviceTypeVersion and :service_type_version' if attributes.key?(:'serviceTypeVersion') && attributes.key?(:'service_type_version')

      self.service_type_version = attributes[:'service_type_version'] if attributes[:'service_type_version']

      self.is_obligation_capable = attributes[:'isObligationCapable'] unless attributes[:'isObligationCapable'].nil?

      raise 'You cannot provide both :isObligationCapable and :is_obligation_capable' if attributes.key?(:'isObligationCapable') && attributes.key?(:'is_obligation_capable')

      self.is_obligation_capable = attributes[:'is_obligation_capable'] unless attributes[:'is_obligation_capable'].nil?

      self.ready_to_upgrade = attributes[:'readyToUpgrade'] unless attributes[:'readyToUpgrade'].nil?

      raise 'You cannot provide both :readyToUpgrade and :ready_to_upgrade' if attributes.key?(:'readyToUpgrade') && attributes.key?(:'ready_to_upgrade')

      self.ready_to_upgrade = attributes[:'ready_to_upgrade'] unless attributes[:'ready_to_upgrade'].nil?

      self.trust_scope = attributes[:'trustScope'] if attributes[:'trustScope']

      raise 'You cannot provide both :trustScope and :trust_scope' if attributes.key?(:'trustScope') && attributes.key?(:'trust_scope')

      self.trust_scope = attributes[:'trust_scope'] if attributes[:'trust_scope']

      self.is_database_service = attributes[:'isDatabaseService'] unless attributes[:'isDatabaseService'].nil?

      raise 'You cannot provide both :isDatabaseService and :is_database_service' if attributes.key?(:'isDatabaseService') && attributes.key?(:'is_database_service')

      self.is_database_service = attributes[:'is_database_service'] unless attributes[:'is_database_service'].nil?

      self.secondary_audiences = attributes[:'secondaryAudiences'] if attributes[:'secondaryAudiences']

      raise 'You cannot provide both :secondaryAudiences and :secondary_audiences' if attributes.key?(:'secondaryAudiences') && attributes.key?(:'secondary_audiences')

      self.secondary_audiences = attributes[:'secondary_audiences'] if attributes[:'secondary_audiences']

      self.is_enterprise_app = attributes[:'isEnterpriseApp'] unless attributes[:'isEnterpriseApp'].nil?

      raise 'You cannot provide both :isEnterpriseApp and :is_enterprise_app' if attributes.key?(:'isEnterpriseApp') && attributes.key?(:'is_enterprise_app')

      self.is_enterprise_app = attributes[:'is_enterprise_app'] unless attributes[:'is_enterprise_app'].nil?

      self.bypass_consent = attributes[:'bypassConsent'] unless attributes[:'bypassConsent'].nil?

      raise 'You cannot provide both :bypassConsent and :bypass_consent' if attributes.key?(:'bypassConsent') && attributes.key?(:'bypass_consent')

      self.bypass_consent = attributes[:'bypass_consent'] unless attributes[:'bypass_consent'].nil?

      self.disable_kmsi_token_authentication = attributes[:'disableKmsiTokenAuthentication'] unless attributes[:'disableKmsiTokenAuthentication'].nil?

      raise 'You cannot provide both :disableKmsiTokenAuthentication and :disable_kmsi_token_authentication' if attributes.key?(:'disableKmsiTokenAuthentication') && attributes.key?(:'disable_kmsi_token_authentication')

      self.disable_kmsi_token_authentication = attributes[:'disable_kmsi_token_authentication'] unless attributes[:'disable_kmsi_token_authentication'].nil?

      self.is_multicloud_service_app = attributes[:'isMulticloudServiceApp'] unless attributes[:'isMulticloudServiceApp'].nil?

      raise 'You cannot provide both :isMulticloudServiceApp and :is_multicloud_service_app' if attributes.key?(:'isMulticloudServiceApp') && attributes.key?(:'is_multicloud_service_app')

      self.is_multicloud_service_app = attributes[:'is_multicloud_service_app'] unless attributes[:'is_multicloud_service_app'].nil?

      self.radius_policy = attributes[:'radiusPolicy'] if attributes[:'radiusPolicy']

      raise 'You cannot provide both :radiusPolicy and :radius_policy' if attributes.key?(:'radiusPolicy') && attributes.key?(:'radius_policy')

      self.radius_policy = attributes[:'radius_policy'] if attributes[:'radius_policy']

      self.apps_network_perimeters = attributes[:'appsNetworkPerimeters'] if attributes[:'appsNetworkPerimeters']

      raise 'You cannot provide both :appsNetworkPerimeters and :apps_network_perimeters' if attributes.key?(:'appsNetworkPerimeters') && attributes.key?(:'apps_network_perimeters')

      self.apps_network_perimeters = attributes[:'apps_network_perimeters'] if attributes[:'apps_network_perimeters']

      self.cloud_control_properties = attributes[:'cloudControlProperties'] if attributes[:'cloudControlProperties']

      raise 'You cannot provide both :cloudControlProperties and :cloud_control_properties' if attributes.key?(:'cloudControlProperties') && attributes.key?(:'cloud_control_properties')

      self.cloud_control_properties = attributes[:'cloud_control_properties'] if attributes[:'cloud_control_properties']

      self.editable_attributes = attributes[:'editableAttributes'] if attributes[:'editableAttributes']

      raise 'You cannot provide both :editableAttributes and :editable_attributes' if attributes.key?(:'editableAttributes') && attributes.key?(:'editable_attributes')

      self.editable_attributes = attributes[:'editable_attributes'] if attributes[:'editable_attributes']

      self.terms_of_use = attributes[:'termsOfUse'] if attributes[:'termsOfUse']

      raise 'You cannot provide both :termsOfUse and :terms_of_use' if attributes.key?(:'termsOfUse') && attributes.key?(:'terms_of_use')

      self.terms_of_use = attributes[:'terms_of_use'] if attributes[:'terms_of_use']

      self.protectable_secondary_audiences = attributes[:'protectableSecondaryAudiences'] if attributes[:'protectableSecondaryAudiences']

      raise 'You cannot provide both :protectableSecondaryAudiences and :protectable_secondary_audiences' if attributes.key?(:'protectableSecondaryAudiences') && attributes.key?(:'protectable_secondary_audiences')

      self.protectable_secondary_audiences = attributes[:'protectable_secondary_audiences'] if attributes[:'protectable_secondary_audiences']

      self.idp_policy = attributes[:'idpPolicy'] if attributes[:'idpPolicy']

      raise 'You cannot provide both :idpPolicy and :idp_policy' if attributes.key?(:'idpPolicy') && attributes.key?(:'idp_policy')

      self.idp_policy = attributes[:'idp_policy'] if attributes[:'idp_policy']

      self.allowed_tags = attributes[:'allowedTags'] if attributes[:'allowedTags']

      raise 'You cannot provide both :allowedTags and :allowed_tags' if attributes.key?(:'allowedTags') && attributes.key?(:'allowed_tags')

      self.allowed_tags = attributes[:'allowed_tags'] if attributes[:'allowed_tags']

      self.app_signon_policy = attributes[:'appSignonPolicy'] if attributes[:'appSignonPolicy']

      raise 'You cannot provide both :appSignonPolicy and :app_signon_policy' if attributes.key?(:'appSignonPolicy') && attributes.key?(:'app_signon_policy')

      self.app_signon_policy = attributes[:'app_signon_policy'] if attributes[:'app_signon_policy']

      self.trust_policies = attributes[:'trustPolicies'] if attributes[:'trustPolicies']

      raise 'You cannot provide both :trustPolicies and :trust_policies' if attributes.key?(:'trustPolicies') && attributes.key?(:'trust_policies')

      self.trust_policies = attributes[:'trust_policies'] if attributes[:'trust_policies']

      self.signon_policy = attributes[:'signonPolicy'] if attributes[:'signonPolicy']

      raise 'You cannot provide both :signonPolicy and :signon_policy' if attributes.key?(:'signonPolicy') && attributes.key?(:'signon_policy')

      self.signon_policy = attributes[:'signon_policy'] if attributes[:'signon_policy']

      self.identity_providers = attributes[:'identityProviders'] if attributes[:'identityProviders']

      raise 'You cannot provide both :identityProviders and :identity_providers' if attributes.key?(:'identityProviders') && attributes.key?(:'identity_providers')

      self.identity_providers = attributes[:'identity_providers'] if attributes[:'identity_providers']

      self.accounts = attributes[:'accounts'] if attributes[:'accounts']

      self.grants = attributes[:'grants'] if attributes[:'grants']

      self.service_params = attributes[:'serviceParams'] if attributes[:'serviceParams']

      raise 'You cannot provide both :serviceParams and :service_params' if attributes.key?(:'serviceParams') && attributes.key?(:'service_params')

      self.service_params = attributes[:'service_params'] if attributes[:'service_params']

      self.attr_rendering_metadata = attributes[:'attrRenderingMetadata'] if attributes[:'attrRenderingMetadata']

      raise 'You cannot provide both :attrRenderingMetadata and :attr_rendering_metadata' if attributes.key?(:'attrRenderingMetadata') && attributes.key?(:'attr_rendering_metadata')

      self.attr_rendering_metadata = attributes[:'attr_rendering_metadata'] if attributes[:'attr_rendering_metadata']

      self.based_on_template = attributes[:'basedOnTemplate'] if attributes[:'basedOnTemplate']

      raise 'You cannot provide both :basedOnTemplate and :based_on_template' if attributes.key?(:'basedOnTemplate') && attributes.key?(:'based_on_template')

      self.based_on_template = attributes[:'based_on_template'] if attributes[:'based_on_template']

      self.granted_app_roles = attributes[:'grantedAppRoles'] if attributes[:'grantedAppRoles']

      raise 'You cannot provide both :grantedAppRoles and :granted_app_roles' if attributes.key?(:'grantedAppRoles') && attributes.key?(:'granted_app_roles')

      self.granted_app_roles = attributes[:'granted_app_roles'] if attributes[:'granted_app_roles']

      self.saml_service_provider = attributes[:'samlServiceProvider'] if attributes[:'samlServiceProvider']

      raise 'You cannot provide both :samlServiceProvider and :saml_service_provider' if attributes.key?(:'samlServiceProvider') && attributes.key?(:'saml_service_provider')

      self.saml_service_provider = attributes[:'saml_service_provider'] if attributes[:'saml_service_provider']

      self.allowed_scopes = attributes[:'allowedScopes'] if attributes[:'allowedScopes']

      raise 'You cannot provide both :allowedScopes and :allowed_scopes' if attributes.key?(:'allowedScopes') && attributes.key?(:'allowed_scopes')

      self.allowed_scopes = attributes[:'allowed_scopes'] if attributes[:'allowed_scopes']

      self.certificates = attributes[:'certificates'] if attributes[:'certificates']

      self.alias_apps = attributes[:'aliasApps'] if attributes[:'aliasApps']

      raise 'You cannot provide both :aliasApps and :alias_apps' if attributes.key?(:'aliasApps') && attributes.key?(:'alias_apps')

      self.alias_apps = attributes[:'alias_apps'] if attributes[:'alias_apps']

      self.as_opc_service = attributes[:'asOPCService'] if attributes[:'asOPCService']

      raise 'You cannot provide both :asOPCService and :as_opc_service' if attributes.key?(:'asOPCService') && attributes.key?(:'as_opc_service')

      self.as_opc_service = attributes[:'as_opc_service'] if attributes[:'as_opc_service']

      self.admin_roles = attributes[:'adminRoles'] if attributes[:'adminRoles']

      raise 'You cannot provide both :adminRoles and :admin_roles' if attributes.key?(:'adminRoles') && attributes.key?(:'admin_roles')

      self.admin_roles = attributes[:'admin_roles'] if attributes[:'admin_roles']

      self.user_roles = attributes[:'userRoles'] if attributes[:'userRoles']

      raise 'You cannot provide both :userRoles and :user_roles' if attributes.key?(:'userRoles') && attributes.key?(:'user_roles')

      self.user_roles = attributes[:'user_roles'] if attributes[:'user_roles']

      self.scopes = attributes[:'scopes'] if attributes[:'scopes']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:radiusApp:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:radiusApp:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:radiusApp:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:radiusApp:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:samlServiceProvider:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:samlServiceProvider:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:samlServiceProvider:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:samlServiceProvider:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:webTierPolicy:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:webTierPolicy:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:webTierPolicy:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:webTierPolicy:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:managedapp:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:managedapp:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:managedapp:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:managedapp:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillAppTemplate:AppTemplate'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillAppTemplate:AppTemplate']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillAppTemplate:AppTemplate and :urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillAppTemplate:AppTemplate') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:opcService:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:opcService:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:opcService:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:opcService:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:kerberosRealm:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:kerberosRealm:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:kerberosRealm:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:kerberosRealm:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:requestable:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:requestable:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:requestable:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:requestable:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillApp:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillApp:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillApp:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:formFillApp:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:dbcs:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:dbcs:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:dbcs:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:dbcs:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:enterpriseApp:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:enterpriseApp:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:enterpriseApp:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:enterpriseApp:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:OCITags'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:OCITags']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:OCITags and :urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:OCITags') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags']

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app = attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:multicloudServiceApp:App'] if attributes[:'urn:ietf:params:scim:schemas:oracle:idcs:extension:multicloudServiceApp:App']

      raise 'You cannot provide both :urn:ietf:params:scim:schemas:oracle:idcs:extension:multicloudServiceApp:App and :urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app' if attributes.key?(:'urn:ietf:params:scim:schemas:oracle:idcs:extension:multicloudServiceApp:App') && attributes.key?(:'urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app')

      self.urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app = attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app'] if attributes[:'urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] idcs_prevented_operations Object to be assigned
    def idcs_prevented_operations=(idcs_prevented_operations)
      # rubocop:disable Style/ConditionalAssignment
      if idcs_prevented_operations.nil?
        @idcs_prevented_operations = nil
      else
        @idcs_prevented_operations =
          idcs_prevented_operations.collect do |item|
            if IDCS_PREVENTED_OPERATIONS_ENUM.include?(item)
              item
            else
              OCI.logger.debug("Unknown value for 'idcs_prevented_operations' [#{item}]. Mapping to 'IDCS_PREVENTED_OPERATIONS_UNKNOWN_ENUM_VALUE'") if OCI.logger
              IDCS_PREVENTED_OPERATIONS_UNKNOWN_ENUM_VALUE
            end
          end
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] login_mechanism Object to be assigned
    def login_mechanism=(login_mechanism)
      # rubocop:disable Style/ConditionalAssignment
      if login_mechanism && !LOGIN_MECHANISM_ENUM.include?(login_mechanism)
        OCI.logger.debug("Unknown value for 'login_mechanism' [" + login_mechanism + "]. Mapping to 'LOGIN_MECHANISM_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @login_mechanism = LOGIN_MECHANISM_UNKNOWN_ENUM_VALUE
      else
        @login_mechanism = login_mechanism
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] client_type Object to be assigned
    def client_type=(client_type)
      # rubocop:disable Style/ConditionalAssignment
      if client_type && !CLIENT_TYPE_ENUM.include?(client_type)
        OCI.logger.debug("Unknown value for 'client_type' [" + client_type + "]. Mapping to 'CLIENT_TYPE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @client_type = CLIENT_TYPE_UNKNOWN_ENUM_VALUE
      else
        @client_type = client_type
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] allowed_operations Object to be assigned
    def allowed_operations=(allowed_operations)
      # rubocop:disable Style/ConditionalAssignment
      if allowed_operations.nil?
        @allowed_operations = nil
      else
        @allowed_operations =
          allowed_operations.collect do |item|
            if ALLOWED_OPERATIONS_ENUM.include?(item)
              item
            else
              OCI.logger.debug("Unknown value for 'allowed_operations' [#{item}]. Mapping to 'ALLOWED_OPERATIONS_UNKNOWN_ENUM_VALUE'") if OCI.logger
              ALLOWED_OPERATIONS_UNKNOWN_ENUM_VALUE
            end
          end
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] client_ip_checking Object to be assigned
    def client_ip_checking=(client_ip_checking)
      # rubocop:disable Style/ConditionalAssignment
      if client_ip_checking && !CLIENT_IP_CHECKING_ENUM.include?(client_ip_checking)
        OCI.logger.debug("Unknown value for 'client_ip_checking' [" + client_ip_checking + "]. Mapping to 'CLIENT_IP_CHECKING_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @client_ip_checking = CLIENT_IP_CHECKING_UNKNOWN_ENUM_VALUE
      else
        @client_ip_checking = client_ip_checking
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] trust_scope Object to be assigned
    def trust_scope=(trust_scope)
      # rubocop:disable Style/ConditionalAssignment
      if trust_scope && !TRUST_SCOPE_ENUM.include?(trust_scope)
        OCI.logger.debug("Unknown value for 'trust_scope' [" + trust_scope + "]. Mapping to 'TRUST_SCOPE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @trust_scope = TRUST_SCOPE_UNKNOWN_ENUM_VALUE
      else
        @trust_scope = trust_scope
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        id == other.id &&
        ocid == other.ocid &&
        schemas == other.schemas &&
        meta == other.meta &&
        idcs_created_by == other.idcs_created_by &&
        idcs_last_modified_by == other.idcs_last_modified_by &&
        idcs_prevented_operations == other.idcs_prevented_operations &&
        tags == other.tags &&
        delete_in_progress == other.delete_in_progress &&
        idcs_last_upgraded_in_release == other.idcs_last_upgraded_in_release &&
        domain_ocid == other.domain_ocid &&
        compartment_ocid == other.compartment_ocid &&
        tenancy_ocid == other.tenancy_ocid &&
        meter_as_opc_service == other.meter_as_opc_service &&
        name == other.name &&
        client_secret == other.client_secret &&
        hashed_client_secret == other.hashed_client_secret &&
        display_name == other.display_name &&
        description == other.description &&
        id_token_enc_algo == other.id_token_enc_algo &&
        delegated_service_names == other.delegated_service_names &&
        active == other.active &&
        app_icon == other.app_icon &&
        app_thumbnail == other.app_thumbnail &&
        migrated == other.migrated &&
        infrastructure == other.infrastructure &&
        is_login_target == other.is_login_target &&
        show_in_my_apps == other.show_in_my_apps &&
        login_mechanism == other.login_mechanism &&
        landing_page_url == other.landing_page_url &&
        product_logo_url == other.product_logo_url &&
        privacy_policy_url == other.privacy_policy_url &&
        terms_of_service_url == other.terms_of_service_url &&
        contact_email_address == other.contact_email_address &&
        product_name == other.product_name &&
        home_page_url == other.home_page_url &&
        is_form_fill == other.is_form_fill &&
        is_o_auth_client == other.is_o_auth_client &&
        is_radius_app == other.is_radius_app &&
        client_type == other.client_type &&
        redirect_uris == other.redirect_uris &&
        all_url_schemes_allowed == other.all_url_schemes_allowed &&
        logout_uri == other.logout_uri &&
        post_logout_redirect_uris == other.post_logout_redirect_uris &&
        allowed_grants == other.allowed_grants &&
        allowed_operations == other.allowed_operations &&
        client_ip_checking == other.client_ip_checking &&
        is_opc_service == other.is_opc_service &&
        is_unmanaged_app == other.is_unmanaged_app &&
        allow_access_control == other.allow_access_control &&
        is_o_auth_resource == other.is_o_auth_resource &&
        access_token_expiry == other.access_token_expiry &&
        refresh_token_expiry == other.refresh_token_expiry &&
        allow_offline == other.allow_offline &&
        callback_service_url == other.callback_service_url &&
        audience == other.audience &&
        is_mobile_target == other.is_mobile_target &&
        login_page_url == other.login_page_url &&
        linking_callback_url == other.linking_callback_url &&
        logout_page_url == other.logout_page_url &&
        error_page_url == other.error_page_url &&
        is_saml_service_provider == other.is_saml_service_provider &&
        is_web_tier_policy == other.is_web_tier_policy &&
        is_kerberos_realm == other.is_kerberos_realm &&
        icon == other.icon &&
        is_alias_app == other.is_alias_app &&
        is_managed_app == other.is_managed_app &&
        service_type_urn == other.service_type_urn &&
        service_type_version == other.service_type_version &&
        is_obligation_capable == other.is_obligation_capable &&
        ready_to_upgrade == other.ready_to_upgrade &&
        trust_scope == other.trust_scope &&
        is_database_service == other.is_database_service &&
        secondary_audiences == other.secondary_audiences &&
        is_enterprise_app == other.is_enterprise_app &&
        bypass_consent == other.bypass_consent &&
        disable_kmsi_token_authentication == other.disable_kmsi_token_authentication &&
        is_multicloud_service_app == other.is_multicloud_service_app &&
        radius_policy == other.radius_policy &&
        apps_network_perimeters == other.apps_network_perimeters &&
        cloud_control_properties == other.cloud_control_properties &&
        editable_attributes == other.editable_attributes &&
        terms_of_use == other.terms_of_use &&
        protectable_secondary_audiences == other.protectable_secondary_audiences &&
        idp_policy == other.idp_policy &&
        allowed_tags == other.allowed_tags &&
        app_signon_policy == other.app_signon_policy &&
        trust_policies == other.trust_policies &&
        signon_policy == other.signon_policy &&
        identity_providers == other.identity_providers &&
        accounts == other.accounts &&
        grants == other.grants &&
        service_params == other.service_params &&
        attr_rendering_metadata == other.attr_rendering_metadata &&
        based_on_template == other.based_on_template &&
        granted_app_roles == other.granted_app_roles &&
        saml_service_provider == other.saml_service_provider &&
        allowed_scopes == other.allowed_scopes &&
        certificates == other.certificates &&
        alias_apps == other.alias_apps &&
        as_opc_service == other.as_opc_service &&
        admin_roles == other.admin_roles &&
        user_roles == other.user_roles &&
        scopes == other.scopes &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags &&
        urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app == other.urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, ocid, schemas, meta, idcs_created_by, idcs_last_modified_by, idcs_prevented_operations, tags, delete_in_progress, idcs_last_upgraded_in_release, domain_ocid, compartment_ocid, tenancy_ocid, meter_as_opc_service, name, client_secret, hashed_client_secret, display_name, description, id_token_enc_algo, delegated_service_names, active, app_icon, app_thumbnail, migrated, infrastructure, is_login_target, show_in_my_apps, login_mechanism, landing_page_url, product_logo_url, privacy_policy_url, terms_of_service_url, contact_email_address, product_name, home_page_url, is_form_fill, is_o_auth_client, is_radius_app, client_type, redirect_uris, all_url_schemes_allowed, logout_uri, post_logout_redirect_uris, allowed_grants, allowed_operations, client_ip_checking, is_opc_service, is_unmanaged_app, allow_access_control, is_o_auth_resource, access_token_expiry, refresh_token_expiry, allow_offline, callback_service_url, audience, is_mobile_target, login_page_url, linking_callback_url, logout_page_url, error_page_url, is_saml_service_provider, is_web_tier_policy, is_kerberos_realm, icon, is_alias_app, is_managed_app, service_type_urn, service_type_version, is_obligation_capable, ready_to_upgrade, trust_scope, is_database_service, secondary_audiences, is_enterprise_app, bypass_consent, disable_kmsi_token_authentication, is_multicloud_service_app, radius_policy, apps_network_perimeters, cloud_control_properties, editable_attributes, terms_of_use, protectable_secondary_audiences, idp_policy, allowed_tags, app_signon_policy, trust_policies, signon_policy, identity_providers, accounts, grants, service_params, attr_rendering_metadata, based_on_template, granted_app_roles, saml_service_provider, allowed_scopes, certificates, alias_apps, as_opc_service, admin_roles, user_roles, scopes, urn_ietf_params_scim_schemas_oracle_idcs_extension_radius_app_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_saml_service_provider_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_web_tier_policy_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_managedapp_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_template_app_template, urn_ietf_params_scim_schemas_oracle_idcs_extension_opc_service_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_kerberos_realm_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_requestable_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_form_fill_app_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_dbcs_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_enterprise_app_app, urn_ietf_params_scim_schemas_oracle_idcs_extension_oci_tags, urn_ietf_params_scim_schemas_oracle_idcs_extension_multicloud_service_app_app].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
