# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200601

module OCI
  module LogAnalytics
    # Module containing models for requests made to, and responses received from,
    # OCI LogAnalytics services
    module Models
    end
  end
end

# Require models
require 'oci/log_analytics/models/abstract_column'
require 'oci/log_analytics/models/abstract_command_descriptor'
require 'oci/log_analytics/models/abstract_field'
require 'oci/log_analytics/models/abstract_parser_test_result_log_entry'
require 'oci/log_analytics/models/abstract_parser_test_result_log_line'
require 'oci/log_analytics/models/action'
require 'oci/log_analytics/models/action_types'
require 'oci/log_analytics/models/add_entity_association_details'
require 'oci/log_analytics/models/add_fields_command_descriptor'
require 'oci/log_analytics/models/add_insights_command_descriptor'
require 'oci/log_analytics/models/anomaly_command_descriptor'
require 'oci/log_analytics/models/archiving_configuration'
require 'oci/log_analytics/models/argument'
require 'oci/log_analytics/models/assign_encryption_key_details'
require 'oci/log_analytics/models/associable_entity'
require 'oci/log_analytics/models/associable_entity_collection'
require 'oci/log_analytics/models/association_property'
require 'oci/log_analytics/models/association_summary_report'
require 'oci/log_analytics/models/auto_association_collection'
require 'oci/log_analytics/models/auto_association_state'
require 'oci/log_analytics/models/auto_lookups'
require 'oci/log_analytics/models/bottom_command_descriptor'
require 'oci/log_analytics/models/bucket_command_descriptor'
require 'oci/log_analytics/models/bucket_range'
require 'oci/log_analytics/models/change_ingest_time_rule_compartment_details'
require 'oci/log_analytics/models/change_log_analytics_em_bridge_compartment_details'
require 'oci/log_analytics/models/change_log_analytics_entity_compartment_details'
require 'oci/log_analytics/models/change_log_analytics_log_group_compartment_details'
require 'oci/log_analytics/models/change_log_analytics_object_collection_rule_compartment_details'
require 'oci/log_analytics/models/change_scheduled_task_compartment_details'
require 'oci/log_analytics/models/char_encoding_collection'
require 'oci/log_analytics/models/chart_column'
require 'oci/log_analytics/models/chart_data_column'
require 'oci/log_analytics/models/classify_column'
require 'oci/log_analytics/models/classify_command_descriptor'
require 'oci/log_analytics/models/cluster_command_descriptor'
require 'oci/log_analytics/models/cluster_compare_command_descriptor'
require 'oci/log_analytics/models/cluster_details_command_descriptor'
require 'oci/log_analytics/models/cluster_split_command_descriptor'
require 'oci/log_analytics/models/column'
require 'oci/log_analytics/models/column_name'
require 'oci/log_analytics/models/column_name_collection'
require 'oci/log_analytics/models/command_descriptor'
require 'oci/log_analytics/models/compare_command_descriptor'
require 'oci/log_analytics/models/compare_content_details'
require 'oci/log_analytics/models/compare_content_result'
require 'oci/log_analytics/models/compare_line_result'
require 'oci/log_analytics/models/condition_block'
require 'oci/log_analytics/models/config_lifecycle_state'
require 'oci/log_analytics/models/create_acceleration_task_details'
require 'oci/log_analytics/models/create_ingest_time_rule_details'
require 'oci/log_analytics/models/create_log_analytics_em_bridge_details'
require 'oci/log_analytics/models/create_log_analytics_entity_details'
require 'oci/log_analytics/models/create_log_analytics_entity_type_details'
require 'oci/log_analytics/models/create_log_analytics_log_group_details'
require 'oci/log_analytics/models/create_log_analytics_object_collection_rule_details'
require 'oci/log_analytics/models/create_scheduled_task_details'
require 'oci/log_analytics/models/create_standard_task_details'
require 'oci/log_analytics/models/create_view_command_descriptor'
require 'oci/log_analytics/models/creation_source'
require 'oci/log_analytics/models/creation_source_type'
require 'oci/log_analytics/models/credential_endpoint'
require 'oci/log_analytics/models/cron_schedule'
require 'oci/log_analytics/models/dedup_command_descriptor'
require 'oci/log_analytics/models/delete_command_descriptor'
require 'oci/log_analytics/models/delete_log_analytics_association'
require 'oci/log_analytics/models/delete_log_analytics_association_details'
require 'oci/log_analytics/models/delta_command_descriptor'
require 'oci/log_analytics/models/demo_mode_command_descriptor'
require 'oci/log_analytics/models/disable_auto_association_detail'
require 'oci/log_analytics/models/disable_auto_association_details'
require 'oci/log_analytics/models/distinct_command_descriptor'
require 'oci/log_analytics/models/efd_regex_result'
require 'oci/log_analytics/models/effective_property_collection'
require 'oci/log_analytics/models/effective_property_summary'
require 'oci/log_analytics/models/em_bridge_latest_import_processing_status'
require 'oci/log_analytics/models/em_bridge_lifecycle_states'
require 'oci/log_analytics/models/enable_auto_association_detail'
require 'oci/log_analytics/models/enable_auto_association_details'
require 'oci/log_analytics/models/encryption_key_info_collection'
require 'oci/log_analytics/models/encryption_key_info_summary'
require 'oci/log_analytics/models/encryption_key_source'
require 'oci/log_analytics/models/encryption_key_type'
require 'oci/log_analytics/models/endpoint_credentials'
require 'oci/log_analytics/models/endpoint_proxy'
require 'oci/log_analytics/models/endpoint_request'
require 'oci/log_analytics/models/endpoint_response'
require 'oci/log_analytics/models/endpoint_result'
require 'oci/log_analytics/models/entity_cloud_type'
require 'oci/log_analytics/models/entity_lifecycle_states'
require 'oci/log_analytics/models/entity_type_property'
require 'oci/log_analytics/models/error_details'
require 'oci/log_analytics/models/estimate_purge_data_size_details'
require 'oci/log_analytics/models/estimate_purge_data_size_result'
require 'oci/log_analytics/models/estimate_recall_data_size_details'
require 'oci/log_analytics/models/estimate_recall_data_size_result'
require 'oci/log_analytics/models/estimate_release_data_size_details'
require 'oci/log_analytics/models/estimate_release_data_size_result'
require 'oci/log_analytics/models/eval_command_descriptor'
require 'oci/log_analytics/models/event_stats_command_descriptor'
require 'oci/log_analytics/models/event_type'
require 'oci/log_analytics/models/event_type_collection'
require 'oci/log_analytics/models/event_type_details'
require 'oci/log_analytics/models/export_content'
require 'oci/log_analytics/models/export_details'
require 'oci/log_analytics/models/extended_fields_validation_result'
require 'oci/log_analytics/models/extract_command_descriptor'
require 'oci/log_analytics/models/extract_log_field_results'
require 'oci/log_analytics/models/extract_log_header_details'
require 'oci/log_analytics/models/extract_log_header_results'
require 'oci/log_analytics/models/field'
require 'oci/log_analytics/models/field_argument'
require 'oci/log_analytics/models/field_summary_command_descriptor'
require 'oci/log_analytics/models/field_summary_report'
require 'oci/log_analytics/models/field_value'
require 'oci/log_analytics/models/fields_add_remove_field'
require 'oci/log_analytics/models/fields_command_descriptor'
require 'oci/log_analytics/models/file_validation_response'
require 'oci/log_analytics/models/filter'
require 'oci/log_analytics/models/filter_details'
require 'oci/log_analytics/models/filter_output'
require 'oci/log_analytics/models/fixed_frequency_schedule'
require 'oci/log_analytics/models/frequent_command_descriptor'
require 'oci/log_analytics/models/function_field'
require 'oci/log_analytics/models/geo_stats_command_descriptor'
require 'oci/log_analytics/models/head_command_descriptor'
require 'oci/log_analytics/models/highlight_command_descriptor'
require 'oci/log_analytics/models/highlight_groups_command_descriptor'
require 'oci/log_analytics/models/highlight_rows_command_descriptor'
require 'oci/log_analytics/models/indexes'
require 'oci/log_analytics/models/ingest_time_rule'
require 'oci/log_analytics/models/ingest_time_rule_action'
require 'oci/log_analytics/models/ingest_time_rule_additional_field_condition'
require 'oci/log_analytics/models/ingest_time_rule_condition'
require 'oci/log_analytics/models/ingest_time_rule_field_condition'
require 'oci/log_analytics/models/ingest_time_rule_metric_extraction_action'
require 'oci/log_analytics/models/ingest_time_rule_resource'
require 'oci/log_analytics/models/ingest_time_rule_summary'
require 'oci/log_analytics/models/ingest_time_rule_summary_collection'
require 'oci/log_analytics/models/job_mode'
require 'oci/log_analytics/models/job_mode_filter'
require 'oci/log_analytics/models/json_extract_command_descriptor'
require 'oci/log_analytics/models/label_names'
require 'oci/log_analytics/models/label_priority'
require 'oci/log_analytics/models/label_priority_collection'
require 'oci/log_analytics/models/label_source_collection'
require 'oci/log_analytics/models/label_source_summary'
require 'oci/log_analytics/models/label_summary_report'
require 'oci/log_analytics/models/level'
require 'oci/log_analytics/models/lifecycle_states'
require 'oci/log_analytics/models/link_command_descriptor'
require 'oci/log_analytics/models/link_details_command_descriptor'
require 'oci/log_analytics/models/literal_argument'
require 'oci/log_analytics/models/log_analytics_associated_entity'
require 'oci/log_analytics/models/log_analytics_associated_entity_collection'
require 'oci/log_analytics/models/log_analytics_association'
require 'oci/log_analytics/models/log_analytics_association_collection'
require 'oci/log_analytics/models/log_analytics_association_parameter'
require 'oci/log_analytics/models/log_analytics_association_parameter_collection'
require 'oci/log_analytics/models/log_analytics_category'
require 'oci/log_analytics/models/log_analytics_category_collection'
require 'oci/log_analytics/models/log_analytics_config_work_request'
require 'oci/log_analytics/models/log_analytics_config_work_request_collection'
require 'oci/log_analytics/models/log_analytics_config_work_request_payload'
require 'oci/log_analytics/models/log_analytics_config_work_request_summary'
require 'oci/log_analytics/models/log_analytics_em_bridge'
require 'oci/log_analytics/models/log_analytics_em_bridge_collection'
require 'oci/log_analytics/models/log_analytics_em_bridge_summary'
require 'oci/log_analytics/models/log_analytics_em_bridge_summary_report'
require 'oci/log_analytics/models/log_analytics_endpoint'
require 'oci/log_analytics/models/log_analytics_entity'
require 'oci/log_analytics/models/log_analytics_entity_collection'
require 'oci/log_analytics/models/log_analytics_entity_summary'
require 'oci/log_analytics/models/log_analytics_entity_summary_report'
require 'oci/log_analytics/models/log_analytics_entity_topology_collection'
require 'oci/log_analytics/models/log_analytics_entity_topology_link'
require 'oci/log_analytics/models/log_analytics_entity_topology_link_collection'
require 'oci/log_analytics/models/log_analytics_entity_topology_summary'
require 'oci/log_analytics/models/log_analytics_entity_type'
require 'oci/log_analytics/models/log_analytics_entity_type_collection'
require 'oci/log_analytics/models/log_analytics_entity_type_summary'
require 'oci/log_analytics/models/log_analytics_extended_field'
require 'oci/log_analytics/models/log_analytics_field'
require 'oci/log_analytics/models/log_analytics_field_collection'
require 'oci/log_analytics/models/log_analytics_field_summary'
require 'oci/log_analytics/models/log_analytics_import_custom_change_list'
require 'oci/log_analytics/models/log_analytics_import_custom_content'
require 'oci/log_analytics/models/log_analytics_label'
require 'oci/log_analytics/models/log_analytics_label_alias'
require 'oci/log_analytics/models/log_analytics_label_collection'
require 'oci/log_analytics/models/log_analytics_label_definition'
require 'oci/log_analytics/models/log_analytics_label_operator'
require 'oci/log_analytics/models/log_analytics_label_operator_collection'
require 'oci/log_analytics/models/log_analytics_label_summary'
require 'oci/log_analytics/models/log_analytics_label_view'
require 'oci/log_analytics/models/log_analytics_log_group'
require 'oci/log_analytics/models/log_analytics_log_group_summary'
require 'oci/log_analytics/models/log_analytics_log_group_summary_collection'
require 'oci/log_analytics/models/log_analytics_lookup'
require 'oci/log_analytics/models/log_analytics_lookup_collection'
require 'oci/log_analytics/models/log_analytics_lookup_fields'
require 'oci/log_analytics/models/log_analytics_meta_function'
require 'oci/log_analytics/models/log_analytics_meta_function_argument'
require 'oci/log_analytics/models/log_analytics_meta_function_collection'
require 'oci/log_analytics/models/log_analytics_meta_source_type'
require 'oci/log_analytics/models/log_analytics_meta_source_type_collection'
require 'oci/log_analytics/models/log_analytics_metric'
require 'oci/log_analytics/models/log_analytics_object_collection_rule'
require 'oci/log_analytics/models/log_analytics_object_collection_rule_collection'
require 'oci/log_analytics/models/log_analytics_object_collection_rule_summary'
require 'oci/log_analytics/models/log_analytics_operation_types'
require 'oci/log_analytics/models/log_analytics_parameter'
require 'oci/log_analytics/models/log_analytics_parser'
require 'oci/log_analytics/models/log_analytics_parser_collection'
require 'oci/log_analytics/models/log_analytics_parser_field'
require 'oci/log_analytics/models/log_analytics_parser_filter'
require 'oci/log_analytics/models/log_analytics_parser_function'
require 'oci/log_analytics/models/log_analytics_parser_function_collection'
require 'oci/log_analytics/models/log_analytics_parser_function_parameter'
require 'oci/log_analytics/models/log_analytics_parser_meta_plugin'
require 'oci/log_analytics/models/log_analytics_parser_meta_plugin_collection'
require 'oci/log_analytics/models/log_analytics_parser_meta_plugin_parameter'
require 'oci/log_analytics/models/log_analytics_parser_summary'
require 'oci/log_analytics/models/log_analytics_pattern_filter'
require 'oci/log_analytics/models/log_analytics_preference'
require 'oci/log_analytics/models/log_analytics_preference_collection'
require 'oci/log_analytics/models/log_analytics_preference_details'
require 'oci/log_analytics/models/log_analytics_property'
require 'oci/log_analytics/models/log_analytics_resource_category'
require 'oci/log_analytics/models/log_analytics_resource_category_collection'
require 'oci/log_analytics/models/log_analytics_resource_category_details'
require 'oci/log_analytics/models/log_analytics_source'
require 'oci/log_analytics/models/log_analytics_source_collection'
require 'oci/log_analytics/models/log_analytics_source_data_filter'
require 'oci/log_analytics/models/log_analytics_source_entity_type'
require 'oci/log_analytics/models/log_analytics_source_extended_field_definition'
require 'oci/log_analytics/models/log_analytics_source_extended_field_definition_collection'
require 'oci/log_analytics/models/log_analytics_source_function'
require 'oci/log_analytics/models/log_analytics_source_label_condition'
require 'oci/log_analytics/models/log_analytics_source_metadata_field'
require 'oci/log_analytics/models/log_analytics_source_metric'
require 'oci/log_analytics/models/log_analytics_source_pattern'
require 'oci/log_analytics/models/log_analytics_source_pattern_collection'
require 'oci/log_analytics/models/log_analytics_source_summary'
require 'oci/log_analytics/models/log_analytics_warning'
require 'oci/log_analytics/models/log_analytics_warning_collection'
require 'oci/log_analytics/models/log_endpoint'
require 'oci/log_analytics/models/log_group_summary_report'
require 'oci/log_analytics/models/log_list_endpoint'
require 'oci/log_analytics/models/log_list_type_endpoint'
require 'oci/log_analytics/models/log_set_collection'
require 'oci/log_analytics/models/log_set_key_types'
require 'oci/log_analytics/models/log_sets_count'
require 'oci/log_analytics/models/log_type_endpoint'
require 'oci/log_analytics/models/lookup_command_descriptor'
require 'oci/log_analytics/models/lookup_field'
require 'oci/log_analytics/models/lookup_summary_report'
require 'oci/log_analytics/models/macro_command_descriptor'
require 'oci/log_analytics/models/map_command_descriptor'
require 'oci/log_analytics/models/match_info'
require 'oci/log_analytics/models/metric_extraction'
require 'oci/log_analytics/models/module_command_descriptor'
require 'oci/log_analytics/models/multi_search_command_descriptor'
require 'oci/log_analytics/models/name_value_pair'
require 'oci/log_analytics/models/namespace'
require 'oci/log_analytics/models/namespace_collection'
require 'oci/log_analytics/models/namespace_summary'
require 'oci/log_analytics/models/nlp_command_descriptor'
require 'oci/log_analytics/models/object_collection_rule_collection_types'
require 'oci/log_analytics/models/object_collection_rule_lifecycle_states'
require 'oci/log_analytics/models/operation_status'
require 'oci/log_analytics/models/outlier_command_descriptor'
require 'oci/log_analytics/models/overlapping_recall_collection'
require 'oci/log_analytics/models/overlapping_recall_summary'
require 'oci/log_analytics/models/parse_query_details'
require 'oci/log_analytics/models/parse_query_output'
require 'oci/log_analytics/models/parsed_content'
require 'oci/log_analytics/models/parsed_field'
require 'oci/log_analytics/models/parser_summary_report'
require 'oci/log_analytics/models/parser_test_result'
require 'oci/log_analytics/models/pattern_override'
require 'oci/log_analytics/models/payload_type'
require 'oci/log_analytics/models/property_metadata_summary'
require 'oci/log_analytics/models/property_metadata_summary_collection'
require 'oci/log_analytics/models/property_override'
require 'oci/log_analytics/models/purge_action'
require 'oci/log_analytics/models/purge_storage_data_details'
require 'oci/log_analytics/models/query_aggregation'
require 'oci/log_analytics/models/query_details'
require 'oci/log_analytics/models/query_operation_type'
require 'oci/log_analytics/models/query_work_request'
require 'oci/log_analytics/models/query_work_request_collection'
require 'oci/log_analytics/models/query_work_request_summary'
require 'oci/log_analytics/models/rare_command_descriptor'
require 'oci/log_analytics/models/recall_archived_data_details'
require 'oci/log_analytics/models/recall_count'
require 'oci/log_analytics/models/recall_status'
require 'oci/log_analytics/models/recalled_data'
require 'oci/log_analytics/models/recalled_data_collection'
require 'oci/log_analytics/models/recalled_data_info'
require 'oci/log_analytics/models/recalled_data_size'
require 'oci/log_analytics/models/regex_command_descriptor'
require 'oci/log_analytics/models/regex_match_result'
require 'oci/log_analytics/models/release_recalled_data_details'
require 'oci/log_analytics/models/remove_entity_associations_details'
require 'oci/log_analytics/models/rename_command_descriptor'
require 'oci/log_analytics/models/result_column'
require 'oci/log_analytics/models/rule'
require 'oci/log_analytics/models/rule_kind'
require 'oci/log_analytics/models/rule_summary'
require 'oci/log_analytics/models/rule_summary_collection'
require 'oci/log_analytics/models/rule_summary_report'
require 'oci/log_analytics/models/schedule'
require 'oci/log_analytics/models/scheduled_task'
require 'oci/log_analytics/models/scheduled_task_collection'
require 'oci/log_analytics/models/scheduled_task_summary'
require 'oci/log_analytics/models/scheduler_resource'
require 'oci/log_analytics/models/scope_filter'
require 'oci/log_analytics/models/search_command_descriptor'
require 'oci/log_analytics/models/search_lookup_command_descriptor'
require 'oci/log_analytics/models/sort_command_descriptor'
require 'oci/log_analytics/models/sort_field'
require 'oci/log_analytics/models/source_mapping_response'
require 'oci/log_analytics/models/source_summary_report'
require 'oci/log_analytics/models/source_validate_details'
require 'oci/log_analytics/models/source_validate_results'
require 'oci/log_analytics/models/standard_task'
require 'oci/log_analytics/models/stats_command_descriptor'
require 'oci/log_analytics/models/status_summary'
require 'oci/log_analytics/models/step_info'
require 'oci/log_analytics/models/storage'
require 'oci/log_analytics/models/storage_data_type'
require 'oci/log_analytics/models/storage_operation_type'
require 'oci/log_analytics/models/storage_usage'
require 'oci/log_analytics/models/storage_work_request'
require 'oci/log_analytics/models/storage_work_request_collection'
require 'oci/log_analytics/models/storage_work_request_summary'
require 'oci/log_analytics/models/stream_action'
require 'oci/log_analytics/models/sub_system_name'
require 'oci/log_analytics/models/success'
require 'oci/log_analytics/models/suggest_details'
require 'oci/log_analytics/models/suggest_output'
require 'oci/log_analytics/models/table_column'
require 'oci/log_analytics/models/tail_command_descriptor'
require 'oci/log_analytics/models/task_type'
require 'oci/log_analytics/models/test_parser_payload_details'
require 'oci/log_analytics/models/time_cluster_column'
require 'oci/log_analytics/models/time_cluster_command_descriptor'
require 'oci/log_analytics/models/time_cluster_data_column'
require 'oci/log_analytics/models/time_column'
require 'oci/log_analytics/models/time_compare_command_descriptor'
require 'oci/log_analytics/models/time_range'
require 'oci/log_analytics/models/time_stats_cluster'
require 'oci/log_analytics/models/time_stats_column'
require 'oci/log_analytics/models/time_stats_command_descriptor'
require 'oci/log_analytics/models/time_stats_data_column'
require 'oci/log_analytics/models/timezone_collection'
require 'oci/log_analytics/models/top_command_descriptor'
require 'oci/log_analytics/models/trend_column'
require 'oci/log_analytics/models/ui_parser_test_metadata'
require 'oci/log_analytics/models/unprocessed_data_bucket'
require 'oci/log_analytics/models/update_log_analytics_em_bridge_details'
require 'oci/log_analytics/models/update_log_analytics_entity_details'
require 'oci/log_analytics/models/update_log_analytics_entity_type_details'
require 'oci/log_analytics/models/update_log_analytics_log_group_details'
require 'oci/log_analytics/models/update_log_analytics_object_collection_rule_details'
require 'oci/log_analytics/models/update_lookup_metadata_details'
require 'oci/log_analytics/models/update_scheduled_task_details'
require 'oci/log_analytics/models/update_standard_task_details'
require 'oci/log_analytics/models/update_storage_details'
require 'oci/log_analytics/models/upload'
require 'oci/log_analytics/models/upload_collection'
require 'oci/log_analytics/models/upload_file_collection'
require 'oci/log_analytics/models/upload_file_status'
require 'oci/log_analytics/models/upload_file_summary'
require 'oci/log_analytics/models/upload_summary'
require 'oci/log_analytics/models/upload_warning_collection'
require 'oci/log_analytics/models/upload_warning_summary'
require 'oci/log_analytics/models/upsert_log_analytics_association'
require 'oci/log_analytics/models/upsert_log_analytics_association_details'
require 'oci/log_analytics/models/upsert_log_analytics_field_details'
require 'oci/log_analytics/models/upsert_log_analytics_label_details'
require 'oci/log_analytics/models/upsert_log_analytics_parser_details'
require 'oci/log_analytics/models/upsert_log_analytics_source_details'
require 'oci/log_analytics/models/usage_status_item'
require 'oci/log_analytics/models/validate_endpoint_result'
require 'oci/log_analytics/models/validate_label_condition_details'
require 'oci/log_analytics/models/validate_label_condition_result'
require 'oci/log_analytics/models/value_type'
require 'oci/log_analytics/models/verify_output'
require 'oci/log_analytics/models/violation'
require 'oci/log_analytics/models/warning_reference_details'
require 'oci/log_analytics/models/where_command_descriptor'
require 'oci/log_analytics/models/work_request'
require 'oci/log_analytics/models/work_request_collection'
require 'oci/log_analytics/models/work_request_error'
require 'oci/log_analytics/models/work_request_error_collection'
require 'oci/log_analytics/models/work_request_log'
require 'oci/log_analytics/models/work_request_log_collection'
require 'oci/log_analytics/models/work_request_resource'
require 'oci/log_analytics/models/work_request_status'
require 'oci/log_analytics/models/work_request_summary'
require 'oci/log_analytics/models/xml_extract_command_descriptor'

# Require generated clients
require 'oci/log_analytics/log_analytics_client'
require 'oci/log_analytics/log_analytics_client_composite_operations'

# Require service utilities
require 'oci/log_analytics/util'
