# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200630

module OCI
  module Opsi
    # Module containing models for requests made to, and responses received from,
    # OCI Opsi services
    module Models
    end
  end
end

# Require models
require 'oci/opsi/models/action_type'
require 'oci/opsi/models/add_em_managed_external_exadata_insight_members_details'
require 'oci/opsi/models/add_exadata_insight_members_details'
require 'oci/opsi/models/add_pe_comanaged_exadata_insight_members_details'
require 'oci/opsi/models/addm_db_collection'
require 'oci/opsi/models/addm_db_finding_aggregation'
require 'oci/opsi/models/addm_db_finding_aggregation_collection'
require 'oci/opsi/models/addm_db_finding_category_collection'
require 'oci/opsi/models/addm_db_finding_category_summary'
require 'oci/opsi/models/addm_db_findings_time_series_collection'
require 'oci/opsi/models/addm_db_findings_time_series_summary'
require 'oci/opsi/models/addm_db_parameter_aggregation'
require 'oci/opsi/models/addm_db_parameter_aggregation_collection'
require 'oci/opsi/models/addm_db_parameter_category_collection'
require 'oci/opsi/models/addm_db_parameter_category_summary'
require 'oci/opsi/models/addm_db_parameter_change_aggregation'
require 'oci/opsi/models/addm_db_parameter_change_aggregation_collection'
require 'oci/opsi/models/addm_db_recommendation_aggregation'
require 'oci/opsi/models/addm_db_recommendation_aggregation_collection'
require 'oci/opsi/models/addm_db_recommendation_category_collection'
require 'oci/opsi/models/addm_db_recommendation_category_summary'
require 'oci/opsi/models/addm_db_recommendations_time_series_collection'
require 'oci/opsi/models/addm_db_recommendations_time_series_summary'
require 'oci/opsi/models/addm_db_schema_object_collection'
require 'oci/opsi/models/addm_db_schema_object_summary'
require 'oci/opsi/models/addm_db_sql_statement_collection'
require 'oci/opsi/models/addm_db_sql_statement_summary'
require 'oci/opsi/models/addm_db_summary'
require 'oci/opsi/models/addm_report'
require 'oci/opsi/models/archival_state'
require 'oci/opsi/models/autonomous_database_configuration_summary'
require 'oci/opsi/models/autonomous_database_insight'
require 'oci/opsi/models/autonomous_database_insight_summary'
require 'oci/opsi/models/awr_database_collection'
require 'oci/opsi/models/awr_database_cpu_usage_collection'
require 'oci/opsi/models/awr_database_cpu_usage_summary'
require 'oci/opsi/models/awr_database_metric_collection'
require 'oci/opsi/models/awr_database_metric_summary'
require 'oci/opsi/models/awr_database_parameter_change_collection'
require 'oci/opsi/models/awr_database_parameter_change_summary'
require 'oci/opsi/models/awr_database_parameter_collection'
require 'oci/opsi/models/awr_database_parameter_summary'
require 'oci/opsi/models/awr_database_report'
require 'oci/opsi/models/awr_database_snapshot_collection'
require 'oci/opsi/models/awr_database_snapshot_range_collection'
require 'oci/opsi/models/awr_database_snapshot_range_summary'
require 'oci/opsi/models/awr_database_snapshot_summary'
require 'oci/opsi/models/awr_database_sql_report'
require 'oci/opsi/models/awr_database_summary'
require 'oci/opsi/models/awr_database_sysstat_collection'
require 'oci/opsi/models/awr_database_sysstat_summary'
require 'oci/opsi/models/awr_database_top_wait_event_collection'
require 'oci/opsi/models/awr_database_top_wait_event_summary'
require 'oci/opsi/models/awr_database_wait_event_bucket_collection'
require 'oci/opsi/models/awr_database_wait_event_bucket_summary'
require 'oci/opsi/models/awr_database_wait_event_collection'
require 'oci/opsi/models/awr_database_wait_event_summary'
require 'oci/opsi/models/awr_hub'
require 'oci/opsi/models/awr_hub_lifecycle_state'
require 'oci/opsi/models/awr_hub_objects'
require 'oci/opsi/models/awr_hub_source'
require 'oci/opsi/models/awr_hub_source_lifecycle_state'
require 'oci/opsi/models/awr_hub_source_status'
require 'oci/opsi/models/awr_hub_source_summary'
require 'oci/opsi/models/awr_hub_source_summary_collection'
require 'oci/opsi/models/awr_hub_source_type'
require 'oci/opsi/models/awr_hub_sources'
require 'oci/opsi/models/awr_hub_summary'
require 'oci/opsi/models/awr_hub_summary_collection'
require 'oci/opsi/models/awr_hubs'
require 'oci/opsi/models/awr_query_result'
require 'oci/opsi/models/awr_report'
require 'oci/opsi/models/awr_report_format_type'
require 'oci/opsi/models/awr_snapshot_collection'
require 'oci/opsi/models/awr_snapshot_summary'
require 'oci/opsi/models/awr_source_summary'
require 'oci/opsi/models/basic_configuration_item_metadata'
require 'oci/opsi/models/basic_configuration_item_summary'
require 'oci/opsi/models/change_autonomous_database_insight_advanced_features_details'
require 'oci/opsi/models/change_awr_hub_source_compartment_details'
require 'oci/opsi/models/change_database_insight_compartment_details'
require 'oci/opsi/models/change_enterprise_manager_bridge_compartment_details'
require 'oci/opsi/models/change_exadata_insight_compartment_details'
require 'oci/opsi/models/change_host_insight_compartment_details'
require 'oci/opsi/models/change_news_report_compartment_details'
require 'oci/opsi/models/change_operations_insights_private_endpoint_compartment_details'
require 'oci/opsi/models/change_operations_insights_warehouse_compartment_details'
require 'oci/opsi/models/change_opsi_configuration_compartment_details'
require 'oci/opsi/models/change_pe_comanaged_database_insight_details'
require 'oci/opsi/models/cloud_importable_compute_entity_summary'
require 'oci/opsi/models/configuration_item_allowed_value_details'
require 'oci/opsi/models/configuration_item_allowed_value_type'
require 'oci/opsi/models/configuration_item_free_text_allowed_value_details'
require 'oci/opsi/models/configuration_item_limit_allowed_value_details'
require 'oci/opsi/models/configuration_item_metadata'
require 'oci/opsi/models/configuration_item_pick_allowed_value_details'
require 'oci/opsi/models/configuration_item_summary'
require 'oci/opsi/models/configuration_item_type'
require 'oci/opsi/models/configuration_item_unit_details'
require 'oci/opsi/models/configuration_item_value_source_configuration_type'
require 'oci/opsi/models/configuration_items_collection'
require 'oci/opsi/models/connection_details'
require 'oci/opsi/models/create_awr_hub_details'
require 'oci/opsi/models/create_awr_hub_source_details'
require 'oci/opsi/models/create_basic_configuration_item_details'
require 'oci/opsi/models/create_configuration_item_details'
require 'oci/opsi/models/create_database_insight_details'
require 'oci/opsi/models/create_em_managed_external_database_insight_details'
require 'oci/opsi/models/create_em_managed_external_exadata_insight_details'
require 'oci/opsi/models/create_em_managed_external_exadata_member_entity_details'
require 'oci/opsi/models/create_em_managed_external_host_insight_details'
require 'oci/opsi/models/create_enterprise_manager_bridge_details'
require 'oci/opsi/models/create_exadata_insight_details'
require 'oci/opsi/models/create_host_insight_details'
require 'oci/opsi/models/create_macs_managed_cloud_host_insight_details'
require 'oci/opsi/models/create_macs_managed_external_host_insight_details'
require 'oci/opsi/models/create_news_report_details'
require 'oci/opsi/models/create_operations_insights_private_endpoint_details'
require 'oci/opsi/models/create_operations_insights_warehouse_details'
require 'oci/opsi/models/create_operations_insights_warehouse_user_details'
require 'oci/opsi/models/create_opsi_configuration_details'
require 'oci/opsi/models/create_opsi_ux_configuration_details'
require 'oci/opsi/models/create_pe_comanaged_database_insight_details'
require 'oci/opsi/models/create_pe_comanaged_exadata_insight_details'
require 'oci/opsi/models/create_pe_comanaged_exadata_vmcluster_details'
require 'oci/opsi/models/credential_by_vault'
require 'oci/opsi/models/credential_details'
require 'oci/opsi/models/credentials_by_source'
require 'oci/opsi/models/db_external_instance'
require 'oci/opsi/models/db_external_properties'
require 'oci/opsi/models/dbos_config_instance'
require 'oci/opsi/models/db_parameters'
require 'oci/opsi/models/data_object_bind_parameter'
require 'oci/opsi/models/data_object_column_metadata'
require 'oci/opsi/models/data_object_column_unit'
require 'oci/opsi/models/data_object_core_column_unit'
require 'oci/opsi/models/data_object_custom_column_unit'
require 'oci/opsi/models/data_object_data_size_column_unit'
require 'oci/opsi/models/data_object_frequency_column_unit'
require 'oci/opsi/models/data_object_other_standard_column_unit'
require 'oci/opsi/models/data_object_power_column_unit'
require 'oci/opsi/models/data_object_query'
require 'oci/opsi/models/data_object_query_time_filters'
require 'oci/opsi/models/data_object_rate_column_unit'
require 'oci/opsi/models/data_object_standard_query'
require 'oci/opsi/models/data_object_temperature_column_unit'
require 'oci/opsi/models/data_object_templatized_query'
require 'oci/opsi/models/data_object_time_column_unit'
require 'oci/opsi/models/data_object_type'
require 'oci/opsi/models/database'
require 'oci/opsi/models/database_configuration_collection'
require 'oci/opsi/models/database_configuration_metric_group'
require 'oci/opsi/models/database_configuration_summary'
require 'oci/opsi/models/database_details'
require 'oci/opsi/models/database_entity_source'
require 'oci/opsi/models/database_entity_source_all'
require 'oci/opsi/models/database_insight'
require 'oci/opsi/models/database_insight_summary'
require 'oci/opsi/models/database_insights'
require 'oci/opsi/models/database_insights_collection'
require 'oci/opsi/models/database_insights_data_object'
require 'oci/opsi/models/database_insights_data_object_summary'
require 'oci/opsi/models/database_parameter_type_details'
require 'oci/opsi/models/disk_group'
require 'oci/opsi/models/disk_group_details'
require 'oci/opsi/models/download_operations_insights_warehouse_wallet_details'
require 'oci/opsi/models/em_managed_external_database_configuration_summary'
require 'oci/opsi/models/em_managed_external_database_insight'
require 'oci/opsi/models/em_managed_external_database_insight_summary'
require 'oci/opsi/models/em_managed_external_exadata_insight'
require 'oci/opsi/models/em_managed_external_exadata_insight_summary'
require 'oci/opsi/models/em_managed_external_host_configuration_summary'
require 'oci/opsi/models/em_managed_external_host_insight'
require 'oci/opsi/models/em_managed_external_host_insight_summary'
require 'oci/opsi/models/enable_autonomous_database_insight_advanced_features_details'
require 'oci/opsi/models/enable_database_insight_details'
require 'oci/opsi/models/enable_em_managed_external_database_insight_details'
require 'oci/opsi/models/enable_em_managed_external_exadata_insight_details'
require 'oci/opsi/models/enable_em_managed_external_host_insight_details'
require 'oci/opsi/models/enable_exadata_insight_details'
require 'oci/opsi/models/enable_host_insight_details'
require 'oci/opsi/models/enable_macs_managed_cloud_host_insight_details'
require 'oci/opsi/models/enable_macs_managed_external_host_insight_details'
require 'oci/opsi/models/enable_pe_comanaged_database_insight_details'
require 'oci/opsi/models/enable_pe_comanaged_exadata_insight_details'
require 'oci/opsi/models/enterprise_manager_bridge'
require 'oci/opsi/models/enterprise_manager_bridge_collection'
require 'oci/opsi/models/enterprise_manager_bridge_summary'
require 'oci/opsi/models/enterprise_manager_bridges'
require 'oci/opsi/models/exadata_configuration_collection'
require 'oci/opsi/models/exadata_configuration_summary'
require 'oci/opsi/models/exadata_database_machine_configuration_summary'
require 'oci/opsi/models/exadata_database_statistics_summary'
require 'oci/opsi/models/exadata_details'
require 'oci/opsi/models/exadata_diskgroup_statistics_summary'
require 'oci/opsi/models/exadata_entity_source'
require 'oci/opsi/models/exadata_exacs_configuration_summary'
require 'oci/opsi/models/exadata_host_statistics_summary'
require 'oci/opsi/models/exadata_insight'
require 'oci/opsi/models/exadata_insight_lifecycle_state'
require 'oci/opsi/models/exadata_insight_resource_capacity_trend_aggregation'
require 'oci/opsi/models/exadata_insight_resource_capacity_trend_summary'
require 'oci/opsi/models/exadata_insight_resource_forecast_trend_summary'
require 'oci/opsi/models/exadata_insight_resource_insight_utilization_item'
require 'oci/opsi/models/exadata_insight_resource_statistics'
require 'oci/opsi/models/exadata_insight_resource_statistics_aggregation'
require 'oci/opsi/models/exadata_insight_summary'
require 'oci/opsi/models/exadata_insight_summary_collection'
require 'oci/opsi/models/exadata_insights'
require 'oci/opsi/models/exadata_insights_data_object'
require 'oci/opsi/models/exadata_insights_data_object_summary'
require 'oci/opsi/models/exadata_member_collection'
require 'oci/opsi/models/exadata_member_summary'
require 'oci/opsi/models/exadata_rack_type'
require 'oci/opsi/models/exadata_resource_type'
require 'oci/opsi/models/exadata_storage_server_statistics_summary'
require 'oci/opsi/models/exadata_type'
require 'oci/opsi/models/historical_data_item'
require 'oci/opsi/models/host'
require 'oci/opsi/models/host_configuration_collection'
require 'oci/opsi/models/host_configuration_metric_group'
require 'oci/opsi/models/host_configuration_summary'
require 'oci/opsi/models/host_cpu_hardware_configuration'
require 'oci/opsi/models/host_cpu_statistics'
require 'oci/opsi/models/host_cpu_usage'
require 'oci/opsi/models/host_details'
require 'oci/opsi/models/host_entities'
require 'oci/opsi/models/host_entity_source'
require 'oci/opsi/models/host_filesystem_configuration'
require 'oci/opsi/models/host_filesystem_usage'
require 'oci/opsi/models/host_hardware_configuration'
require 'oci/opsi/models/host_importable_agent_entity_summary'
require 'oci/opsi/models/host_insight'
require 'oci/opsi/models/host_insight_resource_statistics_aggregation'
require 'oci/opsi/models/host_insight_summary'
require 'oci/opsi/models/host_insight_summary_collection'
require 'oci/opsi/models/host_insights'
require 'oci/opsi/models/host_insights_data_object'
require 'oci/opsi/models/host_insights_data_object_summary'
require 'oci/opsi/models/host_instance_map'
require 'oci/opsi/models/host_memory_configuration'
require 'oci/opsi/models/host_memory_statistics'
require 'oci/opsi/models/host_memory_usage'
require 'oci/opsi/models/host_network_activity_summary'
require 'oci/opsi/models/host_network_configuration'
require 'oci/opsi/models/host_network_statistics'
require 'oci/opsi/models/host_performance_metric_group'
require 'oci/opsi/models/host_product'
require 'oci/opsi/models/host_resource_allocation'
require 'oci/opsi/models/host_resource_capacity_trend_aggregation'
require 'oci/opsi/models/host_resource_statistics'
require 'oci/opsi/models/host_storage_statistics'
require 'oci/opsi/models/host_top_processes'
require 'oci/opsi/models/hosted_entity_collection'
require 'oci/opsi/models/hosted_entity_summary'
require 'oci/opsi/models/importable_agent_entity_source'
require 'oci/opsi/models/importable_agent_entity_summary'
require 'oci/opsi/models/importable_agent_entity_summary_collection'
require 'oci/opsi/models/importable_compute_entity_summary'
require 'oci/opsi/models/importable_compute_entity_summary_collection'
require 'oci/opsi/models/importable_enterprise_manager_entity'
require 'oci/opsi/models/importable_enterprise_manager_entity_collection'
require 'oci/opsi/models/individual_opsi_data_object_details_in_query'
require 'oci/opsi/models/ingest_addm_reports_details'
require 'oci/opsi/models/ingest_addm_reports_response_details'
require 'oci/opsi/models/ingest_database_configuration_details'
require 'oci/opsi/models/ingest_database_configuration_response_details'
require 'oci/opsi/models/ingest_host_configuration_details'
require 'oci/opsi/models/ingest_host_configuration_response_details'
require 'oci/opsi/models/ingest_host_metrics_details'
require 'oci/opsi/models/ingest_host_metrics_response_details'
require 'oci/opsi/models/ingest_my_sql_sql_text_details'
require 'oci/opsi/models/ingest_my_sql_sql_text_response_details'
require 'oci/opsi/models/ingest_sql_bucket_details'
require 'oci/opsi/models/ingest_sql_bucket_response_details'
require 'oci/opsi/models/ingest_sql_plan_lines_details'
require 'oci/opsi/models/ingest_sql_plan_lines_response_details'
require 'oci/opsi/models/ingest_sql_stats_details'
require 'oci/opsi/models/ingest_sql_stats_response_details'
require 'oci/opsi/models/ingest_sql_text_details'
require 'oci/opsi/models/ingest_sql_text_response_details'
require 'oci/opsi/models/instance_metrics'
require 'oci/opsi/models/lifecycle_state'
require 'oci/opsi/models/list_objects'
require 'oci/opsi/models/macs_managed_cloud_host_configuration_summary'
require 'oci/opsi/models/macs_managed_cloud_host_insight'
require 'oci/opsi/models/macs_managed_cloud_host_insight_summary'
require 'oci/opsi/models/macs_managed_external_database_configuration_summary'
require 'oci/opsi/models/macs_managed_external_database_insight'
require 'oci/opsi/models/macs_managed_external_database_insight_summary'
require 'oci/opsi/models/macs_managed_external_host_configuration_summary'
require 'oci/opsi/models/macs_managed_external_host_insight'
require 'oci/opsi/models/macs_managed_external_host_insight_summary'
require 'oci/opsi/models/my_sql_sql_text'
require 'oci/opsi/models/network_usage_trend'
require 'oci/opsi/models/network_usage_trend_aggregation'
require 'oci/opsi/models/news_content_types'
require 'oci/opsi/models/news_content_types_resource'
require 'oci/opsi/models/news_frequency'
require 'oci/opsi/models/news_locale'
require 'oci/opsi/models/news_report'
require 'oci/opsi/models/news_report_collection'
require 'oci/opsi/models/news_report_summary'
require 'oci/opsi/models/news_reports'
require 'oci/opsi/models/object_summary'
require 'oci/opsi/models/operation_status'
require 'oci/opsi/models/operation_type'
require 'oci/opsi/models/operations_insights_private_endpoint'
require 'oci/opsi/models/operations_insights_private_endpoint_collection'
require 'oci/opsi/models/operations_insights_private_endpoint_lifecycle_state'
require 'oci/opsi/models/operations_insights_private_endpoint_summary'
require 'oci/opsi/models/operations_insights_warehouse'
require 'oci/opsi/models/operations_insights_warehouse_lifecycle_state'
require 'oci/opsi/models/operations_insights_warehouse_summary'
require 'oci/opsi/models/operations_insights_warehouse_summary_collection'
require 'oci/opsi/models/operations_insights_warehouse_user'
require 'oci/opsi/models/operations_insights_warehouse_user_lifecycle_state'
require 'oci/opsi/models/operations_insights_warehouse_user_summary'
require 'oci/opsi/models/operations_insights_warehouse_user_summary_collection'
require 'oci/opsi/models/operations_insights_warehouse_users'
require 'oci/opsi/models/operations_insights_warehouses'
require 'oci/opsi/models/opsi_configuration'
require 'oci/opsi/models/opsi_configuration_basic_configuration_item_summary'
require 'oci/opsi/models/opsi_configuration_configuration_item_summary'
require 'oci/opsi/models/opsi_configuration_lifecycle_state'
require 'oci/opsi/models/opsi_configuration_summary'
require 'oci/opsi/models/opsi_configuration_type'
require 'oci/opsi/models/opsi_configurations'
require 'oci/opsi/models/opsi_configurations_collection'
require 'oci/opsi/models/opsi_data_object'
require 'oci/opsi/models/opsi_data_object_details_in_query'
require 'oci/opsi/models/opsi_data_object_details_target'
require 'oci/opsi/models/opsi_data_object_query_param'
require 'oci/opsi/models/opsi_data_object_summary'
require 'oci/opsi/models/opsi_data_object_supported_query_param'
require 'oci/opsi/models/opsi_data_object_type'
require 'oci/opsi/models/opsi_data_object_type_opsi_data_object_details_in_query'
require 'oci/opsi/models/opsi_data_objects'
require 'oci/opsi/models/opsi_data_objects_collection'
require 'oci/opsi/models/opsi_ux_configuration'
require 'oci/opsi/models/opsi_ux_configuration_summary'
require 'oci/opsi/models/opsi_warehouse_data_objects'
require 'oci/opsi/models/pe_comanaged_database_connection_details'
require 'oci/opsi/models/pe_comanaged_database_host_details'
require 'oci/opsi/models/pe_comanaged_database_insight'
require 'oci/opsi/models/pe_comanaged_database_insight_summary'
require 'oci/opsi/models/pe_comanaged_exadata_insight'
require 'oci/opsi/models/pe_comanaged_exadata_insight_summary'
require 'oci/opsi/models/pe_comanaged_host_configuration_summary'
require 'oci/opsi/models/pe_comanaged_host_insight'
require 'oci/opsi/models/pe_comanaged_host_insight_summary'
require 'oci/opsi/models/pe_comanaged_managed_external_database_configuration_summary'
require 'oci/opsi/models/projected_data_item'
require 'oci/opsi/models/query_data_object_json_result_set_rows_collection'
require 'oci/opsi/models/query_data_object_result_set_column_metadata'
require 'oci/opsi/models/query_data_object_result_set_rows_collection'
require 'oci/opsi/models/query_opsi_data_object_data_details'
require 'oci/opsi/models/query_warehouse_data_object_data_details'
require 'oci/opsi/models/related_object_type_details'
require 'oci/opsi/models/resource_capacity_trend_aggregation'
require 'oci/opsi/models/resource_filters'
require 'oci/opsi/models/resource_insight_current_utilization'
require 'oci/opsi/models/resource_insight_projected_utilization'
require 'oci/opsi/models/resource_insight_projected_utilization_item'
require 'oci/opsi/models/resource_statistics'
require 'oci/opsi/models/resource_statistics_aggregation'
require 'oci/opsi/models/resource_status'
require 'oci/opsi/models/resource_usage_summary'
require 'oci/opsi/models/resource_usage_trend_aggregation'
require 'oci/opsi/models/schema_object_type_details'
require 'oci/opsi/models/sort_order'
require 'oci/opsi/models/sql_bucket'
require 'oci/opsi/models/sql_insight_aggregation'
require 'oci/opsi/models/sql_insight_aggregation_collection'
require 'oci/opsi/models/sql_insight_thresholds'
require 'oci/opsi/models/sql_inventory'
require 'oci/opsi/models/sql_plan_collection'
require 'oci/opsi/models/sql_plan_insight_aggregation'
require 'oci/opsi/models/sql_plan_insight_aggregation_collection'
require 'oci/opsi/models/sql_plan_insights'
require 'oci/opsi/models/sql_plan_line'
require 'oci/opsi/models/sql_plan_summary'
require 'oci/opsi/models/sql_response_time_distribution_aggregation'
require 'oci/opsi/models/sql_response_time_distribution_aggregation_collection'
require 'oci/opsi/models/sql_search_collection'
require 'oci/opsi/models/sql_search_summary'
require 'oci/opsi/models/sql_statistic_aggregation'
require 'oci/opsi/models/sql_statistic_aggregation_collection'
require 'oci/opsi/models/sql_statistics'
require 'oci/opsi/models/sql_statistics_time_series'
require 'oci/opsi/models/sql_statistics_time_series_aggregation'
require 'oci/opsi/models/sql_statistics_time_series_aggregation_collection'
require 'oci/opsi/models/sql_statistics_time_series_by_plan_aggregation'
require 'oci/opsi/models/sql_statistics_time_series_by_plan_aggregation_collection'
require 'oci/opsi/models/sql_stats'
require 'oci/opsi/models/sql_text'
require 'oci/opsi/models/sql_text_collection'
require 'oci/opsi/models/sql_text_summary'
require 'oci/opsi/models/sql_type_details'
require 'oci/opsi/models/storage_server'
require 'oci/opsi/models/storage_server_details'
require 'oci/opsi/models/storage_tier'
require 'oci/opsi/models/storage_usage_trend'
require 'oci/opsi/models/storage_usage_trend_aggregation'
require 'oci/opsi/models/summarize_awr_sources_summaries_collection'
require 'oci/opsi/models/summarize_database_insight_resource_capacity_trend_aggregation_collection'
require 'oci/opsi/models/summarize_database_insight_resource_forecast_trend_aggregation'
require 'oci/opsi/models/summarize_database_insight_resource_statistics_aggregation_collection'
require 'oci/opsi/models/summarize_database_insight_resource_usage_aggregation'
require 'oci/opsi/models/summarize_database_insight_resource_usage_trend_aggregation_collection'
require 'oci/opsi/models/summarize_database_insight_resource_utilization_insight_aggregation'
require 'oci/opsi/models/summarize_database_insight_tablespace_usage_trend_aggregation_collection'
require 'oci/opsi/models/summarize_exadata_insight_resource_capacity_trend_aggregation'
require 'oci/opsi/models/summarize_exadata_insight_resource_capacity_trend_collection'
require 'oci/opsi/models/summarize_exadata_insight_resource_forecast_trend_aggregation'
require 'oci/opsi/models/summarize_exadata_insight_resource_forecast_trend_collection'
require 'oci/opsi/models/summarize_exadata_insight_resource_statistics_aggregation_collection'
require 'oci/opsi/models/summarize_exadata_insight_resource_usage_aggregation'
require 'oci/opsi/models/summarize_exadata_insight_resource_usage_collection'
require 'oci/opsi/models/summarize_exadata_insight_resource_utilization_insight_aggregation'
require 'oci/opsi/models/summarize_host_insight_network_usage_trend_aggregation_collection'
require 'oci/opsi/models/summarize_host_insight_resource_capacity_trend_aggregation_collection'
require 'oci/opsi/models/summarize_host_insight_resource_forecast_trend_aggregation'
require 'oci/opsi/models/summarize_host_insight_resource_statistics_aggregation_collection'
require 'oci/opsi/models/summarize_host_insight_resource_usage_aggregation'
require 'oci/opsi/models/summarize_host_insight_resource_usage_trend_aggregation_collection'
require 'oci/opsi/models/summarize_host_insight_resource_utilization_insight_aggregation'
require 'oci/opsi/models/summarize_host_insight_storage_usage_trend_aggregation_collection'
require 'oci/opsi/models/summarize_host_insights_top_processes_usage_collection'
require 'oci/opsi/models/summarize_host_insights_top_processes_usage_trend_collection'
require 'oci/opsi/models/summarize_operations_insights_warehouse_resource_usage_aggregation'
require 'oci/opsi/models/summary_statistics'
require 'oci/opsi/models/tablespace_usage_trend'
require 'oci/opsi/models/tablespace_usage_trend_aggregation'
require 'oci/opsi/models/top_processes_usage'
require 'oci/opsi/models/top_processes_usage_trend'
require 'oci/opsi/models/top_processes_usage_trend_aggregation'
require 'oci/opsi/models/update_autonomous_database_insight_details'
require 'oci/opsi/models/update_awr_hub_details'
require 'oci/opsi/models/update_awr_hub_source_details'
require 'oci/opsi/models/update_basic_configuration_item_details'
require 'oci/opsi/models/update_configuration_item_details'
require 'oci/opsi/models/update_database_insight_details'
require 'oci/opsi/models/update_em_managed_external_database_insight_details'
require 'oci/opsi/models/update_em_managed_external_exadata_insight_details'
require 'oci/opsi/models/update_em_managed_external_host_insight_details'
require 'oci/opsi/models/update_enterprise_manager_bridge_details'
require 'oci/opsi/models/update_exadata_insight_details'
require 'oci/opsi/models/update_host_insight_details'
require 'oci/opsi/models/update_macs_managed_cloud_host_insight_details'
require 'oci/opsi/models/update_macs_managed_external_database_insight_details'
require 'oci/opsi/models/update_macs_managed_external_host_insight_details'
require 'oci/opsi/models/update_news_report_details'
require 'oci/opsi/models/update_operations_insights_private_endpoint_details'
require 'oci/opsi/models/update_operations_insights_warehouse_details'
require 'oci/opsi/models/update_operations_insights_warehouse_user_details'
require 'oci/opsi/models/update_opsi_configuration_details'
require 'oci/opsi/models/update_opsi_ux_configuration_details'
require 'oci/opsi/models/update_pe_comanaged_database_insight_details'
require 'oci/opsi/models/update_pe_comanaged_exadata_insight_details'
require 'oci/opsi/models/ux_configuration_items_collection'
require 'oci/opsi/models/vm_cluster_summary'
require 'oci/opsi/models/warehouse_data_object_collection'
require 'oci/opsi/models/warehouse_data_object_details'
require 'oci/opsi/models/warehouse_data_object_summary'
require 'oci/opsi/models/warehouse_table_data_object_details'
require 'oci/opsi/models/warehouse_view_data_object_details'
require 'oci/opsi/models/work_request'
require 'oci/opsi/models/work_request_collection'
require 'oci/opsi/models/work_request_error'
require 'oci/opsi/models/work_request_error_collection'
require 'oci/opsi/models/work_request_log_entry'
require 'oci/opsi/models/work_request_log_entry_collection'
require 'oci/opsi/models/work_request_resource'
require 'oci/opsi/models/work_request_resource_metadata_key'
require 'oci/opsi/models/work_requests'

# Require generated clients
require 'oci/opsi/operations_insights_client'
require 'oci/opsi/operations_insights_client_composite_operations'

# Require service utilities
require 'oci/opsi/util'
