# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220915

module OCI
  module Psql
    # Module containing models for requests made to, and responses received from,
    # OCI Psql services
    module Models
    end
  end
end

# Require models
require 'oci/psql/models/action_type'
require 'oci/psql/models/backup'
require 'oci/psql/models/backup_collection'
require 'oci/psql/models/backup_policy'
require 'oci/psql/models/backup_source_details'
require 'oci/psql/models/backup_summary'
require 'oci/psql/models/change_backup_compartment_details'
require 'oci/psql/models/change_configuration_compartment_details'
require 'oci/psql/models/change_db_system_compartment_details'
require 'oci/psql/models/config_overrides'
require 'oci/psql/models/config_params'
require 'oci/psql/models/configuration'
require 'oci/psql/models/configuration_collection'
require 'oci/psql/models/configuration_details'
require 'oci/psql/models/configuration_summary'
require 'oci/psql/models/connection_details'
require 'oci/psql/models/create_backup_details'
require 'oci/psql/models/create_configuration_details'
require 'oci/psql/models/create_db_instance_details'
require 'oci/psql/models/create_db_system_details'
require 'oci/psql/models/credentials'
require 'oci/psql/models/daily_backup_policy'
require 'oci/psql/models/db_configuration_override_collection'
require 'oci/psql/models/db_instance'
require 'oci/psql/models/db_instance_endpoint'
require 'oci/psql/models/db_system'
require 'oci/psql/models/db_system_collection'
require 'oci/psql/models/db_system_details'
require 'oci/psql/models/db_system_summary'
require 'oci/psql/models/default_config_params'
require 'oci/psql/models/default_configuration'
require 'oci/psql/models/default_configuration_collection'
require 'oci/psql/models/default_configuration_details'
require 'oci/psql/models/default_configuration_summary'
require 'oci/psql/models/endpoint'
require 'oci/psql/models/failover_db_system_details'
require 'oci/psql/models/management_policy'
require 'oci/psql/models/management_policy_details'
require 'oci/psql/models/monthly_backup_policy'
require 'oci/psql/models/network_details'
require 'oci/psql/models/none_backup_policy'
require 'oci/psql/models/none_source_details'
require 'oci/psql/models/oci_optimized_storage_details'
require 'oci/psql/models/operation_status'
require 'oci/psql/models/operation_type'
require 'oci/psql/models/password_details'
require 'oci/psql/models/patch_db_system_details'
require 'oci/psql/models/patch_insert_instruction'
require 'oci/psql/models/patch_instruction'
require 'oci/psql/models/patch_merge_instruction'
require 'oci/psql/models/patch_move_instruction'
require 'oci/psql/models/patch_prohibit_instruction'
require 'oci/psql/models/patch_remove_instruction'
require 'oci/psql/models/patch_replace_instruction'
require 'oci/psql/models/patch_require_instruction'
require 'oci/psql/models/plain_text_password_details'
require 'oci/psql/models/primary_db_instance_details'
require 'oci/psql/models/reset_master_user_password_details'
require 'oci/psql/models/restart_db_instance_in_db_system_details'
require 'oci/psql/models/restore_db_system_details'
require 'oci/psql/models/shape_collection'
require 'oci/psql/models/shape_summary'
require 'oci/psql/models/sort_order'
require 'oci/psql/models/source_details'
require 'oci/psql/models/storage_details'
require 'oci/psql/models/update_backup_details'
require 'oci/psql/models/update_configuration_details'
require 'oci/psql/models/update_db_config_params'
require 'oci/psql/models/update_db_system_db_instance_details'
require 'oci/psql/models/update_db_system_details'
require 'oci/psql/models/update_storage_details_params'
require 'oci/psql/models/vault_secret_password_details'
require 'oci/psql/models/weekly_backup_policy'
require 'oci/psql/models/work_request'
require 'oci/psql/models/work_request_error'
require 'oci/psql/models/work_request_error_collection'
require 'oci/psql/models/work_request_log_entry'
require 'oci/psql/models/work_request_log_entry_collection'
require 'oci/psql/models/work_request_resource'
require 'oci/psql/models/work_request_resource_metadata_key'
require 'oci/psql/models/work_request_summary'
require 'oci/psql/models/work_request_summary_collection'

# Require generated clients
require 'oci/psql/postgresql_client'
require 'oci/psql/postgresql_client_composite_operations'

# Require service utilities
require 'oci/psql/util'
