# Copyright (c) 2016, 2023, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210630
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Summary of vulnerability audit.
  class Devops::Models::VulnerabilityAuditSummary
    # **[Required]** The OCID of the vulnerability audit.
    # @return [String]
    attr_accessor :vulnerability_audit_id

    # Commit hash used while retrieving the pom file for vulnerabilityAudit.
    # @return [String]
    attr_accessor :commit_hash

    # **[Required]** Build stage OCID where scan was configured.
    # @return [String]
    attr_accessor :build_stage_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'vulnerability_audit_id': :'vulnerabilityAuditId',
        'commit_hash': :'commitHash',
        'build_stage_id': :'buildStageId'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'vulnerability_audit_id': :'String',
        'commit_hash': :'String',
        'build_stage_id': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :vulnerability_audit_id The value to assign to the {#vulnerability_audit_id} property
    # @option attributes [String] :commit_hash The value to assign to the {#commit_hash} property
    # @option attributes [String] :build_stage_id The value to assign to the {#build_stage_id} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.vulnerability_audit_id = attributes[:'vulnerabilityAuditId'] if attributes[:'vulnerabilityAuditId']

      raise 'You cannot provide both :vulnerabilityAuditId and :vulnerability_audit_id' if attributes.key?(:'vulnerabilityAuditId') && attributes.key?(:'vulnerability_audit_id')

      self.vulnerability_audit_id = attributes[:'vulnerability_audit_id'] if attributes[:'vulnerability_audit_id']

      self.commit_hash = attributes[:'commitHash'] if attributes[:'commitHash']

      raise 'You cannot provide both :commitHash and :commit_hash' if attributes.key?(:'commitHash') && attributes.key?(:'commit_hash')

      self.commit_hash = attributes[:'commit_hash'] if attributes[:'commit_hash']

      self.build_stage_id = attributes[:'buildStageId'] if attributes[:'buildStageId']

      raise 'You cannot provide both :buildStageId and :build_stage_id' if attributes.key?(:'buildStageId') && attributes.key?(:'build_stage_id')

      self.build_stage_id = attributes[:'build_stage_id'] if attributes[:'build_stage_id']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        vulnerability_audit_id == other.vulnerability_audit_id &&
        commit_hash == other.commit_hash &&
        build_stage_id == other.build_stage_id
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [vulnerability_audit_id, commit_hash, build_stage_id].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
